--
--
--
--    filename:	dbstruktur-versionswechsel.sql
--
--    version:	1.3
--
--    Änderungen des Datenbankmodells Datenbankmodells 'Virtuelles Fahrzeug' - vf bis zum Versionswechsel
--
--
--
-- ----------------------------------------------------------------------------------------
--
--
--    Copyright (C) 2007-2011  Michael Bellair
--
--    This program is free software: you can redistribute it and/or modify
--    it under the terms of the GNU General Public License as published by
--    the Free Software Foundation, either version 3 of the License, or
--    (at your option) any later version.
--
--    This program is distributed in the hope that it will be useful,
--    but WITHOUT ANY WARRANTY; without even the implied warranty of
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--    GNU General Public License for more details.
--
--    You should have received a copy of the GNU General Public License
--    along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
--    Michael Bellair
--    Sportplatzstrasse 11
--    01259 Dresden
--
--    E-Mail:	bellair@freenet.de
--    homepage:	http://vf.michaelbellair.de/index.html
--
--
-- ----------------------------------------------------------------------------------------
--



--
-- -----------------------------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------------------------
--

-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------
--				----------------------------------------------------------
-- 	tl.erzeuge__DBModell()	----------------------------------------------------------
--				----------------------------------------------------------
-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------
CREATE OR REPLACE FUNCTION tl.erzeuge__DBModell( OUT tldateiinhalt varchar ) AS
$$
DECLARE
--------------------------------------------------------------------------------
-- Konstanten
--------------------------------------------------------------------------------
--
-- Datenbankname (db[1]), Titel (db[2]), Version (db[3])
--
db varchar[] := ARRAY['vf', 'Virtuelles Fahrzeug', '1.3'];

--------------------------------------------------------------------------------
-- lokale Variablen
--------------------------------------------------------------------------------
--
-- temporäre Ganzzahlvariablen
--
tmpInteger_1 integer;
tmpInteger_2 integer;
tmpInteger_3 integer;
tmpInteger_4 integer;
tmpInteger_5 integer;
tmpInteger_6 integer;
tmpInteger_7 integer;
--
-- temporäre Textvariablen
--
tmpVarchar_1 varchar;
tmpVarchar_2 varchar;
tmpVarchar_3 varchar;
tmpVarchar_4 varchar;
tmpVarchar_5 varchar;
tmpVarchar_6 varchar;
tmpVarchar_7 varchar;
--
-- Liste temporärer Textvariablen
--
tmpVarcharListe_1 varchar[] := ARRAY[''];
tmpVarcharListe_2 varchar[] := ARRAY[''];
tmpVarcharListe_3 varchar[] := ARRAY[''];
--
-- FOR-LOOP-Schleifenvariablen
--
zeile_1 RECORD;
zeile_2 RECORD;




BEGIN

--------------------------------------------------------------------------------
--			--------------------------------------------------------
-- 1.)	Statischer Teil	--------------------------------------------------------
--			--------------------------------------------------------
--------------------------------------------------------------------------------
tldateiinhalt := E'% vf-dbdoku.tex
%
% Dokument erzeugen siehe ''makefile''
%
\\documentclass{gnufdlartikelA4}
%\\makeglossary
\\makeglossaries



% ---------------------------------------------------------------------------------------
% ---------------------------------------------------------------------------------------
% --								-------------------------
% --	glossary-Befehle (Stichwortverzeichnis) umdefinieren	-------------------------
% --								-------------------------
% ---------------------------------------------------------------------------------------
% ---------------------------------------------------------------------------------------
%
\\renewcommand{\\glossaryname}{Verzeichnis der Tabellenspalten und Begriffe}
\\renewcommand{\\entryname}{Tabellenspalte / Begriff}
\\renewcommand{\\descriptionname}{Beschreibung}



% ---------------------------------------------------------------------------------------
% ---------------------------------------------------------------------------------------
% --								-------------------------
% --	\\dbGlossary{spaltenname}{schema.tabelle}{beschreibung}	-------------------------
% --								-------------------------
% ---------------------------------------------------------------------------------------
% ---------------------------------------------------------------------------------------
%
\\newcommand{\\dbGlossary}[3]{%
  \\texttt{#1}%
  \\ifthenelse{\\equal{#2}{}}%
  {\\glossary{name=\\texttt{#1}, description={#3},sort=#1}}%
  {\\glossary{name=\\texttt{#2#1}, description={#3},sort=#2#1}}%
}



% ---------------------------------------------------------------------------------------
% ---------------------------------------------------------------------------------------
% --					-------------------------------------------------
% --	Tabellenhierarchie darstellen	-------------------------------------------------
% --					-------------------------------------------------
% ---------------------------------------------------------------------------------------
% ---------------------------------------------------------------------------------------
\\usepackage{lscape}
\\usepackage{tikz}
%
% 
%	Breite und Höhe aus >gnufdlartikelA4.cls<
%
%	Breite:					240mm ((\\textHoehe+6) : 3 = Ganzzahl)
%	Höhe:					160mm (\\textBreite - 8mm zum Vermeiden des 
%							Seitenumbruches)
%
%	Zeichenbereichbreite der Ebenen:	240mm : 3 = 80mm
%
%	max. Länge der Spaltennamen
%	(11pt \\scriptsize, 30 Zeichen):		46mm
%
%	max. Länge der Basisdatentypen
%	(11pt \\scriptsize, 8 Zeichen):		14mm
%
%	max. Länge der Verweise
%	(11pt \\scriptsize, 3 Zeichen)
%
%	Linke obere Ecke (x,y)mm
%		Ebene 1:			(33, 157.5)
%		Ebene 2:			(113, 157.5)
%		Ebene 3:			(193, 157.5)
%
%
%	||	          33			  113			  193
%	||  15  |	(46+14)	| 5 ||  15  |	(46+14)	| 5 ||  15  |	(46+14)	| 5 ||
%	-
%	-
% 157.5	5 LEERZEILE
%	-
% 152.5	5 schema.tabellenname
%	-
% 147.5	5 Tabellenspalte / Datentyp
%	-
% ...	5 ...
%	-
%	5 Tabellenspalte / Datentyp
%	-
%	-
%	5 LEERZEILE
%	-
%	5 schema.tabellenname
%	-
%	5 Tabellenspalte / Datentyp
%	-
%	5 ...
%


% ---------------------------------------------------------------------------------------
% --				---------------------------------------------------------
% --	seiteTabHierarchie	---------------------------------------------------------
% --				---------------------------------------------------------
% ---------------------------------------------------------------------------------------
%
\\newenvironment{seiteTabHierarchie}[1]{%
  \\begin{landscape}
    \\subsection{Tabellenhierarchie der Ebenen #1}
    \\begin{tikzpicture}

      %
      % Alle Texte werden in Schreibmaschinenschrift dargestellt
      % Der Abstand zum linken und rechten Boxrand ist Null
      %
      \\tikzstyle{every node}=[font=\\ttfamily\\scriptsize, inner xsep=0mm]

      %
      % Rahmen um die Grafik zeichnen und somit die Maximalgröße unabhängig von der Anzahl und 
      % Position der dargestellten Tabellen festlegen (Breite, Höhe verwenden)
      %
      \\draw (0,0) rectangle (240mm,160mm);
}{%
    \\end{tikzpicture}%
  \\end{landscape}
}


% ---------------------------------------------------------------------------------------
% --				---------------------------------------------------------
% --	Längen / Zähler		---------------------------------------------------------
% --				---------------------------------------------------------
% ---------------------------------------------------------------------------------------
%
\\newcounter{cEins}



% ---------------------------------------------------------------------------------------
% --									-----------------
% --	\\zeichneTabelle{lfdNr Zielspalte}{Nodename Zielspalte}{x}{y}	-----------------
% --		{schema.tabelle}{spName, dTyp, Nodename}		-----------------
% --									-----------------
% ---------------------------------------------------------------------------------------
%
\\newcommand{\\zeichneTabelle}[6]{%

  %
  % Zähler  setzen
  %
  \\setcounter{cEins}{1}

  %
  % Tabellenname
  %
  % befindet sich 5mm unterhalb der übergebenen y-Koordinate
  %
  \\draw	(#3, #4 - 5mm ) node[minimum height=5mm,text width=42mm, inner xsep=2mm]{#5};

  %
  % Spalten
  %
  % Syntax des \\foreach - Befehls aus 
  % Kapitel 15 "Repeating Things: The Foreach Statement" S. 134 
  % des Dokumentes "TikZ and pgf --- Manual for Version 1.01"
  %
  \\foreach \\spName / \\dTyp / \\nodeName in {#6} {%

    %
    % Spalten zeichnen
    %
    % Nodename:
    %	schema-tabelle-spalte
    %
    \\ifthenelse{\\value{cEins} = 1}{%

      %
      % die erste Spalte ist stets >id< und ist Zielpunkt der Verbindung
      %
      \\draw %
      ( #3, #4 - 5mm * \\value{cEins} - 5mm ) %
      node[minimum height=5mm, minimum width=46mm, draw, fill=white]{\\spName}
      ( [xshift=30mm] #3, #4 - 5mm * \\value{cEins} - 5mm ) %
      node[minimum height=5mm, minimum width=14mm, draw, fill=white, name = \\nodeName]{\\dTyp};

      %
      % Verweis auf Zielspalte (id) setzen
      %
      \\ifthenelse{\\equal{#1}{}}{}{%

	\\zeichneVerbindung{#1}{#2}{}{z}
	
      }

    }{%

      %
      % die restlichen Spalten können Startpunkt einer Verbindung sein
      %
      \\draw %
      ( #3, #4 - 5mm * \\value{cEins} - 5mm ) %
      node[minimum height=5mm, minimum width=46mm, draw, fill=white, name = \\nodeName]{\\spName}
      ( [xshift=30mm] #3, #4 - 5mm * \\value{cEins} - 5mm ) %
      node[minimum height=5mm, minimum width=14mm, draw, fill=white]{\\dTyp};

    }

    %
    % den Wert des Zählers um Eins erhöhen
    %
    \\stepcounter{cEins}
  }
}


% ---------------------------------------------------------------------------------------
% --									-----------------
% --	\\zeichneVerbindung{lfdNr Zielspalte}{Nodename Zielspalte}	-----------------
% --				{Nodename Startspalte}{istVerweis}	-----------------
% --									-----------------
% --	istVerweis: leer ... Verbindung zeichnen			-----------------
% --	istVerweis: z    ... Verweis auf Zielspalte			-----------------
% --	istVerweis: s    ... Verweis aus Startspalte			-----------------
% --									-----------------
% ---------------------------------------------------------------------------------------
%
\\newcommand{\\zeichneVerbindung}[4]{%

  %
  % Farbe (Hintergrundfüllung)
  % siehe "11.1 Nodes and Their Shapes" aus "TikZ and pgf --- Manual for Version 1.01"
  %
  % Pfeilspitzen
  % siehe "24.5 Predefined Arrow Tip Kinds" aus "TikZ and pgf --- Manual for Version 1.01"
  %
  % Linienstärken
  % siehe "10.2.1 Graphic Parameters: Line Width, Line Cap, and Line Join" aus 
  %			"TikZ and pgf --- Manual for Version 1.01"
  %
  % Koordinaten
  % siehe "8.1 Coordinates and Coordinate Options"
  % siehe "8.3 Polar Coordinates"
  % siehe "8.5.1 Named Anchor Coordinates"
  %			aus "TikZ and pgf --- Manual for Version 1.01"
  %

  %
  % Verbindung zeichnen
  %
  \\ifthenelse{\\equal{#4}{}}{%

    \\draw[latex-] (#2.east) -- ++(2ex, 0mm) -- ([xshift=-4ex]#3.west) -- (#3.west);

  }{%

    %
    % Verweis in Zielspalte
    %
    \\ifthenelse{\\equal{#4}{z}}{%

      \\draw[latex-] (#2.east) --  ++(2ex, 0mm) -- ++(0mm, 2mm) node[yshift = 1ex, fill=white]{#1};

    }{%

      \\draw[-latex] ([yshift=-0.75ex]#3.west) --  ++(-2ex, 0mm);
      \\draw ([yshift=-0.75ex]#3.west) node[xshift = -2ex, yshift = 1.5ex, fill=white, inner sep=0pt]{#1};

    }

  }

}



% ----------------------------------------------------------------------------------------
% ----------------------------------------------------------------------------------------
%				----------------------------------------------------------
%  Deckblatt und Copyleft	----------------------------------------------------------
%  Zusammenfassung		----------------------------------------------------------
%  Inhaltsverzeichnis		----------------------------------------------------------
%				----------------------------------------------------------
% ----------------------------------------------------------------------------------------
% ----------------------------------------------------------------------------------------
\\begin{document}

%
% Titel, Autor, Ausgabe
%
\\newcommand{\\dbmodellvf}[1]{Datenbankmodell #1"`'
|| db[2]
|| E'"''}
\\TitelAutorAusgabe{\\dbmodellvf{\\\\}\\\\Version '
|| db[3]
|| '}{Michael Bellair}{Ausgabedatum: ' 
|| to_char( current_date, 'YYYY-MM-DD')
|| E'}

%
% Zusammenfassung
%
\\Zusammenfassung{%
Das {\\dbmodellvf{}} wird beschrieben.}

%
% Inhaltsverzeichnis
%
\\Inhaltsverzeichnis



% ----------------------------------------------------------------------------------------
% ----------------------------------------------------------------------------------------
%		--------------------------------------------------------------------------
%  Einleitung	--------------------------------------------------------------------------
%		--------------------------------------------------------------------------
% ----------------------------------------------------------------------------------------
% ----------------------------------------------------------------------------------------
\\cleardoublepage
\\section{Einleitung}

Es wird die Struktur des Datenbankmodells vorgestellt.
Jedem Datenbankschema ist ein Abschnitt zugeordnet. 
Ziel und Zweck des Schemas werden beschrieben.';





--------------------------------------------------------------------------------
--									--------
-- 2.)	Dynamischer Teil - Kommentar zur Datenbank 'vf' auslesen	--------
--									--------
--------------------------------------------------------------------------------
tldateiinhalt := tldateiinhalt || E'


% ----------------------------------------------------------------------------------------
% ----------------------------------------------------------------------------------------
%			------------------------------------------------------------------
%  Das Datenbankmodell	------------------------------------------------------------------
%			------------------------------------------------------------------
% ----------------------------------------------------------------------------------------
% ----------------------------------------------------------------------------------------
\\cleardoublepage
\\section{Das Datenbankmodell}
';
EXECUTE 
	'SELECT 
		shobj_description(
			( SELECT oid FROM pg_database 
			  WHERE pg_database.datname = current_database() LIMIT 1 )
			,''pg_database'')'

INTO tmpVarchar_1;
tldateiinhalt := tldateiinhalt || tmpVarchar_1;



--------------------------------------------------------------------------------
--							------------------------
-- 3.)	Dynamischer Teil - Darstellung der Schemas	------------------------
--							------------------------
--------------------------------------------------------------------------------
FOR zeile_1 IN

	SELECT
		pg_namespace.nspname
		, pg_description.description
	FROM
		pg_description
		, pg_namespace
	WHERE
		pg_description.objoid = pg_namespace.oid
	AND
		NOT ( pg_namespace.nspname LIKE( 'pg_%' )
		OR pg_namespace.nspname LIKE( 'public' ) )
	ORDER BY
		pg_namespace.nspname
LOOP

	--
	-- Überschrift und Beschreibung zusammenstellen
	--
	tldateiinhalt := tldateiinhalt || E'



% ----------------------------------------------------------------------------------------
% ----------------------------------------------------------------------------------------
%			------------------------------------------------------------------
%  ' || zeile_1.nspname || E'		------------------------------------------------------------------
%			------------------------------------------------------------------
% ----------------------------------------------------------------------------------------
% ----------------------------------------------------------------------------------------
\\newpage
\\section{' || zeile_1.nspname || E'}

%
% Beschreibung des Schemas
%
\\noindent ' 
|| zeile_1.description;


	--
	-- Tabellenhierarchie darstellen -
	-- Die nach Ebene sortierten Tabellen durchlaufen
	--
	tmpVarcharListe_1 := NULL; -- Inhalt der Darstellungsblätter aufnehmen
	tmpVarcharListe_2 := NULL; -- die im Darstellungsblatt gültigen Verbindungen aufnehmen

	tmpVarchar_1 := '';	-- aktueller Tabellenname
	tmpVarchar_2 := '';	-- aktuelle Ebenenüberschriften

	tmpInteger_1 := 0;	-- aktuelle Ebene
	tmpInteger_2 := 0;	-- lfd. Nr. des Darstellungsblattes der aktuellen Ebene
	tmpInteger_4 := 0;	-- Nr.des ersten Darstellungsblattes des aktuellen Ebenenblockes
	tmpInteger_3 := 0;	-- aktuelle y-Koordinate
	tmpInteger_5 := 0;	-- Spaltenanzahl der vorhergehenden Tabelle
	tmpInteger_6 := 0;	-- Ebenenüberschrift

	FOR zeile_2 IN

		SELECT 
			replace( spziel, '.', '-' ) AS zielnodename
 			, ( CAST( ebene AS integer ) % 3 = 0 ) AS ebwechsel
 			, ( CAST( ebene AS integer ) % 3 ) AS modulo
			, CAST( ebene AS integer ) AS ebene
			, spanz
 			, tl.erzeuge__TLdbGlossary(
				intern.gib__stsname( 'schtab', spname )
				, ''
				, beschr_tabelle ) AS tname
			, tl.erzeuge__TLdbGlossary(
				intern.gib__stsname( 'sp', spname )
				, intern.gib__stsname( 'schtab', spname ) || '.'
				, beschr_spalte ) AS spaltenname
			, tl.erzeuge__TLZk( CAST( dtyp AS text ) ) AS dtyp
			, replace( replace( spname, '.', '-' ), '_', '-' ) AS nodename
		FROM 
			intern.gib__Liste_Tabellenpositionen( CAST( zeile_1.nspname AS text ) ) LEFT OUTER JOIN intern.zeige__tabspInformationen ON ( intern.gib__stsname( 'schtab', spname ) = tabname ) LEFT OUTER JOIN intern.zeige__fremdschluessel ON ( spname = spstart ) LEFT OUTER JOIN intern.zeige__spaltenanzahl gibspanz ON ( gibspanz.tabname = intern.gib__stsname( 'schtab', spname ) )
		ORDER BY
		--	Ebenenreihenfolge
		--		3	6	9	...
		--		1	4	7	...
		--		2	5	8	...
		CASE WHEN( CAST( ebene AS integer ) % 3 = 0 ) 
			THEN ( CAST( ebene AS integer ) - 3 ) 
			ELSE ( CAST( ebene AS integer ) ) 
		END
		, intern.gib__stsname( 'schtab', spname )
		, spnr
--
-- ggf. später Bereinigen, die Reihenfolge 3-1-2 ist nicht mehr notwendig
--
--		ebene

	LOOP

--
-- Test
--
--RAISE NOTICE '%', zeile_2.tname || '.' || zeile_2.spaltenname;


		--
		-- beim Tabellenwechsel >\zeichneTabelle{...}< übernehmen
		--
		IF(
		    NOT( tmpVarchar_1 = zeile_2.tname )
		  )
		THEN

			--
			-- aktuellen Tabellennamen übernehmen
			-- (zum Erkennen des nächsten Tabellenwechsels)
			--
			tmpVarchar_1 := zeile_2.tname;

			--
			-- y-Koordinate auf nächste Zeile setzen
			--
			tmpInteger_3 := tmpInteger_3 - ( ( tmpInteger_5 + 2 ) * 5 );

			--
			-- Ebenenüberschrift hochzählen
			--	- beim ersten Durchlauf
			-- 	- am Ebenenblockwechsel
			--
			IF(
				( tmpVarcharListe_1 IS NULL )
				OR ( zeile_2.ebwechsel )
			  )
			THEN

				tmpInteger_6 := tmpInteger_6 + 1;
				tmpVarchar_2 := CAST( tmpInteger_6 AS text )
							|| ' --- '
							|| CAST( tmpInteger_6 + 2 AS text );

			END IF;

			--
			-- Neues Darstellungsblatt anlegen
			--	-> beim ersten Durchlauf bzw. am Ebenenblockwechsel 
			--	   (Übergang Ebenen (6,4,5), (9,7,8), ...)
			--	-> letzte Tabellenspalte paßt nicht mehr auf das 
			--	   Darstellungsblatt bei y < 7.5 mm (innerhalb einer Ebene)
			--
 			IF(
				( tmpVarcharListe_1 IS NULL )
				OR ( ( tmpInteger_1 != zeile_2.ebene ) 
					AND ( zeile_2.ebwechsel ) )
 				OR ( ( tmpInteger_1 = zeile_2.ebene )
				    AND ( tmpInteger_3 - ( ( zeile_2.spanz + 1 ) * 5 ) < 7.5 ) )
 			  )
 			THEN

				--
				-- Neues Darstellungsblatt anlegen, wenn ...
				-- 	-> ... die erste Tabelle übernommen wird
				--
				IF(	
					array_dims( tmpVarcharListe_1 ) IS NULL 
				  ) 
				THEN

					tmpVarcharListe_1[1] := '';
					tmpVarcharListe_2 := NULL;
					tmpVarcharListe_2[1] := '';
					tmpInteger_4 := 1;
					tmpInteger_2 := 1;


				--
				-- 	-> ... das Ende der Liste erreicht wurde
				--
				ELSIF(
					tmpInteger_4 = array_upper( tmpVarcharListe_1, 1 )
				  )
				THEN

					tmpVarcharListe_1 := array_append( tmpVarcharListe_1, 
									'' );
					tmpVarcharListe_2 := array_append( tmpVarcharListe_2, 
									'' );

					--
					-- Nr. des ersten Darstellungsblattes des aktuellen
					-- Ebenenblockes übernehmen
					--
					tmpInteger_4 := array_upper( tmpVarcharListe_1, 1 );
					tmpInteger_2 := tmpInteger_4;

				--
				-- ... sonst auf nächstes Darstellungsblatt schalten
				--
				ELSE

					tmpInteger_2 := tmpInteger_2 + 1;

				END IF;

				--
				-- y-Koordinate auf erste Zeile setzen
				--
 				tmpInteger_3 := 157;

				--
				-- Umgebung setzen
				--
 				tmpVarcharListe_1[tmpInteger_2] := E'%
% ----------------------------------------------------------------------------------------
%				----------------------------------------------------------
%  ' || tmpVarchar_2 || E' 			----------------------------------------------------------
%				----------------------------------------------------------
% ----------------------------------------------------------------------------------------
%
\\begin{seiteTabHierarchie}{' || tmpVarchar_2 || '}
 
';

 			END IF;

			--
			-- am Ebenenwechsel 
			--	-> Ebene übernehmen
			--	-> die lfd. Nr. des Darstellungsblattes auf das erste Blatt des 
			--	   aktuellen Ebenenblockes setzen
			--	-> y-Koordinate auf erste Zeile setzen
			--
 			IF(
 				( tmpInteger_1 != zeile_2.ebene )
 			  )
 			THEN

				--
				-- die letzten drei Punkte
				--
				tmpInteger_1 := zeile_2.ebene;
 				tmpInteger_2 := tmpInteger_4;
  				tmpInteger_3 := 157;

 			END IF;

			--
			-- \zeichneTabelle{...}{%
			-- auf dem aktuellen Zeichenblatt übernehmen
			--
			tmpVarcharListe_1[tmpInteger_2] := 
				tmpVarcharListe_1[tmpInteger_2]
				|| '}' || chr( 10 ) || chr( 10 )
				|| E'\\zeichneTabelle{}{'
				|| zeile_2.nodename
				|| '}{'
				|| CASE zeile_2.ebene	WHEN( 1 ) THEN '33mm'
							WHEN( 2 ) THEN '113mm'
							ELSE '193mm' 
			  				END
				|| '}{'
				|| tmpInteger_3 || '.5mm'
				|| '}{'
				|| zeile_2.tname
				|| '}{%' || chr( 10 );
		
			--
			-- aktuelle Spaltenanzahl übernehmen
			--
			tmpInteger_5 := zeile_2.spanz;

		END IF;

		--
		-- Spalten übernehmen
		--
		tmpVarcharListe_1[tmpInteger_2] := 
			tmpVarcharListe_1[tmpInteger_2] 
			|| zeile_2.spaltenname
			|| '/'
			|| zeile_2.dtyp
			|| '/'
			|| zeile_2.nodename
			|| ',%' || chr( 10 );

		--
		-- Hilfszeichenkette für \zeichneVerbindung{...} zusammenstellen
		--
		IF(
			( zeile_2.zielnodename IS NOT NULL )
		  )
		THEN
			tmpVarcharListe_2[tmpInteger_2] :=
					tmpVarcharListe_2[tmpInteger_2]
					|| '{'
					|| zeile_2.zielnodename
					|| '}|{'
					|| zeile_2.nodename
					|| '}'
					|| CASE WHEN( zeile_2.ebwechsel ) THEN '%' ELSE '' END
					|| chr( 10 );
		END IF;

	END LOOP;

	--
	-- letzten Block abschließen und Darstellungsblätter übernehmen
	--
	FOR tmpInteger_1 IN 1..array_upper( tmpVarcharListe_1, 1 )
	LOOP

		--
		-- letzten Block abschließen
		--
		tmpVarcharListe_1[tmpInteger_1] := tmpVarcharListe_1[tmpInteger_1]
			|| chr( 10 ) || E'\\end{seiteTabHierarchie}';

		--
		-- Bereinigen
		--
		tmpVarcharListe_1[tmpInteger_1] := replace( tmpVarcharListe_1[tmpInteger_1]
			, E'}
 
}

\\zeichneTabelle'
			, E'}

\\zeichneTabelle' );

		tmpVarcharListe_1[tmpInteger_1] := replace( tmpVarcharListe_1[tmpInteger_1]
			, E',%
}

\\zeichneTabelle'
			, E'%
}

\\zeichneTabelle' );

		tmpVarcharListe_1[tmpInteger_1] := replace( tmpVarcharListe_1[tmpInteger_1]
				, E',%

\\end{seiteTabHierarchie}'
				, E'%
}

');

		--
		-- Verbindungen vervollständigen und übernehmen
		--
		tmpVarcharListe_3 := string_to_array( tmpVarcharListe_2[tmpInteger_1], chr( 10 ) );
		FOR tmpInteger_7 IN 1..( CASE WHEN( tmpVarcharListe_3 IS NOT NULL ) THEN array_upper( tmpVarcharListe_3, 1 ) ELSE 1 END - 1 )
		LOOP

			--
			-- \zeichneVerbindung{...} zusammenstellen
			--
			tmpVarcharListe_1[tmpInteger_1] := tmpVarcharListe_1[tmpInteger_1]
				|| E'\\zeichneVerbindung{}'
				|| replace( replace( tmpVarcharListe_3[tmpInteger_7], '|', '' )
					, '%'
					, '' )
--
-- später korrigieren, wenn Verbindungen zwischen Ebene 3 und 1 bestehen.
-- Dazu das Auftreten von >%< am Ende der Zeichenkette >tmpVarcharListe_3[tmpInteger_7]<
-- auswerten
--
				|| CASE WHEN( 
					position( E'\\zeichneTabelle{}'
						|| split_part( tmpVarcharListe_3[tmpInteger_7]
							, '|'
							, 1 )
					in tmpVarcharListe_1[tmpInteger_1] ) = 0 ) 
				   THEN '{s}' 
				   ELSE '{}' 
				   END
				|| chr( 10 );

		END LOOP;

		--
		-- Darstellungsblätter übernehmen und abschließen
		--
		tldateiinhalt := tldateiinhalt
			|| tmpVarcharListe_1[tmpInteger_1]
			|| E'
\\end{seiteTabHierarchie}


';

	END LOOP;

	--
	-- Schlüssel und Bedingungen darstellen
	--
	tldateiinhalt := tldateiinhalt || E'


%
% Schlüssel und Bedingungen
%
\\subsection{Schlüssel und Bedingungen}';

	--
	-- Primärschlüssel, Fremdschlüssel, unique constraint, check constraint initialisieren
	--
	tmpVarchar_2 := E'

%
% Liste der Primärschlüssel
%
\\noindent \\textbf{Primärschlüssel}
\\begin{description}
';
	tmpVarchar_3 := E'

%
% Liste der Fremdschlüssel
%
\\noindent \\textbf{Fremdschlüssel}
\\begin{description}
';
	tmpVarchar_4 := E'

%
% Liste der Unique Constraints
%
\\noindent \\textbf{Unique Constraints}
\\begin{description}
';
	tmpVarchar_5 := E'

%
% Liste der Check Constraints
%
\\noindent \\textbf{Check Constraints}
\\begin{description}
';

	--
	-- Primärschlüssel, Fremdschlüssel, unique constraint, check constraint eintragen
	--
	FOR zeile_2 IN
		SELECT
			CASE pg_constraint.contype	-- Reihenfolge festgelegt
				WHEN 'p' THEN 1		-- 1. Primärschlüssel
				WHEN 'f' THEN 2		-- 2. Fremdschlüssel
				WHEN 'u' THEN 3		-- 3. unique constraint
				ELSE 4			-- 4. check constraint
			END AS typ
			, pg_constraint.conname AS name
			, pg_namespace.nspname || '.' || pg_class.relname AS tabelle
			, pg_description.description AS beschreibung
			, pg_constraint.consrc AS bedingung
			, pg_constraint.conkey AS spnr
		FROM
			pg_namespace
			, pg_class
			, pg_constraint LEFT OUTER JOIN pg_description ON ( 
						pg_description.objoid = pg_constraint.oid )
		WHERE
			pg_constraint.connamespace = pg_namespace.oid
		AND
			pg_constraint.conrelid = pg_class.oid
		AND
			pg_namespace.nspname = zeile_1.nspname
		ORDER BY
			typ
			, tabelle
			, name
	LOOP

		--
		-- Liste der Spaltennamen setzen
		--
		tmpVarchar_7 := '';

		FOR tmpInteger_2 IN 1..array_upper ( zeile_2.spnr, 1 )
		LOOP

			--
			-- Alle verwendeten Spaltennamen ermitteln ...
			--
			SELECT INTO tmpVarchar_6
				pg_attribute.attname AS spname
			FROM 
				pg_namespace, pg_class, pg_attribute
			WHERE 
				pg_class.relnamespace = pg_namespace.oid
			AND
				pg_attribute.attrelid = pg_class.oid
			AND
				pg_attribute.attnum = zeile_2.spnr[tmpInteger_2]
			AND
				pg_namespace.nspname 
				|| '.' 
				|| pg_class.relname = zeile_2.tabelle;

			--
			-- ... und übernehmen
			--
			tmpVarchar_7 := tmpVarchar_7 
					|| ', ' || zeile_2.tabelle 
					|| '.' || tmpVarchar_6;

		END LOOP;
		--
		-- das führende Komma entfernen
		--
		tmpVarchar_7 := substring( tmpVarchar_7 from 3 );

		--
		-- '\item...' setzen
		--
		tmpVarchar_1 := E'  \\item[\\texttt{' 
					|| tl.erzeuge__TLdbGlossary( CAST( 
									zeile_2.name AS text )
									, zeile_2.tabelle
									, zeile_2.beschreibung )
					|| '}] ';

		--
		-- Primärschlüssel
		--
		IF ( zeile_2.typ = 1 ) THEN
			tmpVarchar_2 := tmpVarchar_2
						|| tmpVarchar_1
						|| E'für Spalte \\texttt{'
						|| tmpVarchar_7
						|| '}'
						|| chr( 10 );

		--
		-- Fremdschlüssel
		--
		ELSIF ( zeile_2.typ = 2 ) THEN 
			tmpVarchar_3 := tmpVarchar_3
						|| tmpVarchar_1
						|| E'aus Spalte \\texttt{'
						|| tmpVarchar_7
						|| '}'
						|| chr( 10 );

		--
		-- unique constraint
		--
		ELSIF ( zeile_2.typ = 3 ) THEN
			tmpVarchar_4 := tmpVarchar_4
						|| tmpVarchar_1
						|| E'in Tabelle \\texttt{'
						||	CAST( zeile_2.tabelle AS text ) 
						|| E'} für die Spalte(n) \\texttt{'
						|| tmpVarchar_7
						|| '}'
						|| chr( 10 );

		--
		-- check constraint
		--
		ELSE
			tmpVarchar_5 := tmpVarchar_5
						|| tmpVarchar_1
						|| E'in Tabelle \\texttt{'
						||	CAST( zeile_2.tabelle AS text )
						|| E'} die Bedingung \\texttt{'
						||	CAST( zeile_2.bedingung AS text )
						|| '}'
						|| chr( 10 );

		END IF;

	END LOOP;


	--
	-- Schlüssel, Bedingungen, Funktionen übernehmen, wenn sie verwendet wurden
	--
	tmpVarchar_1 := E'\\end{description}';
	IF ( position( E'\\item[' in tmpVarchar_2 ) > 0  ) THEN
		tldateiinhalt := tldateiinhalt || tmpVarchar_2 || tmpVarchar_1;
	END IF;

	IF ( position( E'\\item[' in tmpVarchar_3 ) > 0  ) THEN 
		tldateiinhalt := tldateiinhalt || tmpVarchar_3 || tmpVarchar_1;
	END IF;

	IF ( position( E'\\item[' in tmpVarchar_4 ) > 0  ) THEN 
		tldateiinhalt := tldateiinhalt || tmpVarchar_4 || tmpVarchar_1;
	END IF;

	IF ( position( E'\\item[' in tmpVarchar_5 ) > 0  ) THEN 
		tldateiinhalt := tldateiinhalt || tmpVarchar_5 || tmpVarchar_1;
	END IF;


	--
	-- Funktionen eintragen
	--
	FOR zeile_2 IN
		SELECT 
			-- Sollte die Programmiersprache ausgegeben werden ?
			-- pg_language.lanname AS progsprache
			pg_namespace.nspname || '.' || pg_proc.proname AS fktname
			, pg_proc.proargmodes AS parammodi
			, pg_proc.proargnames AS paramnamen
			, CASE WHEN( pg_proc.proallargtypes IS NULL )
			  THEN pg_proc.proargtypes
			  ELSE pg_proc.proallargtypes 
			  END  AS paramdtypen
			, pg_description.description AS beschreibung
			, pg_proc.proisagg
			-- Sollte der Quelltext ausgegeben werden ?
			-- , pg_proc.prosrc AS quelltext
		FROM 
			pg_namespace, pg_language, pg_proc LEFT OUTER JOIN pg_description ON ( pg_description.objoid = pg_proc.oid )
		WHERE
			pg_proc.pronamespace = pg_namespace.oid
		AND
			pg_proc.prolang = pg_language.oid
		AND
			pg_namespace.nspname = zeile_1.nspname
		ORDER BY
			fktname
	LOOP

		--
		-- Funktionsnamen eintragen
		--
		tmpVarchar_1 := E'

%
% Funktionsbeschreibung
%
\\subsection{' 
				|| zeile_2.fktname
				|| E'}

\\textbf{Funktionsname}\\\\
\\texttt{'
				|| zeile_2.fktname
				|| '(';


		--
		-- Parameterliste und die Beschreibungen der Funktionsparameter/Rückgabewerte 
		-- zusammenstellen
		--
		tmpVarchar_2 := '';
		tmpVarchar_3 := '';
		FOR tmpInteger_2 IN 1..CASE WHEN( array_upper ( zeile_2.paramnamen, 1 ) IS NULL )
						THEN 0 
						ELSE array_upper ( zeile_2.paramnamen, 1 ) 
						END
		LOOP

			--
			-- Alle verwendeten Datentypen ermitteln ...
			--
			SELECT INTO tmpVarchar_4
				CASE WHEN( position( '_' in typname ) = 1 )
				THEN ltrim( typname, '_') || '[]'
				ELSE typname
				END AS dtyp
			FROM
				pg_type
			WHERE
				CASE WHEN( zeile_2.parammodi IS NULL )
				THEN oid = zeile_2.paramdtypen[tmpInteger_2 - 1]
				ELSE oid = zeile_2.paramdtypen[tmpInteger_2]
				END
			ORDER BY
				typname
			;

			--
			-- ... übernehmen und die Parameternamen einschließlich Modus
			--     ergänzen
			--
			tmpVarchar_2 := tmpVarchar_2
						|| ', ';
			IF( zeile_2.parammodi[tmpInteger_2] IS NULL )
			THEN
				tmpVarchar_2 := tmpVarchar_2 || 'IN ';
			ELSE
				tmpVarchar_2 := tmpVarchar_2
						|| CASE zeile_2.parammodi[tmpInteger_2]
							WHEN 'b' THEN 'INOUT '
							WHEN 'i' THEN 'IN '
							WHEN 'o' THEN 'OUT '
						   END;
			END IF;
			tmpVarchar_2 := tmpVarchar_2
						|| zeile_2.paramnamen[tmpInteger_2]
						|| ' '
						|| tmpVarchar_4
						;

			--
			-- Beschreibungen der Funktionsparameter/Rückgabewerte zusammenstellen
			-- (das Trennzeichen einschließlich Position zum extrahieren der 
			--  Beschreibungen ist in >intern.nimm__TLKommentarFunktion(...)< 
			--  definiert)
			--
			tmpVarchar_3 := tmpVarchar_3
						|| E'\\item[\\texttt{'
						|| zeile_2.paramnamen[tmpInteger_2]
						|| '}] '
						|| split_part( zeile_2.beschreibung
								, chr( 2 )
								, tmpInteger_2 * 2 )
						|| chr( 10 );



		END LOOP;

		--
		-- Parameterliste und Beschreibungen der Funktionsparameter übernehmen
		--
		tmpVarchar_1 := tmpVarchar_1 
				|| CASE WHEN( tmpVarchar_2 != '' )
				   THEN substring( tmpVarchar_2 from 2 )
					|| ' '
				   ELSE
					''
				   END
				|| E')}
\\\\
\\\\
\\textbf{Funktionsparameter/Rückgabewert(e)}
\\begin{description}
'
				|| CASE WHEN( tmpVarchar_3 = '' )
				   THEN
					E'\\item[\\texttt{-}]' || chr( 10 )
				   ELSE
					tmpVarchar_3
				   END
				|| E'\\end{description}';

		--
		-- Funktionsbeschreibung übernehmen, das Trennzeichen zum extrahieren 
		-- der Beschreibung ist in >intern.nimm__TLKommentarFunktion(...)< definiert
		--
		tldateiinhalt := tldateiinhalt 
				|| tmpVarchar_1
				|| E'


\\noindent\\textbf{Funktionsbeschreibung}\\\\
'

				-- Beschreibung der Aggregatfunktion übernehmen
				|| CASE WHEN( zeile_2.proisagg ) THEN zeile_2.beschreibung
					ELSE split_part( zeile_2.beschreibung
								, chr( 3 )
								, 2 )
					END;


		--
		-- Beispiele zusammenbauen ...
		-- ( das Trennzeichen zum extrahieren der Beispiele ist 
		-- in >intern.nimm__TLKommentarFunktion(...)< definiert )
		--
		tmpVarchar_1 := '';
		FOR tmpInteger_2 IN 4..array_upper ( string_to_array( zeile_2.beschreibung, chr( 3 ) ), 1 )
		LOOP

			tmpVarchar_1 := tmpVarchar_1 
						|| E'\\texttt{'
						|| split_part( zeile_2.beschreibung, 
								chr( 3 ), 
								tmpInteger_2 )
						|| E'}\\\\\\\\'
						|| chr( 10 );

		END LOOP;

		--
		-- ... und übernehmen
		--
		IF(
			tmpVarchar_1 != ''
		) 
		THEN

			tldateiinhalt := tldateiinhalt 
					|| E'\\noindent
\\\\
\\\\
\\noindent\\textbf{Beispiele}\\\\
'
					|| rtrim( tmpVarchar_1, E'\\' );

		END IF;

	END LOOP;





	--
	-- Sichten eintragen
	--
	FOR zeile_2 IN

		SELECT
			pg_namespace.nspname || '.' || pg_class.relname AS sicht
			, pg_description.description AS beschreibung
		FROM
			pg_namespace
			, pg_class LEFT OUTER JOIN pg_description ON
							( pg_description.objoid = pg_class.oid )
		WHERE
			pg_class.relnamespace = pg_namespace.oid
		AND
			pg_class.relkind = 'v'
		AND
			pg_namespace.nspname = zeile_1.nspname
		ORDER BY
			sicht

	LOOP

		--
		-- Den Namen der Sicht immer aufführen
		--
		tldateiinhalt := tldateiinhalt || E'

%
% Beschreibung der Sicht
%
\\subsection{'
						|| zeile_2.sicht
						|| '}'
						|| chr(10);

		--
		-- Wenn keine Beschreibung existiert, zur nächsten Sicht gehen ...
		--
		IF(
			zeile_2.beschreibung IS NULL
		)
		THEN
			CONTINUE;
		END IF;

		--
		-- ... und wenn eine Beschreibung existiert, die Spalten darstellen ...
		--
		tldateiinhalt := tldateiinhalt	|| E'
\\textbf{Beschreibung der Spalten}
\\begin{description}'
						|| chr( 10 );

		FOR tmpInteger_2 IN 2..array_upper ( string_to_array( zeile_2.beschreibung, chr( 2 ) ), 1 ) - 1 BY 2
		LOOP

			--
			-- Spalten eintragen
			--
			tldateiinhalt := tldateiinhalt
						|| E'\\item[\\texttt{'
						|| split_part( zeile_2.beschreibung
								, chr( 2 )
								, tmpInteger_2 )
						|| '}]'
						|| split_part( zeile_2.beschreibung
								, chr( 2 )
								, tmpInteger_2 + 1 )
						|| chr( 10 );

		END LOOP;
		tldateiinhalt := tldateiinhalt	|| E'\\end{description}'
						|| chr( 10 );

		--
		-- ... bzw. die Beschreibung
		--
		IF(
			( split_part( zeile_2.beschreibung, chr( 3 ), 2 ) != '' )
			OR ( split_part( zeile_2.beschreibung, chr( 3 ), 2 ) IS NOT NULL )
		)
		THEN

			tldateiinhalt := tldateiinhalt	|| E'
\\noindent\\textbf{Beschreibung der Sicht}\\\\
'
						|| split_part( zeile_2.beschreibung
							, chr( 3 )
							, 2 );

		END IF;

	END LOOP;
	
END LOOP;


--
-- Identifikationsnummern der Zielspalten eintragen
--
tmpInteger_1 := 1;
FOR zeile_1 IN

	SELECT DISTINCT

		replace( replace( spziel, '.', '-' ), '_', '-' ) AS nodename
	FROM
		intern.zeige__fremdschluessel

	ORDER BY

		nodename

LOOP

	--
	-- lfd. Nr. der Zielspalten anhand der TL-nodenamen übernehmen
	--
	tldateiinhalt := replace( tldateiinhalt, E'\\zeichneVerbindung{}{'
					|| zeile_1.nodename
					|| '}', E'\\zeichneVerbindung{'
					|| CAST( tmpInteger_1 AS varchar)
					|| '}{'
					|| zeile_1.nodename
					|| '}' );
	tldateiinhalt := replace( tldateiinhalt, E'\\zeichneTabelle{}{'
					|| zeile_1.nodename
					|| '}', E'\\zeichneTabelle{'
					|| CAST( tmpInteger_1 AS varchar)
					|| '}{'
					|| zeile_1.nodename
					|| '}' );

	--
	-- lfd. Nr. der Zielspalten weiterzählen
	--
	tmpInteger_1 := tmpInteger_1 + 1;

END LOOP;





--------------------------------------------------------------------------------
--					----------------------------------------
-- 6.)	Statischer Teil - Anhang	----------------------------------------
--					----------------------------------------
--------------------------------------------------------------------------------
tldateiinhalt := tldateiinhalt || E'



% ----------------------------------------------------------------------------------------
% ----------------------------------------------------------------------------------------
%		--------------------------------------------------------------------------
%  Anhang	--------------------------------------------------------------------------
%		--------------------------------------------------------------------------
% ----------------------------------------------------------------------------------------
% ----------------------------------------------------------------------------------------
\\cleardoublepage
\\begin{appendix}

  %
  % Lizenz
  %
  \\Lizenz

  %
  % Begriffs-/Abkürzungsverzeichnis
  %
  \\cleardoublepage
  \\begin{landscape}
    \\printglossary
  \\end{landscape}

\\end{appendix}

\\end{document}';


--------------------------------------------------------------------------------
--					----------------------------------------
-- 7.)	Zeilenumbruchzeichen einfügen	----------------------------------------
--	Alle '_' mittels '\_' ersetzen	----------------------------------------
--					----------------------------------------
--------------------------------------------------------------------------------
tldateiinhalt := tl.erzeuge__TLZk( replace( tldateiinhalt, intern.gib__ZU(), E'\n' ) );


--
-- Test
--
--tldateiinhalt := '';


END
$$LANGUAGE 'plpgsql' VOLATILE;
SELECT intern.nimm__TLKommentarFunktion( 'tl.erzeuge__DBModell( OUT tldateiinhalt varchar )', 
ARRAY[
E'Es wird der Inhalt der {\\TeX}/\\LaTeX{}-Datei zurückgegeben, welche das Datenbankmodell enthält.'
],
E'Ziel der Funktion ist das Erzeugen einer {\\TeX}/\\LaTeX{}-Datei, welche das Datenbankmodell enthält. Sie wird aus den Kommentaren erzeugt, welche den verschiedenen Datenbankobjekten zugeordnet wurden.
Es werden die Kommentare der Datenbank, Schemas, Tabellen, Spalten, Funktionen, Primär- und Fremdschlüssel, sowie die \\texttt{unique} und \\texttt{check constraints} verwendet.\\\\
In den Kommentaren sind $\\backslash$ entsprechend zu doppeln. Unterstrichen werden automatisch $\\backslash$ vorangestellt, weshalb zum momentanen Zeitpunkt keine mathematischen Formeln eingegeben werden können.
\\\\
\\\\
Hinweise zur Benutzung:\\\\
Um nicht auf eine separate Ausleseroutine angewiesen zu sein, wird folgende (in \\texttt{psql}) auszufuehrende Handlungsweise empfohlen:\\\\
\\\\
\\texttt{$\\backslash$pset tuples_only $\\backslash$pset format unaligned $\\backslash$pset footer}\\\\
\\texttt{SELECT * FROM tl.erzeuge__DBModell() $\\backslash$o dateiname.tex}\\\\
\\texttt{;}\\\\
\\texttt{$\\backslash$q}\\\\
Alternativ kann in der Kommandozeile\\\\
\\texttt{psql -U micha vf -P tuples_only -P format=unaligned -P footer -c ``SELECT * FROM tl.erzeuge__DBModell()`` -o dateiname.tex}\\\\
eingegeben werden.'
, ARRAY[
E'-- Datenbankmodell ausgeben\\\\SELECT * FROM tl.erzeuge__DBModell();'
]
);
--
-- Standardverhalten:
-- ..................
--
--	-- Datenbankmodell ausgeben
--SELECT * FROM tl.erzeuge__DBModell();
--






--
-- -----------------------------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------------------------
--

--
--
-- --	Tabellen neu hinzufügen		--------------------------------------------------
--
--
ALTER TABLE dok.doku RENAME COLUMN intern_firma_id TO dok_typ_id;

CREATE TABLE dok.typ (
	LIKE intern.alle INCLUDING DEFAULTS,
	spr_uebvar_id INT DEFAULT 0 NOT NULL
) 
WITHOUT OIDS;
INSERT INTO dok.typ VALUES( 0 );

SELECT intern.nimm__TLKommentarSTS( 'dok.doku', 'Tabelle zur Verwaltung der Basisinformationen der Dokumente. Die Dokumente werden anhand des Typs und der projektübergreifenden Dokumentbezeichnung unterschieden.');

SELECT intern.nimm__TLKommentarSTS( 'dok.typ', E'Tabelle zur Verwaltung der Typen der Dokumente.');

SELECT intern.nimm__TLKommentarSTS( 'dok.doku.dok_typ_id', E'Identifikationsnummer zur Klassifizierung des Dokumentes.');
SELECT intern.nimm__TLKommentarSTS( 'dok.doku.spr_uebvar_id_kb', 'Identifikationsnummer der Übersetzungsvariante, welche die projektübergreifende Dokumentbezeichnung (Zweckes, Zieles, ...) darstellt.');

SELECT intern.nimm__TLKommentarSTS( 'dok.typ.spr_uebvar_id', 'Identifikationsnummer der Übersetzungsvariante zur Darstellung des aktuellen Typs.');


SELECT intern.nimm__zeile( 'dok.typ', ARRAY['spr_uebvar_id'], ARRAY[spr.nimm__wgruppe( 'Pflichtenheft', '1', '0' )] );
SELECT intern.nimm__zeile( 'dok.typ', ARRAY['spr_uebvar_id'], ARRAY[spr.nimm__wgruppe( 'Stromlaufplan', '1', '0' )] );
SELECT intern.nimm__zeile( 'dok.typ', ARRAY['spr_uebvar_id'], ARRAY[spr.nimm__wgruppe( 'Zertifikat', '1', '0' )] );
SELECT intern.nimm__zeile( 'dok.typ', ARRAY['spr_uebvar_id'], ARRAY[spr.nimm__wgruppe( 'Zeichnung', '1', '0' )] );



ALTER TABLE dok.typ ADD CONSTRAINT pk__dok_typ_id PRIMARY KEY(id);

ALTER TABLE dok.doku DROP CONSTRAINT fk__dok_doku__intern_firma_id;

ALTER TABLE dok.doku ADD CONSTRAINT fk__dok_doku__dok_typ_id FOREIGN KEY ( dok_typ_id ) REFERENCES dok.typ ( id );

ALTER TABLE dok.typ ADD CONSTRAINT fk__dok_typ__spr_uebvar_id FOREIGN KEY ( spr_uebvar_id ) REFERENCES spr.uebvar ( id );


ALTER TABLE dok.doku DROP CONSTRAINT uc__dok_doku;

ALTER TABLE dok.doku ADD CONSTRAINT uc__dok_doku UNIQUE( idfrei, dok_typ_id, spr_uebvar_id_kb );




--
-- -----------------------------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------------------------
--


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------
--					--------------------------------------------------
-- 	dok.nimm__doku(...)		--------------------------------------------------
--					--------------------------------------------------
-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------
CREATE OR REPLACE FUNCTION dok.nimm__doku( IN liste_werte varchar[], OUT dokuid varchar ) AS
$$
DECLARE
--------------------------------------------------------------------------------
-- Konstanten
--------------------------------------------------------------------------------


--------------------------------------------------------------------------------
-- lokale Variablen
--------------------------------------------------------------------------------
--
-- temporäre Ganzzahlvariable(n)
--
tmpInteger integer;



BEGIN



--
-- 1.)	Liste >liste_werte< auf Plausibilität prüfen
--		- spr_uebvar_id_kb
--		- dok_typ_id
--		- aspekt
--		- notizen
--
EXECUTE intern.pruefe__array( liste_werte, 2, 4, 'dok.nimm__doku(...)', 'liste_werte' );

EXECUTE intern.pruefe__dt( 'gz', liste_werte[1], '1', NULL
				, 'dok.nimm__doku(...)'
				, 'liste_werte[1]' );

EXECUTE intern.pruefe__dt( 'gz', liste_werte[2], '1', NULL
				, 'dok.nimm__doku(...)'
				, 'liste_werte[2]' );

IF(
	NOT( tmpInteger < 3 )
  ) 
THEN
	IF(
		( tabwerte[3] NOT IN( 'BEWEIS', 'QUELLE' ) )
	  ) 
	THEN

		RAISE EXCEPTION 'dok.nimm__doku(...)	Zur Klassifizierung der Dokumente  >tabwerte[3] = %', tabwerte[3] || '< dürfen nur die Werte >BEWEIS< und >QUELLE< übergeben werden. Das Einlesen wird abgebrochen !';
	
	END IF;
	
END IF;



--
-- 2.)	Dokumentenreferenz in >dok.doku< einlesen (Reihenfolge siehe Kommentar)
--
tmpInteger := array_upper( liste_werte, 1 );
EXECUTE
	'SELECT intern.nimm__zeile( ''dok.doku''
			, ARRAY[ ''spr_uebvar_id_kb''
				, ''dok_typ_id'''
				|| CASE WHEN( NOT( tmpInteger < 3 ) )
					THEN ', ''aspekt''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 4 ) )
					THEN ', ''notizen''' ELSE '' END
				|| ']
			, ARRAY[''' 	|| liste_werte[1] || '''
				, '''	|| liste_werte[2] || ''''
				|| CASE WHEN( NOT( tmpInteger < 3 ) )
					THEN ', ''' || liste_werte[3] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 4 ) )
					THEN ', ''' || liste_werte[4] || '''' ELSE '' END
				|| '])'
INTO dokuid;


END
$$LANGUAGE 'plpgsql'  VOLATILE;
SELECT intern.nimm__TLKommentarFunktion( 'dok.nimm__doku( IN liste_werte varchar[], OUT dokuid varchar )',
ARRAY[
E'Liste der Werte, welche in \\texttt{dok.doku} eingelesen werden sollen (Hinweise siehe Funktionsbeschreibung --- Werteliste einlesen). Sie werden in der folgenden Reihenfolge in die Spalten
\\begin{enumerate}
  \\item \\texttt{spr_uebvar_id_kb}
  \\item \\texttt{dok_typ_id}
  \\item \\texttt{aspekt}
  \\item \\texttt{notizen}
\\end{enumerate}
eingetragen. Es müssen mindestens die ersten zwei Werte übergeben werden.\\\\Für \\texttt{aspekt} darf nur \\texttt{BEWEIS} zur Kennzeichnung von Dokumenen, die beweisen, daß eine Sicherheitsanforderung umgesetzt wurde bzw. \\texttt{QUELLE} zur Kennzeichnung von Dokumenten, die auf den Ursprung einer Sicherheitsanforderung verweisen.'
, E'Es wird die Datenbank-Identifikationsnummer der eingelesenen Dokumentenreferenz (\\texttt{dok.doku.id}) zurückgegeben.'
],
E'Mittels dieser Funktion werden die im System zu referenzierenden Dokumente in \\texttt{dok.doku} eingelesen.
\\\\
\\\\
Werteliste einlesen:\\\\
Dem Funktionsparameter \\texttt{liste_werte} ist eine Werteliste (\\texttt{ARRAY}) zu übergeben (die maximale Anzahl und die Reihenfolge der Werte ist fest vorgegeben --- siehe oben). Soll nur eine Teilmenge der Werte übergeben werden, dann sind alle Werte von links nach rechts zu spezifizieren (nichtbenötigte Werte am Ende der Liste dürfen weggelassen werden).\\\\[2ex]
\\textbf{ACHTUNG\\\\Die Beispiele müssen aktualisiert werden !}'
, ARRAY[
E'-- Fehlermeldung. Der Parameter \\texttt{liste_werte} darf nicht \\texttt{NULL} sein.\\\\SELECT * FROM dok.nimm__doku( NULL );'
, E'-- Fehlermeldung. Es sind mindestens zwei Werte zu übergeben.\\\\SELECT * FROM dok.nimm__doku( ARRAY[''08-15''] );'
, E'-- Fehlermeldung. Die Werte müssen größer \\texttt{0} bzw. dürfen nicht leer sein.\\\\SELECT * FROM dok.nimm__doku( ARRAY['''', ''1''] );\\\\SELECT * FROM dok.nimm__doku( ARRAY[''08-15'', ''0''] );'
, E'-- Dokumentenreferenz einlesen\\\\SELECT dok_doku_id, doknr, intern_firma_id_eigentuemer, spr_uebvar_id__doktitel, spr_uebvar_id__kurzbeschr, dok_doku_notizen FROM dok.zeige__doku;\\\\SELECT * FROM dok.nimm__doku( ARRAY[''08-15'', ''1''] );\\\\SELECT * FROM dok.nimm__doku( ARRAY[''08-15'', ''1'', spr.nimm__wgruppe( ''Dokumententitel'', ''1'', ''0'' )] );\\\\SELECT * FROM dok.nimm__doku( ARRAY[''08-15'', ''1'', spr.nimm__wgruppe( ''Dokumententitel'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Dokumentenkurzbeschreibung'', ''1'', ''0'' )] );\\\\SELECT * FROM dok.nimm__doku( ARRAY[''08-15'', ''1'', spr.nimm__wgruppe( ''Dokumententitel'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Dokumentenkurzbeschreibung'', ''1'', ''0'' ), ''Zusatzinformationen''] );\\\\SELECT dok_doku_id, doknr, intern_firma_id__eigentuemer, spr_uebvar_id__doktitel, spr_uebvar_id__kurzbeschr, dok_doku_notizen FROM dok.zeige__doku;'
]
);
--
-- Fehlermeldungen
-- ...............
--
--	-- Fehlermeldung. Der Parameter \\texttt{liste_werte} darf nicht \\texttt{NULL} sein.
--SELECT * FROM dok.nimm__doku( NULL );
--
--	-- Fehlermeldung. Es sind mindestens zwei Werte zu übergeben.
--SELECT * FROM dok.nimm__doku( ARRAY['08-15'] );
--
--	-- Fehlermeldung. Die Werte müssen größer \\texttt{0} bzw. dürfen nicht leer sein.
--SELECT * FROM dok.nimm__doku( ARRAY['', '1'] );
--SELECT * FROM dok.nimm__doku( ARRAY['08-15', '0'] );
--
--
--
-- Standardverhalten:
-- ..................
--
--	-- Dokumentenreferenz einlesen
--SELECT dok_doku_id, doknr, intern_firma_id__eigentuemer, spr_uebvar_id__doktitel, spr_uebvar_id__kurzbeschr, dok_doku_notizen FROM dok.zeige__doku;
--SELECT * FROM dok.nimm__doku( ARRAY['08-15', '1'] );

--SELECT * FROM dok.nimm__doku( ARRAY['08-15', '1', spr.nimm__wgruppe( 'Dokumententitel', '1', '0' )] );
--SELECT * FROM dok.nimm__doku( ARRAY['08-15', '1', spr.nimm__wgruppe( 'Dokumententitel', '1', '0' ), spr.nimm__wgruppe( 'Dokumentenkurzbeschreibung', '1', '0' )] );
--SELECT * FROM dok.nimm__doku( ARRAY['08-15', '1', spr.nimm__wgruppe( 'Dokumententitel', '1', '0' ), spr.nimm__wgruppe( 'Dokumentenkurzbeschreibung', '1', '0' ), 'Zusatzinformationen'] );
--SELECT dok_doku_id, doknr, intern_firma_id__eigentuemer, spr_uebvar_id__doktitel, spr_uebvar_id__kurzbeschr, dok_doku_notizen FROM dok.zeige__doku;
--








--
-- -----------------------------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------------------------
--



-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------
--				----------------------------------------------------------
--	prj.zeige__dokdoku	----------------------------------------------------------
--				----------------------------------------------------------
-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------
DROP VIEW prj.zeige__dokdoku;
CREATE OR REPLACE VIEW prj.zeige__dokdoku
AS
  SELECT
	--
	-- --	dok.doku	----------------------------------------------------------
	--
	dok.doku.id AS dok__doku__id
	, dok.doku.aspekt AS dok__doku__aspekt
	, dok.doku.notizen AS dok__doku__notizen
	, dok.doku.dok_typ_id AS dok__doku__dok_typ_id
	, dok.doku.spr_uebvar_id_kb AS dok__doku__spr_uebvar_id_kb
	--
	-- --	prj.pl_prtdokdoku	----------------------------------------------------------
	--
	, prj.pl_prtdokdoku.id AS prj__pl_prtdokdoku__id
	, prj.pl_prtdokdoku.prj_projekte_id AS prj__pl_prtdokdoku__prj_projekte_id
	, prj.pl_prtdokdoku.prt_protokoll_id AS prj__pl_prtdokdoku__prt_protokoll_id
	, prj.pl_prtdokdoku.nr AS prj__pl_prtdokdoku__nr
	, prj.pl_prtdokdoku.spr_uebvar_id AS prj__pl_prtdokdoku__spr_uebvar_id
	, prj.pl_prtdokdoku.spr_uebvar_id_zus AS prj__pl_prtdokdoku__spr_uebvar_id_zus
	, prj.pl_prtdokdoku.notizen AS prj__pl_prtdokdoku__notizen
	, prj.pl_prtdokdoku.logdatuhrz AS prj__pl_prtdokdoku__logdatuhrz
	, prj.pl_prtdokdoku.logdqok AS prj__pl_prtdokdoku__logdqok
	, prj.pl_prtdokdoku.logdquelle AS prj__pl_prtdokdoku__logdquelle
	, prj.pl_prtdokdoku.logentfernt AS prj__pl_prtdokdoku__logentfernt
	, prj.pl_prtdokdoku.logname AS prj__pl_prtdokdoku__logname
	--
	-- --	prj.pl_dokausgabe	--------------------------------------------------
	--
	, prj.pl_dokausgabe.id AS prj__pl_dokausgabe__id
	, prj.pl_dokausgabe.prj_projekte_id AS prj__pl_dokausgabe__prj_projekte_id
	, prj.pl_dokausgabe.stand AS prj__pl_dokausgabe__stand
	, prj.pl_dokausgabe.datum AS prj__pl_dokausgabe__datum
	, prj.pl_dokausgabe.istfrei AS prj__pl_dokausgabe__istfrei
	, prj.pl_dokausgabe.notizen AS prj__pl_dokausgabe__notizen
	, prj.pl_dokausgabe.logdatuhrz AS prj__pl_dokausgabe__logdatuhrz
	, prj.pl_dokausgabe.logdqok AS prj__pl_dokausgabe__logdqok
	, prj.pl_dokausgabe.logdquelle AS prj__pl_dokausgabe__logdquelle
	, prj.pl_dokausgabe.logentfernt AS prj__pl_dokausgabe__logentfernt
	, prj.pl_dokausgabe.logname AS prj__pl_dokausgabe__logname
	--
	-- --	prj.ppl_dokdoku	----------------------------------------------------------
	--
	, prj.ppl_dokdoku.id AS prj__ppl_dokdoku__id
	, prj.ppl_dokdoku.prj_personen_id AS prj__ppl_dokdoku__prj_personen_id
	, prj.ppl_dokdoku.prj_projekte_id AS prj__ppl_dokdoku__prj_projekte_id
	, prj.ppl_dokdoku.notizen AS prj__ppl_dokdoku__notizen
	, prj.ppl_dokdoku.logdatuhrz AS prj__ppl_dokdoku__logdatuhrz
	, prj.ppl_dokdoku.logdqok AS prj__ppl_dokdoku__logdqok
	, prj.ppl_dokdoku.logdquelle AS prj__ppl_dokdoku__logdquelle
	, prj.ppl_dokdoku.logentfernt AS prj__ppl_dokdoku__logentfernt
	, prj.ppl_dokdoku.logname AS prj__ppl_dokdoku__logname
	--
	-- --	prj.p_dokstrkt	----------------------------------------------------------
	--
	, prj.p_dokstrkt.id AS prj__p_dokstrkt__id
	, prj.p_dokstrkt.notizen AS prj__p_dokstrkt__notizen
	, prj.p_dokstrkt.prj_projekte_id AS prj__p_dokstrkt__prj_projekte_id
	, prj.p_dokstrkt.str_strkt_id AS prj__p_dokstrkt__str_strkt_id
  FROM
	dok.doku
		--
		-- prj.pl_prtdokdoku
		--
		LEFT OUTER JOIN prj.pl_prtdokdoku ON ( 
		         dok.doku.id = prj.pl_prtdokdoku.dok_doku_id
		     AND prj.pl_prtdokdoku.idfrei = 0 )
		--
		-- prj.pl_dokausgabe
		--
		LEFT OUTER JOIN prj.pl_dokausgabe ON ( 
		         dok.doku.id = prj.pl_dokausgabe.dok_doku_id
		     AND prj.pl_dokausgabe.idfrei = 0 )
		--
		-- prj.pl_dokausgabe
		--
		LEFT OUTER JOIN prj.ppl_dokdoku ON ( 
		         dok.doku.id = prj.ppl_dokdoku.dok_doku_id
		     AND prj.ppl_dokdoku.idfrei = 0 )
		--
		-- prj.p_dokstrkt
		--
		LEFT OUTER JOIN prj.p_dokstrkt ON ( 
		         dok.doku.id = prj.p_dokstrkt.dok_doku_id
		     AND prj.p_dokstrkt.idfrei = 0 )
  WHERE
	dok.doku.idfrei = 0
;
SELECT intern.nimm__TLKommentarSicht( 'prj.zeige__dokdoku'
, ARRAY[
   'dok__doku__id'
 , 'dok__doku__aspekt'
 , 'dok__doku__notizen'
 , 'dok__doku__dok_typ_id'
 , 'dok__doku__spr_uebvar_id_kb'
 , 'prj__pl_prtdokdoku__id'
 , 'prj__pl_prtdokdoku__prj_projekte_id'
 , 'prj__pl_prtdokdoku__prt_protokoll_id'
 , 'prj__pl_prtdokdoku__nr'
 , 'prj__pl_prtdokdoku__spr_uebvar_id'
 , 'prj__pl_prtdokdoku__spr_uebvar_id_zus'
 , 'prj__pl_prtdokdoku__notizen'
 , 'prj__pl_prtdokdoku__logdatuhrz'
 , 'prj__pl_prtdokdoku__logdqok'
 , 'prj__pl_prtdokdoku__logdquelle'
 , 'prj__pl_prtdokdoku__logentfernt'
 , 'prj__pl_prtdokdoku__logname'
 , 'prj__pl_dokausgabe__id'
 , 'prj__pl_dokausgabe__prj_projekte_id'
 , 'prj__pl_dokausgabe__stand'
 , 'prj__pl_dokausgabe__datum'
 , 'prj__pl_dokausgabe__istfrei'
 , 'prj__pl_dokausgabe__notizen'
 , 'prj__pl_dokausgabe__logdatuhrz'
 , 'prj__pl_dokausgabe__logdqok'
 , 'prj__pl_dokausgabe__logdquelle'
 , 'prj__pl_dokausgabe__logentfernt'
 , 'prj__pl_dokausgabe__logname'
 , 'prj__ppl_dokdoku__id'
 , 'prj__ppl_dokdoku__prj_personen_id'
 , 'prj__ppl_dokdoku__prj_projekte_id'
 , 'prj__ppl_dokdoku__notizen'
 , 'prj__ppl_dokdoku__logdatuhrz'
 , 'prj__ppl_dokdoku__logdqok'
 , 'prj__ppl_dokdoku__logdquelle'
 , 'prj__ppl_dokdoku__logentfernt'
 , 'prj__ppl_dokdoku__logname'
 , 'prj__p_dokstrkt__id'
 , 'prj__p_dokstrkt__notizen'
 , 'prj__p_dokstrkt__prj_projekte_id'
 , 'prj__p_dokstrkt__str_strkt_id'
] 
, ARRAY[
   E'siehe \\texttt{dok.doku.id}'
 , E'siehe \\texttt{dok.doku.aspekt}'
 , E'siehe \\texttt{dok.doku.notizen}'
 , E'siehe \\texttt{dok.doku.dok_typ_id}'
 , E'siehe \\texttt{dok.doku.spr_uebvar_id_kb}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.id}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.prj_projekte_id}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.prt_protokoll_id}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.nr}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.spr_uebvar_id}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.spr_uebvar_id_zus}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.notizen}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.logdatuhrz}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.logdqok}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.logdquelle}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.logentfernt}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.logname}'
 , E'siehe \\texttt{prj.pl_dokausgabe.id}'
 , E'siehe \\texttt{prj.pl_dokausgabe.prj_projekte_id}'
 , E'siehe \\texttt{prj.pl_dokausgabe.stand}'
 , E'siehe \\texttt{prj.pl_dokausgabe.datum}'
 , E'siehe \\texttt{prj.pl_dokausgabe.istfrei}'
 , E'siehe \\texttt{prj.pl_dokausgabe.notizen}'
 , E'siehe \\texttt{prj.pl_dokausgabe.logdatuhrz}'
 , E'siehe \\texttt{prj.pl_dokausgabe.logdqok}'
 , E'siehe \\texttt{prj.pl_dokausgabe.logdquelle}'
 , E'siehe \\texttt{prj.pl_dokausgabe.logentfernt}'
 , E'siehe \\texttt{prj.pl_dokausgabe.logname}'
 , E'siehe \\texttt{prj.ppl_dokdoku.id}'
 , E'siehe \\texttt{prj.ppl_dokdoku.prj_personen_id}'
 , E'siehe \\texttt{prj.ppl_dokdoku.prj_projekte_id}'
 , E'siehe \\texttt{prj.ppl_dokdoku.notizen}'
 , E'siehe \\texttt{prj.ppl_dokdoku.logdatuhrz}'
 , E'siehe \\texttt{prj.ppl_dokdoku.logdqok}'
 , E'siehe \\texttt{prj.ppl_dokdoku.logdquelle}'
 , E'siehe \\texttt{prj.ppl_dokdoku.logentfernt}'
 , E'siehe \\texttt{prj.ppl_dokdoku.logname}'
 , E'siehe \\texttt{prj.p_dokstrkt.id}'
 , E'siehe \\texttt{prj.p_dokstrkt.notizen}'
 , E'siehe \\texttt{prj_projekte_id}'
 , E'siehe \\texttt{prj.p_dokstrkt.str_strkt_id}'
], 
E'Es werden die Dokumente (siehe \\texttt{dok.doku}, \\texttt{prj.pl_prtdokdoku}, \\texttt{prj.pl_dokausgabe}, \\texttt{prj.ppl_dokdoku}) angezeigt.' );
--
-- Standardverhalten:
-- ..................
--
--SELECT * FROM prj.zeige__dokdoku;
--



--
-- -----------------------------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------------------------
--






--
-- -----------------------------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------------------------
--



--
--	prj.pp_prtprotokoll modifiziert	----------------------------------
--
ALTER TABLE prj.pp_prtprotokoll ALTER COLUMN duanfrage DROP DEFAULT;
ALTER TABLE prj.pp_prtprotokoll ALTER COLUMN duanfrage DROP NOT NULL;

ALTER TABLE prj.pp_prtprotokoll DROP CONSTRAINT cc__prj_pp_protokoll;
ALTER TABLE prj.pp_prtprotokoll ADD CONSTRAINT cc__prj_pp_protokoll CHECK( 
	--
	-- Nulleintrag
	--
	( id = 0 AND idfrei = 0 AND prj_personen_id = 0	AND prj_projekte_id = 0	AND prt_protokoll_id = 0 AND spr_uebvar_id = 0 )
	--
	-- gelöschter Eintrag
	--
	OR ( id > 0 AND idfrei > 0 )
	--
	-- Protokolleintrag projektspezifisch modifizieren und Randbedingungen setzen
	--
	OR ( id > 0 AND idfrei = 0 AND  prj_personen_id = 0 AND  prj_projekte_id > 0 AND  prt_protokoll_id > 0 AND  teilnehmer = NULL )
	--
	-- dem Protokolleintrag Personen zuordnen
	--
	OR ( id > 0 AND idfrei = 0 AND  prj_personen_id > 0 AND  prj_projekte_id > 0 AND  prt_protokoll_id > 0 AND  spr_uebvar_id = 0 AND  teilnehmer != NULL )
);
SELECT intern.nimm__TLKommentar( 'CONSTRAINT cc__prj_pp_protokoll ON prj.pp_prtprotokoll', E'Dieser CHECK Constraint deckt mehrere Fälle ab:
\\\\
\\\\
\\textbf{Nulleintrag}\\\\
Wenn \\texttt{id = 0}, dann muß \\texttt{idfrei = 0}, \\texttt{prj_personen_id = 0}, \\texttt{prj_projekte_id = 0}, \\texttt{prt_protokoll_id = 0}, \\texttt{spr_uebvar_id = 0} sein.
\\\\
\\\\
\\textbf{Protokolleintrag einem Projekt zuordnen, projektspezifisch modifizieren und Randbedingungen setzen}\\\\
Wenn der Protokolleintrag einem Projekt zugeordnet oder umformuliert wird, ''Intern''/''Erledigt'' gesetzt wird oder das Datum des Erstellens des Protokolleintrages spezifiziert wird, dann muß ein Protokolleintrag (\\texttt{prt_protokoll_id > 0}) und ein Projekt (\\texttt{prj_projekte_id > 0}) zugeordnet sein. Weiterhin darf keine Person  (\\texttt{prj\_personen\_id = 0}) zugeordnet sein.
\\\\
Wenn der Protokolleintrag eine Frage / Aufgabe ist, dann muß zusätzlich ein Termin (\\texttt{termin NOT NULL}) und das Datum des Übersendens der Aufgabe \\texttt{duanfrage NOT NULL} angegeben sein.\\\\
\\\\
\\\\
\\textbf{dem Protokolleintrag die beteiligten Personen bzw. Ansprechpartner zuordnen}\\\\
Wenn dem Protokolleintrag die beteiligten Personen zugeordnet werden, dann muß ein Protokolleintrag (\\texttt{prt_protokoll_id > 0}) und ein Projekt (\\texttt{prj_projekte_id > 0}) ausgewählt sein. Weiterhin muß eine Person (\\texttt{prj\_personen\_id > 0}) als beteiligte Person (\\texttt{teilnehmer = true}) bzw- Ansprechpartner (\\texttt{teilnehmer = false}) gekennzeichnet und \\texttt{spr_uebvar_id = 0} sein.
'  );





--
-- -----------------------------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------------------------
--







-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------
--				----------------------------------------------------------
-- 	prj.nimm__tabwerte(...)	----------------------------------------------------------
--				----------------------------------------------------------
-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION prj.nimm__tabwerte( IN tabname varchar, IN tabwerte varchar[], OUT tabid varchar ) AS
$$
DECLARE
--------------------------------------------------------------------------------
-- Konstanten
--------------------------------------------------------------------------------


--------------------------------------------------------------------------------
-- lokale Variablen
--------------------------------------------------------------------------------
--
-- temporäre Ganzzahlvariable(n)
--
tmpInteger integer;
--
-- Grenzen
--
uGoG integer[];
--
-- Liste der Spaltennamen
--
spNamen varchar[];
--
-- Tabellenwerte müssen veränderbar sein
--
tabwerteIntern varchar[];


BEGIN

--
-- 0. Tabellenwerte übernehmen
--
tabwerteIntern := tabwerte;


--
-- 1.)	Tabname einlesen / prüfen
--
tmpInteger := array_upper( tabwerte, 1 );
IF(
	tabname='p_dokstrkt'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '4' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'dok_doku_id'
			, 'dok_strkt_id'
			, 'notizen'
			];




ELSIF(
	tabname='p_prtstrstrkt'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '4' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'prt_protokoll_id'
			, 'str_strkt_id'
			, 'notizen'
			];


ELSIF(
	tabname='p_prtverbindung'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '4' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'prt_protokoll_id_nachf'
			, 'prt_protokoll_id_vorg'
			, 'notizen'
			];


ELSIF(
	tabname='personen'
  )
THEN

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '4' ];
	spNamen := ARRAY[
			'intern_firma_id'
			, 'name_n'
			, 'name_v'
			, 'notizen'
			];


ELSIF(
	tabname='pl_dokausgabe'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'bw', tabwerte[3], NULL, NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Plausibilitätsprüfung ab tabwerte[5]
	--
	IF(
		NOT( tmpInteger < 5 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'du', tabwerte[5], NULL, NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[5]' );
	END IF;

	--
	-- Plausibilitätsprüfung ab tabwerte[6]
	--
	IF(
		NOT( tmpInteger < 6 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'bw', tabwerte[6], NULL, NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[6]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '2', '11' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'dok_doku_id'
			, 'logentfernt'
			, 'stand'
			, 'datum'
			, 'istfrei'
			, 'notizen'
			, 'logdatuhrz'
			, 'logdquelle'
			, 'logname'
			, 'logdqok'
			];


ELSIF(
	tabname='pl_prtpsgefszenario'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '9' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'ps_gefszenario_id'
			, 'prt_protokoll_id'
			, 'notizen'
			, 'logentfernt'
			, 'logdatuhrz'
			, 'logdquelle'
			, 'logname'
			, 'logdqok'
			];


ELSIF(
	tabname='pl_psgefstrkt'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '9' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'ps_gefszenario_id'
			, 'str_strkt_id'
			, 'notizen'
			, 'logentfernt'
			, 'logdatuhrz'
			, 'logdquelle'
			, 'logname'
			, 'logdqok'
			];


ELSIF(
	tabname='pl_psgefabk'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'bw', tabwerte[3], NULL, NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Plausibilitätsprüfung tabwerte[4]
	--
	IF(
		NOT( tmpInteger < 4 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[4], '0', NULL
						, 'prj.nimm__tabwerte(...)'
						, tabname || '.tabwerte[4]' );
	END IF;
	--
	-- Plausibilitätsprüfung tabwerte[5]
	--
	IF(
		NOT( tmpInteger < 5 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[5], '0', NULL
						, 'prj.nimm__tabwerte(...)'
						, tabname || '.tabwerte[5]' );
	END IF;


	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '4', '10' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'ps_gefszenario_id'
			, 'logentfernt'
			, 'ps_abk_id'
			, 'spr_uebvar_id_zus'
			, 'notizen'
			, 'logdatuhrz'
			, 'logdquelle'
			, 'logname'
			, 'logdqok'
			];


ELSIF(
	tabname='pl_psgefanm'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'bw', tabwerte[3], NULL, NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Plausibilitätsprüfung ab tabwerte[4]
	--
	IF(
		NOT( tmpInteger < 4 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[4], '0', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[4]' );
	END IF;

	--
	-- Plausibilitätsprüfung ab tabwerte[5]
	--
	IF(
		NOT( tmpInteger < 5 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[5], '0', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[5]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '5', '10' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'ps_gefszenario_id'
			, 'logentfernt'
			, 'ps_anmerkung_id'
			, 'spr_uebvar_id'
			, 'notizen'
			, 'logdatuhrz'
			, 'logdquelle'
			, 'logname'
			, 'logdqok'
			];


ELSIF(
	tabname='ppl_dokdoku'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Plausibilitätsprüfung ab tabwerte[4]
	--
	IF(
		NOT( tmpInteger < 4 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'bw', tabwerte[4], NULL, NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[4]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '9' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'dok_doku_id'
			, 'prj_personen_id'
			, 'logentfernt'
			, 'notizen'
			, 'logdatuhrz'
			, 'logdquelle'
			, 'logname'
			, 'logdqok'
			];


--
-- 1.1.) Protokolleintrag einem Projekt zuordnen bzw. projektspezifisch modifizieren
--
--	vorübergehend deaktiviert !
--
--ELSIF(
--	tabname='pp_prtprotokoll'
--  )
--THEN
--
--	--
--	-- Plausibilitätsprüfung ab tabwerte[3]
--	--
--	IF(
--		NOT( tmpInteger < 3 )
--	  ) 
--	THEN
--		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '0', NULL
--					, 'prj.nimm__tabwerte(...)'
--					, tabname || '.tabwerte[3]' );
--	END IF;
--
--	IF(
--		NOT( tmpInteger < 4 )
--	  ) 
--	THEN
--		EXECUTE intern.pruefe__dt( 'du', tabwerte[4], NULL, NULL
--					, 'prj.nimm__tabwerte(...)'
--					, tabname || '.tabwerte[4]' );
--	END IF;
--
--	IF(
--		NOT( tmpInteger < 5 )
--	  ) 
--	THEN
--		EXECUTE intern.pruefe__dt( 'bw', tabwerte[5], NULL, NULL
--					, 'prj.nimm__tabwerte(...)'
--					, tabname || '.tabwerte[5]' );
--	END IF;
--
--	IF(
--		NOT( tmpInteger < 6 )
--	  ) 
--	THEN
--		EXECUTE intern.pruefe__dt( 'bw', tabwerte[6], NULL, NULL
--					, 'prj.nimm__tabwerte(...)'
--					, tabname || '.tabwerte[6]' );
--	END IF;
--
--	--
--	-- Werte zuweisen
--	--
--	uGoG := ARRAY[ '3', '7' ];
--	spNamen := ARRAY[
--			'prj_projekte_id'
--			, 'prt_protokoll_id'
-- 			, 'spr_uebvar_id'
--			, 'datuhrz'
--			, 'intern'
--			, 'erledigt'
--			, 'notizen'
--			];
--
--
---- 1.2.) dem Protokolleintrag die beteiligten Personen zuordnen
---- 1.3.) der Protokolleintrag ist eine Frage / Aufgabe
--ELSIF(
--	tabname='pp_prtprotokoll_pers'
--  )
--THEN
--
--	--
--	-- Plausibilitätsprüfung ab tabwerte[3]
--	--
--	IF(
--		NOT( tmpInteger < 3 )
--	  ) 
--	THEN
--		EXECUTE intern.pruefe__dt( 'bw', tabwerte[3], NULL, NULL
--					, 'prj.nimm__tabwerte(...)'
--					, tabname || '.tabwerte[3]' );
--	END IF;
--
--	IF(
--		NOT( tmpInteger < 4 )
--	  ) 
--	THEN
--		EXECUTE intern.pruefe__dt( 'gz', tabwerte[4], '1', NULL
--					, 'prj.nimm__tabwerte(...)'
--					, tabname || '.tabwerte[4]' );
--	END IF;
--
--	IF(
--		NOT( tmpInteger < 5 )
--	  ) 
--	THEN
--		EXECUTE intern.pruefe__dt( 'du', tabwerte[5], NULL, NULL
--					, 'prj.nimm__tabwerte(...)'
--					, tabname || '.tabwerte[5]' );
--	END IF;
--
--	IF(
--		NOT( tmpInteger < 6 )
--	  ) 
--	THEN
--		EXECUTE intern.pruefe__dt( 'du', tabwerte[6], NULL, NULL
--					, 'prj.nimm__tabwerte(...)'
--					, tabname || '.tabwerte[6]' );
--	END IF;
--
--	--
--	-- Teilnehmer / Frage behandeln
--	--
--	IF(
--		( tmpInteger > 4 )
--		AND ( CAST( tabwerte[3] AS boolean ) = true )
--	  ) 
--	THEN
--		RAISE EXCEPTION 'prj.nimm__tabwerte(...)	Wenn >tabwerte[3] = true< ist, darf >tabwerte[5]< und >tabwerte[6]< nicht angegeben werden. Das Einlesen wird abgebrochen !';
--	END IF;
--
--	IF(
--		( tmpInteger > 3 )
--		AND ( tmpInteger < 5 )
--		AND ( CAST( tabwerte[3] AS boolean ) = false )
--	  ) 
--	THEN
--		RAISE EXCEPTION 'prj.nimm__tabwerte(...)	Wenn >tabwerte[3] = false< ist, muß >tabwerte[5]< angegeben werden. Das Einlesen wird abgebrochen !';
--	END IF;
--
--
--	--
--	-- Werte zuweisen
--	--
--	uGoG := ARRAY[ '4', '7' ];
--	spNamen := ARRAY[
--			'prj_projekte_id'
--			, 'prt_protokoll_id'
--			, 'teilnehmer'
--			, 'prj_personen_id'
--			, 'termin'
--			, 'duanfrage'
--			, 'notizen'
--			];
--
--
ELSIF(
	tabname='pp_psgefszenario'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '0', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );

	IF(
		NOT( tmpInteger < 4 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[4], '0', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[4]' );
	END IF;

	IF(
		NOT( tmpInteger < 5 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[5], '0', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[5]' );
	END IF;

	IF(
		NOT( tmpInteger < 6 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[6], '0', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[6]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '7' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'ps_gefszenario_id'
			, 'prj_personen_id'
			, 'spr_uebvar_id'
			, 'spr_uebvar_id_reprgefszen'
			, 'spr_uebvar_id_ursp'
			, 'notizen'
			];


ELSIF(
	tabname='pp_strstrkt'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );

	IF(
		NOT( tmpInteger < 4 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[4], '0', NULL
						, 'prj.nimm__tabwerte(...)'
						, tabname || '.tabwerte[4]' );
	END IF;

	IF(
		NOT( tmpInteger < 5 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[5], '0', NULL
						, 'prj.nimm__tabwerte(...)'
						, tabname || '.tabwerte[5]' );
	END IF;

	IF(
		NOT( tmpInteger < 6 )
	  ) 
	THEN
		EXECUTE str.pruefe__fbwerte( 'FB-Ereignis', tabwerte[6]
						, 'prj.nimm__tabwerte(...)'
						, 'tabwerte[6]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '7' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'str_strkt_id'
			, 'prj_personen_id'
			, 'spr_uebvar_id'
			, 'spr_uebvar_id_zus'
			, 'fbereignis'
			, 'notizen'
			];


ELSIF(
	tabname='pl_prtdokdoku'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Plausibilitätsprüfung ab tabwerte[5]
	--
	IF(
		NOT( tmpInteger < 5 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[5], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[5]' );
	END IF;

	--
	-- Plausibilitätsprüfung ab tabwerte[6]
	--
	IF(
		NOT( tmpInteger < 6 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'bw', tabwerte[6], NULL, NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[6]' );
	END IF;

	--
	-- Plausibilitätsprüfung ab tabwerte[7]
	--
	IF(
		NOT( tmpInteger < 7 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[7], '0', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[7]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '5', '12' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'dok_doku_id'
			, 'prt_protokoll_id'
			, 'nr'
			, 'spr_uebvar_id'
			, 'logentfernt'
			, 'spr_uebvar_id_zus'
			, 'notizen'
			, 'logdatuhrz'
			, 'logdquelle'
			, 'logname'
			, 'logdqok'
			];


ELSIF(
	tabname='projekte'
  )
THEN
	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '2', '4' ];
	spNamen := ARRAY[
			'prjname'
			, 'prjbeschr'
			, 'makefile'
			, 'notizen'
			];


ELSIF(
	tabname='p_psabk'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;


	IF(
		NOT( tmpInteger < 4 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[4], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[4]' );
	END IF;


	IF(
		NOT( tmpInteger < 5 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[5], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[5]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '2', '6' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'ps_abk_id'
			, 'spr_uebvar_id'
			, 'spr_uebvar_id_l'
			, 'spr_uebvar_id_zus'
			, 'notizen'
			];


ELSIF(
	tabname='p_strverbindung'
  )
THEN

	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	IF(
		NOT( tmpInteger < 4 )
	  ) 
	THEN
		EXECUTE str.pruefe__fbwerte( 'FB-Tor', tabwerte[4]
						, 'prj.nimm__tabwerte(...)'
						, 'tabwerte[4]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '5' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'str_strkt_id_vorg'
			, 'str_strkt_id_nachf'
			, 'fbtor'
			, 'notizen'
			];


ELSE

	--
	-- Fehlermeldung. Es dürfen nur die im Schema >prj< verfügbaren Tabellennamen verwendet 
	-- werden
	--
	RAISE EXCEPTION 'prj.nimm__tabwerte(...)	Der übergebene Tabellenname  >tabname = %', 
		CASE WHEN( tabname IS NULL ) THEN 'NULL' ELSE tabname END
		 || '< ist nicht zulässig. Es dürfen nur die im Schema >prj< enthaltenen Tabellennamen verwendet werden. Das Einlesen wird abgebrochen !';

END IF;



--
-- 2.1)	Plausibilitätsprüfungen für alle Tabellen
--	- Listengröße
--
EXECUTE intern.pruefe__array( tabwerte, uGoG[1], uGoG[2]
				, 'prj.nimm__tabwerte(...)'
				, tabname || '.tabwerte' );

--
-- 2.2)	Plausibilitätsprüfungen für alle Tabellen außer >prj.projekte<
--	- tabwerte[1]
--	- tabwerte[2] (außer >prj.personen<)
--
IF(
	tabname != 'projekte'
  )
THEN

	--
	-- >tabwerte[1]< muß mindestens  >0< sein.
	--
	EXECUTE intern.pruefe__dt( 'gz', tabwerte[1], '0', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[1]' );

	IF(
		tabname != 'personen'
	  )
	THEN

		--
		-- >tabwerte[2]< muß mindestens  >1< sein.
		--
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[2], '1', NULL
						, 'prj.nimm__tabwerte(...)'
						, tabname || '.tabwerte[2]' );

	END IF;

END IF;


--
-- 2.3)	Bei allen Tabellen mit Logbuchfunktion, das Wiederverwenden von Zeilen mittels
--	expliziten Setzen von >logdatuhrz< deaktivieren
--
--	Bei der Übergabe von Werten, die unterhalb >logdatuhrz< liegen, wird >logdatuhrz<
--	automatisch ergänzt
--
--	ACHTUNG ! hier wird das veränderbare Array >tabwerteIntern< gesetzt
--

-- pl_prtpsgefszenario < 6
-- pl_psgefstrkt < 6
-- ppl_dokdoku < 6

-- pl_psgefabk < 7
-- pl_psgefanm < 7

-- pl_dokausgabe < 8

-- pl_prtdokdoku < 9

IF(
	( ( tabname= 'pl_prtpsgefszenario' OR tabname='pl_psgefstrkt' OR tabname='ppl_dokdoku' ) AND ( tmpInteger < 6 ) )
	OR ( ( tabname='pl_psgefabk' OR tabname='pl_psgefanm' ) AND ( tmpInteger < 7 ) )
	OR ( ( tabname='pl_dokausgabe' ) AND ( tmpInteger < 8 ) )
	OR ( tabname='pl_prtdokdoku' AND ( tmpInteger < 9 ) )
  ) 
THEN
	--
	-- Spaltennamen und Wert ergänzen / >tmpInteger< hochzählen
	--
	tmpInteger := tmpInteger + 1;
	spNamen[tmpInteger] := 'logdatuhrz';
	tabwerteIntern := tabwerteIntern || CAST( timeofday() AS varchar );
END IF;


--
-- 3.)	Tabname einlesen
--		- >spNamen[1]< immer vorhanden
--		- >spNamen[2]< immer vorhanden
--		- >spNamen[3 ... 11]< ggf. vorhanden
--
--		- ab hier statt >tabwerte< das veränderbare Array >tabwerteIntern< verwenden
--
EXECUTE
	'SELECT intern.nimm__zeile( ''prj.' 
				|| CASE WHEN( tabname = 'pp_prtprotokoll_pers' ) 
					THEN 'pp_prtprotokoll' ELSE tabname END
				|| ''', ARRAY[ ''' || spNamen[1] || '''
				, ''' || spNamen[2] || ''''
				|| CASE WHEN( NOT( tmpInteger < 3 ) )
					THEN ', ''' || spNamen[3] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 4 ) )
					THEN ', ''' || spNamen[4] ||  '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 5 ) )
					THEN ', ''' || spNamen[5] ||  '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 6 ) )
					THEN ', ''' || spNamen[6] ||  '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 7 ) )
					THEN ', ''' || spNamen[7] ||  '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 8 ) )
					THEN ', ''' || spNamen[8] ||  '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 9 ) )
					THEN ', ''' || spNamen[9] ||  '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 10 ) )
					THEN ', ''' || spNamen[10] ||  '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 11 ) )
					THEN ', ''' || spNamen[11] ||  '''' ELSE '' END
				|| ']
			, ARRAY[''' 	|| tabwerteIntern[1] || '''
				, '''	|| tabwerteIntern[2] || ''''
				|| CASE WHEN( NOT( tmpInteger < 3 ) )
					THEN ', ''' || tabwerteIntern[3] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 4 ) )
					THEN ', ''' || tabwerteIntern[4] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 5 ) )
					THEN ', ''' || tabwerteIntern[5] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 6 ) )
					THEN ', ''' || tabwerteIntern[6] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 7 ) )
					THEN ', ''' || tabwerteIntern[7] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 8 ) )
					THEN ', ''' || tabwerteIntern[8] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 9 ) )
					THEN ', ''' || tabwerteIntern[9] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 10 ) )
					THEN ', ''' || tabwerteIntern[10] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 11 ) )
					THEN ', ''' || tabwerteIntern[11] || '''' ELSE '' END
				|| '])'
INTO tabid;


END
$$LANGUAGE 'plpgsql'  VOLATILE;
SELECT intern.nimm__TLKommentarFunktion( 'prj.nimm__tabwerte( IN tabname varchar, IN tabwerte varchar[], OUT tabid varchar )',
ARRAY[
E'Name der Tabelle (ohne Schemanamen) des Schemas \\texttt{prj}, welche die Werte übernehmen soll  (Details siehe Funktionsbeschreibung --- Werteliste einlesen).'
, E'Liste der Werte, welche in die aktuelle Tabelle eingelesen werden sollen (Details siehe Funktionsbeschreibung --- Werteliste einlesen).'
, E'Es wird die Identifikationsnummer des aktuell eingelesenen Wertes \\texttt{prj.*.id} zurückgegeben.'
],
E'Mittels dieser Funktion werden in die Tabellen des Schemas \\texttt{prj} die Werte eingelesen.
\\\\
\\\\
Werteliste einlesen:\\\\
Dem Funktionsparameter \\texttt{tabwerte} ist eine Werteliste (\\texttt{ARRAY}) zu übergeben (die maximale Anzahl und die Reihenfolge der Werte ist fest vorgegeben --- siehe oben). Soll nur eine Teilmenge der Werte übergeben werden, dann sind alle Werte von links nach rechts zu spezifizieren (nichtbenötigte Werte am Ende der Liste dürfen weggelassen werden).
\\\\
\\\\
\\noindent \\textbf{personen}

\\begin{enumerate}
  \\item \\texttt{intern_firma_id}
  \\item \\texttt{name_n}
  \\item \\texttt{name_v}
  \\item \\texttt{notizen}
\\end{enumerate}
Es müssen mindestens die ersten drei Werte übergeben werden. Der erste Wert muß größer \\texttt{0} sein.
\\\\
\\\\
\\noindent \\textbf{projekte}

\\begin{enumerate}
  \\item \\texttt{prjname}
  \\item \\texttt{prjbeschr}
  \\item \\texttt{makefile}
  \\item \\texttt{notizen}
\\end{enumerate}
Es müssen mindestens die ersten beiden Werte übergeben werden.
\\\\
\\\\
\\textbf{p_dokstrkt, p_prtstrstrkt, p_prtverbindung, \\\\p_psabk, p_strverbindung}

\\begin{enumerate}
  \\item \\texttt{prj_projekte_id}
  \\item \\texttt{dok_doku_id, prt_protokoll_id, prt_protokoll_id_nachf, \\\\ps_abk_id, str_strkt_id_vorg}
  \\item \\texttt{dok_strkt_id, str_strkt_id, prt_protokoll_id_vorg, \\\\spr_uebvar_id, str_strkt_id_nachf}
  \\item \\texttt{notizen, notizen, notizen, \\\\spr_uebvar_id_l, fbtor}
  \\item \\texttt{---, ---, ---, \\\\spr_uebvar_id_zus, notizen}
  \\item \\texttt{---, ---, ---, \\\\notizen, ---}
\\end{enumerate}
Es müssen mindestens die ersten drei Werte übergeben werden. \\texttt{prj_projekte_id} darf \\texttt{0} sein, die anderen beiden Werte müssen größer \\texttt{0} sein.
\\\\
\\\\
\\noindent \\textbf{pl_dokausgabe, pl_prtdokdoku, pl_prtpsgefszenario, \\\\pl_psgefabk, pl_psgefanm, pl_psgefstrkt}

\\begin{enumerate}
  \\item \\texttt{prj_projekte_id}
  \\item \\texttt{dok_doku_id, dok_doku_id, ps_gefszenario_id, \\\\ps_gefszenario_id, ps_gefszenario_id, ps_gefszenario_id}
  \\item \\texttt{logentfernt, prt_protokoll_id, prt_protokoll_id, \\\\logentfernt, logentfernt, str_strkt_id}
  \\item \\texttt{stand, nr, notizen, \\\\ps_abk_id, ps_anmerkung_id, notizen}
  \\item \\texttt{datum, spr_uebvar_id, logentfernt, \\\\spr_uebvar_id_zus, spr_uebvar_id, logentfernt}
  \\item \\texttt{istfrei, logentfernt, logdatuhrz, \\\\notizen, notizen, logdatuhrz}
  \\item \\texttt{notizen, spr_uebvar_id_zus, logdquelle, \\\\logdatuhrz, logdatuhrz, logdquelle}
  \\item \\texttt{logdatuhrz, notizen, logname, \\\\logdquelle, logdquelle, logname}
  \\item \\texttt{logdquelle, logdatuhrz, logdqok, \\\\logname, logname, logdqok}
  \\item \\texttt{logname, logdquelle, ---, \\\\logdqok, logdqok, ---}
  \\item \\texttt{logdqok, logname, ---, \\\\---, ---, ---}
  \\item \\texttt{---, logdqok, ---, \\\\---, ---, ---}
\\end{enumerate}
Es müssen mindestens die ersten beiden Werte übergeben werden. \\texttt{prj_projekte_id} darf \\texttt{0} sein, der andere Wert muß größer \\texttt{0} sein.
Bei diesen Tabellen (Tabellen mit Logbuchfunktion) wird nicht nach bereits eingelesenen Einträgen gesucht. Somit ist es möglich mehrfach dieselben Einträge einzulesen. 
\\\\
\\\\
\\noindent \\textbf{pp_prtprotokoll, pp_prtprotokoll_pers (beide z.Zt. inaktiv), pp_psgefszenario, \\\\ pp_strstrkt, ppl_dokdoku}

\\begin{enumerate}
  \\item \\texttt{prj_projekte_id}
  \\item \\texttt{prt_protokoll_id, prt_protokoll_id, ps_gefszenario_id, \\\\ str_strkt_id, dok_doku_id}
  \\item \\texttt{spr_uebvar_id, teilnehmer, prj_personen_id, \\\\ prj_personen_id, prj_personen_id}
  \\item \\texttt{datuhrz, prj_personen_id, spr_uebvar_id, \\\\ spr_uebvar_id, logentfernt}
  \\item \\texttt{intern, termin, spr_uebvar_id_reprgefszen, \\\\ spr_uebvar_id_zus, notizen} Für die Spalten \\texttt{spr_uebvar_id_fzg} und \\texttt{spr_uebvar_id} muß der Wert größer  \\texttt{0} sein.
  \\item \\texttt{erledigt, duanfrage, spr_uebvar_id_ursp, \\\\ fbereignis, logdatuhrz}
  \\item \\texttt{notizen, notizen, notizen, \\\\ notizen, logdquelle}
  \\item \\texttt{---, ---, ---, \\\\ ---, logname }
  \\item \\texttt{---, ---, ---, \\\\ ---, logdqok }
\\end{enumerate}
Bei den Tabellen \\texttt{ppl_dokdoku} müssen die ersten drei und bei den Tabellen \\texttt{pp_psgefszenario, pp_strstrkt} die ersten zwei Werte übergeben werden. \\texttt{prj_projekte_id} darf \\texttt{0} sein, die anderen Drei bzw. Zwei Werte müssen größer \\texttt{0} sein.
\\\\
Bei der Tabelle \\texttt{pl_prtdokdoku} müssen die ersten fünf Werte übergeben werden.
\\\\
\\\\
Die Tabelle \\texttt{pp_prtprotokoll} deckt drei Aspekte ab:
\\begin{enumerate}
  \\item Protokolleintrag einem Projekt zuordnen, projektspezifisch modifizieren und Randbedingungen setzen (\\texttt{pp_prtprotokoll} wählen);
  \\item dem Protokolleintrag die beteiligten Personen zuordnen (\\texttt{pp_prtprotokoll_pers} wählen);
  \\item dem Protokolleintrag der eine Frage / Aufgabe ist, die relevanten Informationen zuordnen (\\texttt{pp_prtprotokoll_pers} wählen);
\\end{enumerate}
wobei ein Protokolleintrag ein Gefahrenprotokolleintrag, eine Sicherheitsüberprüfung oder ein Terminplaneintrag (je nach Sinnfälligkeit) sein kann.
\\\\
Zur Unterscheidung der drei Aspekte werden die Spalten \\texttt{prj_personen_id} und \\texttt{teilnehmer} verwendet. Es gilt für
\\begin{enumerate}
  \\item \\texttt{prj_personen_id = 0} und \\texttt{teilnehmer = NULL}
  \\item \\texttt{prj_personen_id > 0} und \\texttt{teilnehmer = true}
  \\item \\texttt{prj_personen_id > 0} und \\texttt{teilnehmer = false}
\\end{enumerate}
Die Spalten der Tabelle \\texttt{pp_prtprotokoll} werden zur Abbildung der drei Aspekte wie folgt verwendet:  \\\\
 \\texttt{notizen ........... 1} \\\\
 \\texttt{datuhrz ........... 1} \\\\
 \\texttt{duanfrage ............. 3} \\\\
 \\texttt{erledigt .......... 1} \\\\
 \\texttt{intern ............ 1} \\\\
 \\texttt{prj_personen_id ..... 2 3} \\\\
 \\texttt{prj_projekte_id ... 1 2 3} \\\\
 \\texttt{prt_protokoll_id .. 1 2 3} \\\\
 \\texttt{spr_uebvar_id ..... 1} \\\\
 \\texttt{teilnehmer .......... 2 3} \\\\
 \\texttt{termin ................ 3}
'
, ARRAY[
E'ACTUNG ! Die Beispiele sind nicht aktualisiert --- muß später bereinit werden.'
, E'-- Fehlermeldung. Ungültige Tabelle !\\\\SELECT * FROM prj.nimm__tabwerte( NULL, NULL );'
, E'-- Fehlermeldung. Bei allen Tabellen müssen mindestens zwei Elemente übergeben werden\\\\SELECT * FROM prj.nimm__tabwerte( ''projekte'', ARRAY[''1''] );'
, E'-- Fehlermeldung. Die übergebenen Parameter müssen größer \\texttt{0} sein.\\\\SELECT * FROM prj.nimm__tabwerte( ''p_dokkomp'', ARRAY[''0'', ''1''] );\\\\SELECT * FROM prj.nimm__tabwerte( ''p_dokkomp'', ARRAY[''1'', ''0''] );\\\\SELECT * FROM prj.nimm__tabwerte( ''pl_psgefanm'', ARRAY[''1'', ''1'', ''0''] );\\\\SELECT * FROM prj.nimm__tabwerte( ''ppu_kmpkomp'', ARRAY[''1'', ''1'', ''1'', '''', ''0''] );\\\\SELECT * FROM prj.nimm__tabwerte( ''pp_prtprotokoll'', ARRAY[''1'', ''1'', ''1'', '''', '''', '''', '''', '''', '''', ''0''] );'
, E'-- Fehlermeldung. Es dürfen nur die zulässigen Begriffe verwendet werden\\\\SELECT * FROM prj.nimm__tabwerte( ''pp_strstrkt'', ARRAY[''1'', ''22'', ''1'', ''99'', ''ttt''] );\\\\SELECT * FROM prj.nimm__tabwerte( ''p_strverbindung'', ARRAY[''1'', ''1'', ''ttt''] );'

, E'-- \\texttt{prj.projekte} einlesen\\\\SELECT * FROM prj.projekte;\\\\SELECT * FROM prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt'', ''Inhalt des makefile'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.projekte;'
, E'-- \\texttt{dok.*} einlesen\\\\SELECT * FROM prj.pp_dokausgabe;\\\\SELECT * FROM prj.nimm__tabwerte( ''pp_dokausgabe'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), dok.nimm__tabwerte( ''ausgabe'', ARRAY[ dok.nimm__doku( ARRAY[''08-15'', ''1''] ), ''01''] ), prj.nimm__tabwerte( ''personen'', ARRAY[''1'', ''Bellair'', ''Michael''] ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pp_dokausgabe;\\\\SELECT * FROM prj.p_dokkomp;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_dokkomp'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), dok.nimm__tabwerte( ''komp'', ARRAY[dok.nimm__doku( ARRAY[''08-15'', ''1''] ), kmp.nimm__komp( ARRAY[''1'', ''47/11''] )] ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_dokkomp;\\\\SELECT * FROM prj.p_dokstrkt;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_dokstrkt'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), dok.nimm__tabwerte( ''strkt'', ARRAY[dok.nimm__doku( ARRAY[''08-15'', ''1''] ), str.nimm__strkt( ARRAY[''1'', ''-BAAA'', spr.nimm__wgruppe( ''Strukturpunkt'', ''1'', ''0'' )] )] ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_dokstrkt;'
, E'-- \\texttt{kmp.*} einlesen\\\\SELECT * FROM prj.ppu_kmpkomp;\\\\SELECT * FROM prj.nimm__tabwerte( ''ppu_kmpkomp'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), kmp.nimm__komp( ARRAY[''1'', ''08-15''] ), prj.nimm__tabwerte( ''personen'', ARRAY[''1'', ''Bellair'', ''Michael''] ), ''kmp-id-fzg'', spr.nimm__wgruppe( ''Komponentenbezeichnung-Fahrezeughersteller'', ''1'', ''0'' ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.ppu_kmpkomp;\\\\SELECT * FROM prj.p_kmpstrkt;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_kmpstrkt'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), kmp.nimm__strkt( ARRAY[kmp.nimm__komp( ARRAY[''1'', ''08-15''] ), str.nimm__strkt( ARRAY[''1'', ''-BAAA'', spr.nimm__wgruppe( ''Strukturpunkt'', ''1'', ''0'' )] ), ''Zusatzinformationen''] ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_kmpstrkt;'
, E'-- \\texttt{prt.*} einlesen\\\\SELECT * FROM prj.p_prtdokausgabe;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_prtdokausgabe'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), prt.nimm__tabwerte( ''dokausgabe'', ARRAY[prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( ''Aktueller Protokolleintrag.'', ''1'', ''0'' ), ''PE_OK''] ), dok.nimm__tabwerte( ''ausgabe'', ARRAY[ dok.nimm__doku( ARRAY[''08-15'', ''1''] ), ''01''] ), ''Zusatzinformationen''] ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_prtdokausgabe;\\\\SELECT * FROM prj.p_prtkomp;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_prtkomp'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), prt.nimm__tabwerte( ''komp'', ARRAY[prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( ''Aktueller Protokolleintrag.'', ''1'', ''0'' ), ''PE_OK''] ), kmp.nimm__komp( ARRAY[''1'', ''47/11''] )] ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_prtkomp;\\\\SELECT * FROM prj.pp_prtprotokoll;\\\\SELECT * FROM prj.nimm__tabwerte( ''pp_prtprotokoll'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( ''Aktueller Protokolleintrag.'', ''1'', ''0'' ), ''PE_OK''] ), prj.nimm__tabwerte( ''personen'', ARRAY[''1'', ''Bellair'', ''Michael''] ), ''true'', ''2007-06-08'', ''2007-06-20'', ''2007-07-07'', ''true'', ''true'', spr.nimm__wgruppe( ''Projektabhängiger, aktueller Protokolleintrag.'', ''1'', ''0'' ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pp_prtprotokoll;\\\\SELECT * FROM prj.p_prtstrstrkt;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_prtstrstrkt'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), prt.nimm__tabwerte( ''strkt'', ARRAY[prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( ''Aktueller Protokolleintrag.'', ''1'', ''0'' ), ''PE_OK''] ), str.nimm__strkt( ARRAY[''1'', ''-BAAA'', spr.nimm__wgruppe( ''Strukturpunkt'', ''1'', ''0'' )])]), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_prtstrstrkt;\\\\SELECT * FROM prj.p_prtverbindung;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_prtverbindung'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), prt.nimm__tabwerte( ''verbindung'', ARRAY[prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( ''Aktueller Protokolleintrag.'', ''1'', ''0'' ), ''PE_OK''] ), prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( ''Zugeordneter Aktueller Protokolleintrag.'', ''1'', ''0'' ), ''PE_OK''] )]), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_prtverbindung;'
, E'-- \\texttt{ps.*} einlesen\\\\SELECT * FROM prj.p_psabk;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_psabk'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), ps.nimm__abk( ARRAY[spr.nimm__wgruppe( ''abk'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Abkürzung'', ''1'', ''0'' ), ''BP''] ), spr.nimm__wgruppe( ''projabk'', ''1'', ''0'' ), spr.nimm__wgruppe( ''projektabhängige Abkürzung'', ''1'', ''0'' ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_psabk;\\\\SELECT * FROM prj.pl_psgefabk;\\\\SELECT * FROM prj.nimm__tabwerte( ''pl_psgefabk'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), ps.nimm__aspekte( ''gefabk'', ARRAY[ ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( ''Gefahrenszenario'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Ursprung des Gefahrenszenarios'', ''1'', ''0'' )] ), ps.nimm__abk( ARRAY[spr.nimm__wgruppe( ''abk'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Abkürzung'', ''1'', ''0'' ), ''BP''] )] ), ''2007-06-06'', ''datenquelle'', ''micha'', ''true'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pl_psgefabk;\\\\SELECT * FROM prj.pl_psgefanm;\\\\SELECT * FROM prj.nimm__tabwerte( ''pl_psgefanm'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ),  ps.nimm__aspekte( ''gefanm'', ARRAY[ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( ''Gefahrenszenario'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Ursprung des Gefahrenszenarios'', ''1'', ''0'' )] ), spr.nimm__wgruppe( ''Anmerkungen'', ''1'', ''0'' )] ), spr.nimm__wgruppe( ''projektspezifische Anmerkungen'', ''1'', ''0'' ), ''true'', ''2007-06-06'', ''datenquelle'', ''micha'', ''true'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pl_psgefanm;\\\\SELECT * FROM prj.pl_psgefkomp;\\\\SELECT * FROM prj.nimm__tabwerte( ''pl_psgefkomp'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), ps.nimm__aspekte( ''gefkomp'', ARRAY[ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( ''Gefahrenszenario'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Ursprung des Gefahrenszenarios'', ''1'', ''0'' )] ), kmp.nimm__komp( ARRAY[''1'',''08-15''] )] ), ''2007-06-06'', ''datenquelle'', ''micha'', ''true'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pl_psgefkomp;\\\\SELECT * FROM prj.pl_psgefnetz;\\\\SELECT * FROM prj.nimm__tabwerte( ''pl_psgefnetz'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ),  ps.nimm__aspekte( ''gefnetz'', ARRAY[ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( ''Gefahrenszenario'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Ursprung des Gefahrenszenarios'', ''1'', ''0'' )]), str.nimm__strkt( ARRAY[''1'', ''-BAAA'', spr.nimm__wgruppe( ''Strukturpunkt'', ''1'', ''0'' )])] ), ''2007-06-06'', ''datenquelle'', ''micha'', ''true'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pl_psgefnetz;\\\\SELECT * FROM prj.pl_prtpsgefszenario;\\\\SELECT * FROM prj.nimm__tabwerte( ''pl_prtpsgefszenario'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), ps.nimm__aspekte( ''gefprot'', ARRAY[ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( ''Gefahrenszenario'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Ursprung des Gefahrenszenarios'', ''1'', ''0'' )]), prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( ''Zugeordneter Aktueller Protokolleintrag.'', ''1'', ''0'' ), ''PE_OK''] )] ), ''true'', ''2007-06-06'', ''datenquelle'', ''micha'', ''true'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pl_prtpsgefszenario;\\\\SELECT * FROM prj.pl_psgefstrkt;\\\\SELECT * FROM prj.nimm__tabwerte( ''pl_psgefstrkt'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), ps.nimm__aspekte( ''gefstrkt'', ARRAY[ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( ''Gefahrenszenario'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Ursprung des Gefahrenszenarios'', ''1'', ''0'' )]), str.nimm__strkt( ARRAY[''1'', ''-BAAA'', spr.nimm__wgruppe( ''Strukturpunkt'', ''1'', ''0'' )])] ), ''true'', ''2007-06-06'', ''datenquelle'', ''micha'', ''true'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pl_psgefstrkt;\\\\SELECT * FROM prj.pp_psgefszenario;\\\\SELECT * FROM prj.nimm__tabwerte( ''pp_psgefszenario'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( ''Gefahrenszenario'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Ursprung des Gefahrenszenarios'', ''1'', ''0'' )]), prj.nimm__tabwerte( ''personen'', ARRAY[''1'', ''Bellair'', ''Michael''] ), spr.nimm__wgruppe( ''projektspezifisch formuliertes Gefahrenszenario'', ''1'', ''0'' ), spr.nimm__wgruppe( ''projektspezifisch formulierter Ursprung des Gefahrenszenarios'', ''1'', ''0'' ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pp_psgefszenario;'
, E'-- \\texttt{str.*} einlesen\\\\SELECT * FROM prj.pp_strstrkt;\\\\SELECT * FROM prj.nimm__tabwerte( ''pp_strstrkt'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), str.nimm__strkt( ARRAY[''1'', ''-BAAA'', spr.nimm__wgruppe( ''Strukturpunkt'', ''1'', ''0'' )]), prj.nimm__tabwerte( ''personen'', ARRAY[''1'', ''Bellair'', ''Michael''] ), spr.nimm__wgruppe( ''Strukturpunkt übersetzt ?'', ''1'', ''0'' ), ''HAUS'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pp_strstrkt;\\\\SELECT * FROM prj.p_strverbindung;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_strverbindung'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), str.nimm__verbindung( ARRAY[str.nimm__strkt( ARRAY[''1'', ''-BAAA1'', spr.nimm__wgruppe( ''Strukturpunkt-1'', ''1'', ''0'' )]), str.nimm__strkt( ARRAY[''1'', ''-BAAA2'', spr.nimm__wgruppe( ''Strukturpunkt-2'', ''1'', ''0'' )])] ), ''UND'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_strverbindung;'
]
);
--
-- Fehlermeldungen
-- ...............
--
--
--	-- Fehlermeldung. Ungültige Tabelle !
--SELECT * FROM prj.nimm__tabwerte( NULL, NULL );
--
--	-- Fehlermeldung. Bei allen Tabellen müssen mindestens zwei Elemente übergeben werden
--SELECT * FROM prj.nimm__tabwerte( 'projekte', ARRAY['1'] );
--
--	-- Fehlermeldung. Die übergebenen Parameter müssen größer \\texttt{0} sein.
--SELECT * FROM prj.nimm__tabwerte( 'p_dokkomp', ARRAY['0', '1'] );
--SELECT * FROM prj.nimm__tabwerte( 'p_dokkomp', ARRAY['1', '0'] );
--SELECT * FROM prj.nimm__tabwerte( 'pl_psgefanm', ARRAY['1', '1', '0'] );
--SELECT * FROM prj.nimm__tabwerte( 'pp_prtprotokoll', ARRAY['1', '1', '1', '', '', '', '', '', '', '0'] );
--
--	-- Fehlermeldung. Es dürfen nur die zulässigen Begriffe verwendet werden
--SELECT * FROM prj.nimm__tabwerte( 'pp_strstrkt', ARRAY['1', '22', '1', '99', 'ttt'] );
--SELECT * FROM prj.nimm__tabwerte( 'p_strverbindung', ARRAY['1', '1', 'ttt'] );
--
--
--
--
-- Standardverhalten:
-- ..................
--
--	-- \\texttt{prj.personen} einlesen
--SELECT * FROM prj.personen;
--SELECT * FROM prj.nimm__tabwerte( 'personen', ARRAY['1', 'Bellair', 'Auguste', 'Zusatzinformationen'] );
--SELECT * FROM prj.personen;
--
--
--	-- \\texttt{prj.projekte} einlesen
--SELECT * FROM prj.projekte;
--SELECT * FROM prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt', 'Inhalt des makefile', 'Zusatzinformationen'] );
--SELECT * FROM prj.projekte;
--
--
--
--	-- \\texttt{dok.*} einlesen
--SELECT * FROM prj.pp_dokausgabe;
--SELECT * FROM prj.nimm__tabwerte( 'pp_dokausgabe', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, dok.nimm__tabwerte( 'ausgabe', ARRAY[ dok.nimm__doku( ARRAY['08-15', '1'] ), '01'] )
--	, prj.nimm__tabwerte( 'personen', ARRAY['1', 'Bellair', 'Michael'] )
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.pp_dokausgabe;
--
--SELECT * FROM prj.p_dokkomp;
--SELECT * FROM prj.nimm__tabwerte( 'p_dokkomp', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, dok.nimm__tabwerte( 'komp', ARRAY[dok.nimm__doku( ARRAY['08-15', '1'] )
--					, kmp.nimm__komp( ARRAY['1', '47/11'] )] )
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.p_dokkomp;
--
--SELECT * FROM prj.p_dokstrkt;
--SELECT * FROM prj.nimm__tabwerte( 'p_dokstrkt', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, dok.nimm__tabwerte( 'strkt', ARRAY[dok.nimm__doku( ARRAY['08-15', '1'] )
--					, str.nimm__strkt( ARRAY['1', '-BAAA', spr.nimm__wgruppe( 'Strukturpunkt', '1', '0' )] )] )
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.p_dokstrkt;
--
--
--	-- \\texttt{prt.*} einlesen
--SELECT * FROM prj.p_prtdokausgabe;
--SELECT * FROM prj.nimm__tabwerte( 'p_prtdokausgabe', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, prt.nimm__tabwerte( 'dokausgabe', ARRAY[prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( 'Aktueller Protokolleintrag.', '1', '0' ), 'PE_OK'] ), dok.nimm__tabwerte( 'ausgabe', ARRAY[ dok.nimm__doku( ARRAY['08-15', '1'] ), '01'] ), 'Zusatzinformationen'] )
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.p_prtdokausgabe;
--
--SELECT * FROM prj.p_prtkomp;
--SELECT * FROM prj.nimm__tabwerte( 'p_prtkomp', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, prt.nimm__tabwerte( 'komp', ARRAY[prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( 'Aktueller Protokolleintrag.', '1', '0' ), 'PE_OK'] ), kmp.nimm__komp( ARRAY['1', '47/11'] )] )
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.p_prtkomp;
--
--SELECT * FROM prj.pp_prtprotokoll;
--SELECT * FROM prj.nimm__tabwerte( 'pp_prtprotokoll', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( 'Aktueller Protokolleintrag.', '1', '0' ), 'PE_OK'] )
--	, prj.nimm__tabwerte( 'personen', ARRAY['1', 'Bellair', 'Michael'] )
--	, 'true'
--	, '2007-06-08'
--	, '2007-06-20'
--	, '2007-07-07'
--	, 'true'
--	, 'true'
--	, spr.nimm__wgruppe( 'Projektabhängiger, aktueller Protokolleintrag.', '1', '0' )
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.pp_prtprotokoll;
--
--SELECT * FROM prj.nimm__tabwerte( 'pp_prtprotokoll', ARRAY['2', '1'] );
--SELECT * FROM prj.nimm__tabwerte( 'pp_prtprotokoll', ARRAY['1', '1', '0', '2008-12-18', 'false', 'true', 'Interne Notizen'] );
--SELECT * FROM prj.nimm__tabwerte( 'pp_prtprotokoll_pers', ARRAY['1', '1', 'false', '1', '2008-12-18', '2008-12-18', 'Interne Notizen'] );
--
--SELECT * FROM prj.p_prtstrstrkt;
--SELECT * FROM prj.nimm__tabwerte( 'p_prtstrstrkt', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, prt.nimm__tabwerte( 'strkt', ARRAY[prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( 'Aktueller Protokolleintrag.', '1', '0' ), 'PE_OK'] ), str.nimm__strkt( ARRAY['1', '-BAAA', spr.nimm__wgruppe( 'Strukturpunkt', '1', '0' )])])
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.p_prtstrstrkt;
--
--SELECT * FROM prj.p_prtverbindung;
--SELECT * FROM prj.nimm__tabwerte( 'p_prtverbindung', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, prt.nimm__tabwerte( 'verbindung', ARRAY[prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( 'Aktueller Protokolleintrag.', '1', '0' ), 'PE_OK'] ), prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( 'Zugeordneter Aktueller Protokolleintrag.', '1', '0' ), 'PE_OK'] )])
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.p_prtverbindung;
--
--
--	-- \\texttt{ps.*} einlesen
--SELECT * FROM prj.p_psabk;
--SELECT * FROM prj.nimm__tabwerte( 'p_psabk', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, ps.nimm__abk( ARRAY[spr.nimm__wgruppe( 'abk', '1', '0' ), spr.nimm__wgruppe( 'Abkürzung', '1', '0' ), 'BP'] )
--	, spr.nimm__wgruppe( 'projabk', '1', '0' )
--	, spr.nimm__wgruppe( 'projektabhängige Abkürzung', '1', '0' )
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.p_psabk;
--
--SELECT * FROM prj.pl_psgefabk;
--SELECT * FROM prj.nimm__tabwerte( 'pl_psgefabk', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, ps.nimm__aspekte( 'gefabk', ARRAY[ ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( 'Gefahrenszenario', '1', '0' ), spr.nimm__wgruppe( 'Ursprung des Gefahrenszenarios', '1', '0' )] ), ps.nimm__abk( ARRAY[spr.nimm__wgruppe( 'abk', '1', '0' ), spr.nimm__wgruppe( 'Abkürzung', '1', '0' ), 'BP'] )] )
--	, 'true'
--	, '2007-06-06'
--	, 'datenquelle'
--	, 'micha'
--	, 'true'
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.pl_psgefabk;
--
--SELECT * FROM prj.pl_psgefanm;
--SELECT * FROM prj.nimm__tabwerte( 'pl_psgefanm', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	,  ps.nimm__aspekte( 'gefanm', ARRAY[ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( 'Gefahrenszenario', '1', '0' ), spr.nimm__wgruppe( 'Ursprung des Gefahrenszenarios', '1', '0' )] ), spr.nimm__wgruppe( 'Anmerkungen', '1', '0' )] )
--	, spr.nimm__wgruppe( 'projektspezifische Anmerkungen', '1', '0' )
--	, 'true'
--	, '2007-06-06'
--	, 'datenquelle'
--	, 'micha'
--	, 'true'
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.pl_psgefanm;
--
--SELECT * FROM prj.pl_prtpsgefszenario;
--SELECT * FROM prj.nimm__tabwerte( 'pl_prtpsgefszenario', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, ps.nimm__aspekte( 'gefprot', ARRAY[ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( 'Gefahrenszenario', '1', '0' ), spr.nimm__wgruppe( 'Ursprung des Gefahrenszenarios', '1', '0' )]), prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( 'Zugeordneter Aktueller Protokolleintrag.', '1', '0' ), 'PE_OK'] )] )
--	, 'true'
--	, '2007-06-06'
--	, 'datenquelle'
--	, 'micha'
--	, 'true'
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.pl_prtpsgefszenario;
--
--SELECT * FROM prj.pl_psgefstrkt;
--SELECT * FROM prj.nimm__tabwerte( 'pl_psgefstrkt', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, ps.nimm__aspekte( 'gefstrkt', ARRAY[ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( 'Gefahrenszenario', '1', '0' ), spr.nimm__wgruppe( 'Ursprung des Gefahrenszenarios', '1', '0' )]), str.nimm__strkt( ARRAY['1', '-BAAA', spr.nimm__wgruppe( 'Strukturpunkt', '1', '0' )])] )
--	, 'true'
--	, '2007-06-06'
--	, 'datenquelle'
--	, 'micha'
--	, 'true'
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.pl_psgefstrkt;
--
--SELECT * FROM prj.pp_psgefszenario;
--SELECT * FROM prj.nimm__tabwerte( 'pp_psgefszenario', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( 'Gefahrenszenario', '1', '0' ), spr.nimm__wgruppe( 'Ursprung des Gefahrenszenarios', '1', '0' )])
--	, prj.nimm__tabwerte( 'personen', ARRAY['1', 'Bellair', 'Michael'] )
--	, spr.nimm__wgruppe( 'projektspezifisch formuliertes Gefahrenszenario', '1', '0' )
--	, spr.nimm__wgruppe( 'projektspezifisch formulierter Ursprung des Gefahrenszenarios', '1', '0' )
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.pp_psgefszenario;
--
--
--	-- \\texttt{str.*} einlesen
--SELECT * FROM prj.pp_strstrkt;
--SELECT * FROM prj.nimm__tabwerte( 'pp_strstrkt', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, str.nimm__strkt( ARRAY['1', '-BAAA', spr.nimm__wgruppe( 'Strukturpunkt', '1', '0' )])
--	, prj.nimm__tabwerte( 'personen', ARRAY['1', 'Bellair', 'Michael'] )
--	, spr.nimm__wgruppe( 'Strukturpunkt übersetzt ?', '1', '0' )
--	, 'HAUS'
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.pp_strstrkt;
--
--SELECT * FROM prj.p_strverbindung;
--SELECT * FROM prj.nimm__tabwerte( 'p_strverbindung', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, str.nimm__verbindung( ARRAY[str.nimm__strkt( ARRAY['1', '-BAAA1', spr.nimm__wgruppe( 'Strukturpunkt-1', '1', '0' )]), str.nimm__strkt( ARRAY['1', '-BAAA2', spr.nimm__wgruppe( 'Strukturpunkt-2', '1', '0' )])] )
--	, 'UND'
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.p_strverbindung;
--




--
-- -----------------------------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------------------------
--

--
--	prt.typ.id = 1 umbenennenin '01: Aufgabe/Frage'		----------------------------------------------------------
--

SELECT
	spr.zeige__wgruppe.wgruppe
FROM
	prt.typ
	, spr.zeige__wgruppe
WHERE
	prt.typ.spr_uebvar_id = spr.zeige__wgruppe.spr_uebvar_id
AND
	prt.typ.id = 1
;


UPDATE prt.typ SET spr_uebvar_id = CAST( spr.nimm__wgruppe( '01: Aufgabe/Frage', '1', '0' ) AS integer ) WHERE id = 1;


SELECT
	spr.zeige__wgruppe.wgruppe
FROM
	prt.typ
	, spr.zeige__wgruppe
WHERE
	prt.typ.spr_uebvar_id = spr.zeige__wgruppe.spr_uebvar_id
AND
	prt.typ.id = 1
;






--
-- -----------------------------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------------------------
--


--
-- --	Funktionsgruppen einlesen	----------------------------------------------------------
--
SELECT prj.nimm__tabwerte( 'pp_strstrkt', ARRAY[
	--
	-- --	prj_projekte_id		----------------------------------
	--
	'4'
	--
	-- --	str_strkt_id	------------------------------------------
	--
	, intern.nimm__zeile( 'str.strkt', ARRAY['nr', 'str_name_id'], ARRAY['=B', '3'] )
       	--
	-- --	prj_personen_id	----------------------------------
	--
	, '1'
	--
	-- --	spr_uebvar_id	------------------------------------------
	--
	, spr.nimm__wgruppe( 'Aufnehmen, Schützen, Sichern und Umschließen des Transportgegenstandes', '1'
	  		     , spr.nimm__wgruppe( 'Carry and protect passenger, train, crew and load', '2', '0' ) ) ] );


SELECT prj.nimm__tabwerte( 'pp_strstrkt', ARRAY[
	--
	-- --	prj_projekte_id		----------------------------------
	--
	'4'
	--
	-- --	str_strkt_id	------------------------------------------
	--
	, intern.nimm__zeile( 'str.strkt', ARRAY['nr', 'str_name_id'], ARRAY['=BB', '3'] )
       	--
	-- --	prj_personen_id	----------------------------------
	--
	, '1'
	--
	-- --	spr_uebvar_id	------------------------------------------
	--
	, spr.nimm__wgruppe( 'Innenraum bereitstellen', '1'
	  		     , spr.nimm__wgruppe( 'Arrange interior space', '2', '0' ) ) ] );


SELECT prj.nimm__tabwerte( 'pp_strstrkt', ARRAY[
	--
	-- --	prj_projekte_id		----------------------------------
	--
	'4'
	--
	-- --	str_strkt_id	------------------------------------------
	--
	, intern.nimm__zeile( 'str.strkt', ARRAY['nr', 'str_name_id'], ARRAY['=BC', '3'] )
       	--
	-- --	prj_personen_id	----------------------------------
	--
	, '1'
	--
	-- --	spr_uebvar_id	------------------------------------------
	--
	, spr.nimm__wgruppe( 'Tragen und Umschließen der Ladung', '1'
	  		     , spr.nimm__wgruppe( 'Carry and enclose the load', '2', '0' ) ) ] );


SELECT prj.nimm__tabwerte( 'pp_strstrkt', ARRAY[
	--
	-- --	prj_projekte_id		----------------------------------
	--
	'4'
	--
	-- --	str_strkt_id	------------------------------------------
	--
	, intern.nimm__zeile( 'str.strkt', ARRAY['nr', 'str_name_id'], ARRAY['=BD', '3'] )
       	--
	-- --	prj_personen_id	----------------------------------
	--
	, '1'
	--
	-- --	spr_uebvar_id	------------------------------------------
	--
	, spr.nimm__wgruppe( 'Schützen des Transportgutes im Fall eines Unfalles', '1'
	  		     , spr.nimm__wgruppe( 'Protect in case of crash', '2', '0' ) ) ] );


SELECT prj.nimm__tabwerte( 'pp_strstrkt', ARRAY[
	--
	-- --	prj_projekte_id		----------------------------------
	--
	'4'
	--
	-- --	str_strkt_id	------------------------------------------
	--
	, intern.nimm__zeile( 'str.strkt', ARRAY['nr', 'str_name_id'], ARRAY['=C', '3'] )
       	--
	-- --	prj_personen_id	----------------------------------
	--
	, '1'
	--
	-- --	spr_uebvar_id	------------------------------------------
	--
	, spr.nimm__wgruppe( 'Angemessene Aufenthalts- und Transportbedingungen gewährleisten', '1'
	  		     , spr.nimm__wgruppe( 'Provide appropriate conditions to passenger, train crew and payload', '2', '0' ) ) ] );


SELECT prj.nimm__tabwerte( 'p_strverbindung', ARRAY[
	--
	-- --	prj_projekte_id		----------------------------------
	--
	'4'
	--
	-- --	str_strkt_id_vorg	----------------------------------
	--
	, '899'
	--
	-- --	str_strkt_id_nachf	----------------------------------
	--
	, '900' ] );

SELECT prj.nimm__tabwerte( 'p_strverbindung', ARRAY[
	--
	-- --	prj_projekte_id		----------------------------------
	--
	'4'
	--
	-- --	str_strkt_id_vorg	----------------------------------
	--
	, '899'
	--
	-- --	str_strkt_id_nachf	----------------------------------
	--
	, '901' ] );

SELECT prj.nimm__tabwerte( 'p_strverbindung', ARRAY[
	--
	-- --	prj_projekte_id		----------------------------------
	--
	'4'
	--
	-- --	str_strkt_id_vorg	----------------------------------
	--
	, '899'
	--
	-- --	str_strkt_id_nachf	----------------------------------
	--
	, '902' ] );



--
-- -----------------------------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------------------------
--


--
-- --	>prj.pl_dokausgabe< Spalten hinzufügen	------------------------------------------
--
ALTER TABLE prj.pl_dokausgabe DROP CONSTRAINT uc__prj_pl_dokausgabe;
ALTER TABLE prj.pl_dokausgabe DROP CONSTRAINT fk__prj_pl_dokausgabe__dok_doku_id;
ALTER TABLE prj.pl_dokausgabe DROP CONSTRAINT fk__prj_pl_dokausgabe__prj_projekte_id;

ALTER TABLE prj.pl_dokausgabe RENAME COLUMN prj_projekte_id TO prj_projekte_id___;
ALTER TABLE prj.pl_dokausgabe RENAME COLUMN stand TO stand___;

ALTER TABLE prj.pl_dokausgabe ADD COLUMN nr VARCHAR DEFAULT '???' NOT NULL;
ALTER TABLE prj.pl_dokausgabe ADD COLUMN prj_projekte_id INT DEFAULT 0 NOT NULL;
ALTER TABLE prj.pl_dokausgabe ADD COLUMN spr_uebvar_id INT DEFAULT 0 NOT NULL;
ALTER TABLE prj.pl_dokausgabe ADD COLUMN stand VARCHAR DEFAULT '???' NOT NULL;

ALTER TABLE prj.pl_dokausgabe ALTER COLUMN istfrei SET DEFAULT false;

SELECT intern.nimm__TLKommentarSTS( 'prj.pl_dokausgabe', E'Tabelle zur Verwaltung der Dokumentnummer, des Dokumenttitels und der Ausgaben (Revisionsstände) des aktuellen Dokumentes. Diese Tabelle enthält alle im Projekt verwendeten Dokumente. Mittels Logbuchfunktion kann der Wechsel der Revisionsstände verfolgt werden.');

SELECT intern.nimm__TLKommentarSTS( 'prj.pl_prtdokdoku', E'Mittels dieser Tabelle wird die projektabhängige Logbuchfunktion für die Dokumente bereitgestellt, die dem aktuellen Gefahrenszenario zugeordnet sind.');

SELECT intern.nimm__TLKommentarSTS( 'prj.pl_dokausgabe.nr', 'Identifikationsnummer (Dokumentennummer) des Dokumentes.');
SELECT intern.nimm__TLKommentarSTS( 'prj.pl_dokausgabe.prj_projekte_id', 'Identifikationsnummer des aktuellen Projektes.');
SELECT intern.nimm__TLKommentarSTS( 'prj.pl_dokausgabe.spr_uebvar_id', 'Identifikationsnummer der Übersetzungsvariante, welche den Titel des Dokumentes (Dokumententitel) darstellt.');
SELECT intern.nimm__TLKommentarSTS( 'prj.pl_dokausgabe.stand', 'Revisionstand (Kennzeichen der Ausgabe) des aktellen Dokumentes. Wenn er NULL ist, existiert kein Revisionstand.');

ALTER TABLE prj.pl_dokausgabe ADD CONSTRAINT fk__prj_pl_dokausgabe__prj_projekte_id FOREIGN KEY ( prj_projekte_id ) REFERENCES prj.projekte ( id );
ALTER TABLE prj.pl_dokausgabe ADD CONSTRAINT fk__prj_pl_dokausgabe__spr_uebvar_id FOREIGN KEY ( spr_uebvar_id ) REFERENCES spr.uebvar ( id );

ALTER TABLE prj.pl_dokausgabe ADD CONSTRAINT uc__prj_pl_dokausgabe UNIQUE(idfrei, logentfernt, logdatuhrz, dok_doku_id, prj_projekte_id );


UPDATE prj.pl_dokausgabe SET prj_projekte_id = prj_projekte_id___, stand = stand___;


DROP VIEW prj.zeige__dokdoku;
DROP VIEW prj.zeige__pl_dokausgabe_le;

ALTER TABLE prj.pl_dokausgabe DROP COLUMN prj_projekte_id___;
ALTER TABLE prj.pl_dokausgabe DROP COLUMN stand___;





--
-- --	>prj.pl_dokausgabe< Werte aus >prj.pl_prtdokdoku< übernemen	------------------
--

--
-- Dokument-Nr / -Titel übernehmen, zu denen eine Ausgabe definiert ist
-- (SELECT dient der Plausibilitätsprüfung !)
--
SELECT
	dok_doku_id
	, nr
	, prj_projekte_id
	, spr_uebvar_id
FROM
	prj.pl_prtdokdoku
	, prj.zeige__pl_prtdokdoku_le
WHERE
	prj.zeige__pl_prtdokdoku_le.prj__pl_prtdokdoku__id = prj.pl_prtdokdoku.id
AND
	prj.pl_prtdokdoku.logentfernt = false
ORDER BY
	prj.pl_prtdokdoku.dok_doku_id
;

SELECT
	id
	, logentfernt
	, datum
	, dok_doku_id
	, istfrei
	, nr
	, prj_projekte_id
	, spr_uebvar_id
	, stand
FROM
	prj.pl_dokausgabe
;

--
-- -->
--
UPDATE
	prj.pl_dokausgabe
SET
	nr = prj.pl_prtdokdoku.nr
	, spr_uebvar_id = prj.pl_prtdokdoku.spr_uebvar_id
FROM
	prj.pl_prtdokdoku
	, prj.zeige__pl_prtdokdoku_le
WHERE
	prj.pl_dokausgabe.dok_doku_id = prj.pl_prtdokdoku.dok_doku_id
AND
	prj.pl_prtdokdoku.dok_doku_id > 0
AND
	prj.zeige__pl_prtdokdoku_le.prj__pl_prtdokdoku__id = prj.pl_prtdokdoku.id
AND
	prj.pl_prtdokdoku.logentfernt = false
;

SELECT
	id
	, logentfernt
	, datum
	, dok_doku_id
	, istfrei
	, nr
	, prj_projekte_id
	, spr_uebvar_id
	, stand
FROM
	prj.pl_dokausgabe
;
--
-- Dokument-Nr / -Titel übernehmen, zu denen keine Ausgabe definiert ist (manuell erstellen)
--
SELECT DISTINCT
	dok_doku_id
	, nr
	, prj_projekte_id
	, spr_uebvar_id
FROM
	prj.pl_prtdokdoku
	, prj.zeige__pl_prtdokdoku_le
WHERE
	prj.zeige__pl_prtdokdoku_le.prj__pl_prtdokdoku__id = prj.pl_prtdokdoku.id
AND
	prj.pl_prtdokdoku.logentfernt = false
ORDER BY
	prj.pl_prtdokdoku.dok_doku_id
;

SELECT
	id
	, logentfernt
	, datum
	, dok_doku_id
	, istfrei
	, nr
	, prj_projekte_id
	, spr_uebvar_id
	, stand
FROM
	prj.pl_dokausgabe
;

--
-- -->
--
SELECT DISTINCT
	prj.pl_prtdokdoku.dok_doku_id
	, prj.pl_prtdokdoku.nr
	, prj.pl_prtdokdoku.prj_projekte_id
	, prj.pl_prtdokdoku.spr_uebvar_id
FROM
	prj.zeige__pl_prtdokdoku_le
	, prj.pl_prtdokdoku
		LEFT OUTER JOIN prj.pl_dokausgabe ON ( 
		         prj.pl_dokausgabe.dok_doku_id = prj.pl_prtdokdoku.dok_doku_id
		     AND prj.pl_dokausgabe.idfrei = 0 )
WHERE
	prj.pl_dokausgabe.dok_doku_id IS NULL
AND
	prj.zeige__pl_prtdokdoku_le.prj__pl_prtdokdoku__id = prj.pl_prtdokdoku.id
AND
	prj.pl_prtdokdoku.logentfernt = false
ORDER BY
	prj.pl_prtdokdoku.dok_doku_id
;
SELECT max(id) FROM prj.pl_dokausgabe;

INSERT INTO
      prj.pl_dokausgabe
      ( id, dok_doku_id, nr, prj_projekte_id, spr_uebvar_id )
VALUES(6, 3, '08-17', 2, 943)
;

INSERT INTO
      prj.pl_dokausgabe
      ( id, dok_doku_id, nr, prj_projekte_id, spr_uebvar_id )
VALUES(7, 6, '08-15-Q', 2, 1047)
;

INSERT INTO
      prj.pl_dokausgabe
      ( id, dok_doku_id, nr, prj_projekte_id, spr_uebvar_id )
VALUES(8, 7, '08-16-Q', 2, 1048)
;

SELECT
	id
	, logentfernt
	, datum
	, dok_doku_id
	, istfrei
	, nr
	, prj_projekte_id
	, spr_uebvar_id
	, stand
FROM
	prj.pl_dokausgabe
;







--
-- --	>prj.zeige__pl_dokausgabe_le< aktivieren	----------------------------------
--

CREATE OR REPLACE VIEW prj.zeige__pl_dokausgabe_le
AS
  SELECT
	dokausg.id AS prj__pl_dokausgabe__id
	--
	-- Kontrolle
	--
--	, dokausg.dok_doku_id AS prj__pl_dokausgabe__dok_doku_id
--	, dokausg.prj_projekte_id AS prj__pl_dokausgabe__prj_projekte_id
--	, dokausg.logdatuhrz
--	, dokausg.logentfernt
  FROM
	prj.pl_dokausgabe
		LEFT OUTER JOIN prj.pl_dokausgabe AS dokausg
			ON (
				prj.pl_dokausgabe.dok_doku_id = dokausg.dok_doku_id
			   AND
				prj.pl_dokausgabe.prj_projekte_id = dokausg.prj_projekte_id
			   AND
				prj.pl_dokausgabe.idfrei = 0
			   AND
				dokausg.idfrei = 0
			)
  GROUP BY
	  dokausg.id
	, dokausg.logdatuhrz
	--
	-- Kontrolle
	--
--	, dokausg.dok_doku_id
--	, dokausg.prj_projekte_id
--	, dokausg.logentfernt
  HAVING
	--
	-- Abfrage auf letzte Änderung beschränken 
	--
	max( prj.pl_dokausgabe.logdatuhrz ) = dokausg.logdatuhrz
  ORDER BY
	dokausg.id
	--
	-- Kontrolle
	--
--	, dokausg.dok_doku_id
--	, dokausg.prj_projekte_id
;
SELECT intern.nimm__TLKommentarSicht( 'prj.zeige__pl_dokausgabe_le'
, ARRAY[
   'prj__pl_dokausgabe__id'
] 
, ARRAY[
   E'siehe \\texttt{prj.pl_dokausgabe.id}'
], 
E'Zu jedem in der Tabelle \\texttt{prj.pl_dokausgabe} enthaltenen Dokument wird unter Berücksichtigung des Projektes die Identifikationsnummer \\texttt{prj.pl_dokausgabe.id} der jeweils letzten zugeordneten Ausgabe angezeigt (Logbuchfunktion).' );
--
-- Standardverhalten:
-- ..................
--
--SELECT * FROM prj.zeige__pl_dokausgabe_le;
--



--
-- --	>prj.zeige__dokdoku< korrigieren	------------------------------------------
--

CREATE OR REPLACE VIEW prj.zeige__dokdoku
AS
  SELECT
	--
	-- --	dok.doku	----------------------------------------------------------
	--
	dok.doku.id AS dok__doku__id
	, dok.doku.aspekt AS dok__doku__aspekt
	, dok.doku.notizen AS dok__doku__notizen
	, dok.doku.dok_typ_id AS dok__doku__dok_typ_id
	, dok.doku.spr_uebvar_id_kb AS dok__doku__spr_uebvar_id_kb
	--
	-- --	prj.pl_prtdokdoku	----------------------------------------------------------
	--
	, prj.pl_prtdokdoku.id AS prj__pl_prtdokdoku__id
	, prj.pl_prtdokdoku.prj_projekte_id AS prj__pl_prtdokdoku__prj_projekte_id
	, prj.pl_prtdokdoku.prt_protokoll_id AS prj__pl_prtdokdoku__prt_protokoll_id
	, prj.pl_prtdokdoku.notizen AS prj__pl_prtdokdoku__notizen
	, prj.pl_prtdokdoku.logdatuhrz AS prj__pl_prtdokdoku__logdatuhrz
	, prj.pl_prtdokdoku.logdqok AS prj__pl_prtdokdoku__logdqok
	, prj.pl_prtdokdoku.logdquelle AS prj__pl_prtdokdoku__logdquelle
	, prj.pl_prtdokdoku.logentfernt AS prj__pl_prtdokdoku__logentfernt
	, prj.pl_prtdokdoku.logname AS prj__pl_prtdokdoku__logname
	--
	-- --	prj.pl_dokausgabe	--------------------------------------------------
	--
	, prj.pl_dokausgabe.id AS prj__pl_dokausgabe__id
	, prj.pl_dokausgabe.prj_projekte_id AS prj__pl_dokausgabe__prj_projekte_id
	, prj.pl_dokausgabe.stand AS prj__pl_dokausgabe__stand
	, prj.pl_dokausgabe.datum AS prj__pl_dokausgabe__datum
	, prj.pl_dokausgabe.istfrei AS prj__pl_dokausgabe__istfrei
	, prj.pl_dokausgabe.notizen AS prj__pl_dokausgabe__notizen
	, prj.pl_dokausgabe.nr AS prj__pl_dokausgabe__nr
	, prj.pl_dokausgabe.logdatuhrz AS prj__pl_dokausgabe__logdatuhrz
	, prj.pl_dokausgabe.logdqok AS prj__pl_dokausgabe__logdqok
	, prj.pl_dokausgabe.logdquelle AS prj__pl_dokausgabe__logdquelle
	, prj.pl_dokausgabe.logentfernt AS prj__pl_dokausgabe__logentfernt
	, prj.pl_dokausgabe.logname AS prj__pl_dokausgabe__logname
	, prj.pl_dokausgabe.spr_uebvar_id AS prj__pl_dokausgabe__spr_uebvar_id
	--
	-- --	prj.ppl_dokdoku	----------------------------------------------------------
	--
	, prj.ppl_dokdoku.id AS prj__ppl_dokdoku__id
	, prj.ppl_dokdoku.prj_personen_id AS prj__ppl_dokdoku__prj_personen_id
	, prj.ppl_dokdoku.prj_projekte_id AS prj__ppl_dokdoku__prj_projekte_id
	, prj.ppl_dokdoku.notizen AS prj__ppl_dokdoku__notizen
	, prj.ppl_dokdoku.logdatuhrz AS prj__ppl_dokdoku__logdatuhrz
	, prj.ppl_dokdoku.logdqok AS prj__ppl_dokdoku__logdqok
	, prj.ppl_dokdoku.logdquelle AS prj__ppl_dokdoku__logdquelle
	, prj.ppl_dokdoku.logentfernt AS prj__ppl_dokdoku__logentfernt
	, prj.ppl_dokdoku.logname AS prj__ppl_dokdoku__logname
	--
	-- --	prj.p_dokstrkt	----------------------------------------------------------
	--
	, prj.p_dokstrkt.id AS prj__p_dokstrkt__id
	, prj.p_dokstrkt.notizen AS prj__p_dokstrkt__notizen
	, prj.p_dokstrkt.prj_projekte_id AS prj__p_dokstrkt__prj_projekte_id
	, prj.p_dokstrkt.str_strkt_id AS prj__p_dokstrkt__str_strkt_id
  FROM
	dok.doku
		--
		-- prj.pl_prtdokdoku
		--
		LEFT OUTER JOIN prj.pl_prtdokdoku ON ( 
		         dok.doku.id = prj.pl_prtdokdoku.dok_doku_id
		     AND prj.pl_prtdokdoku.idfrei = 0 )
		--
		-- prj.pl_dokausgabe
		--
		LEFT OUTER JOIN prj.pl_dokausgabe ON ( 
		         dok.doku.id = prj.pl_dokausgabe.dok_doku_id
		     AND prj.pl_dokausgabe.idfrei = 0 )
		--
		-- prj.ppl_dokdoku
		--
		LEFT OUTER JOIN prj.ppl_dokdoku ON ( 
		         dok.doku.id = prj.ppl_dokdoku.dok_doku_id
		     AND prj.ppl_dokdoku.idfrei = 0 )
		--
		-- prj.p_dokstrkt
		--
		LEFT OUTER JOIN prj.p_dokstrkt ON ( 
		         dok.doku.id = prj.p_dokstrkt.dok_doku_id
		     AND prj.p_dokstrkt.idfrei = 0 )
  WHERE
	dok.doku.idfrei = 0
;
SELECT intern.nimm__TLKommentarSicht( 'prj.zeige__dokdoku'
, ARRAY[
   'dok__doku__id'
 , 'dok__doku__aspekt'
 , 'dok__doku__notizen'
 , 'dok__doku__dok_typ_id'
 , 'dok__doku__spr_uebvar_id_kb'
 , 'prj__pl_prtdokdoku__id'
 , 'prj__pl_prtdokdoku__prj_projekte_id'
 , 'prj__pl_prtdokdoku__prt_protokoll_id'
 , 'prj__pl_prtdokdoku__notizen'
 , 'prj__pl_prtdokdoku__logdatuhrz'
 , 'prj__pl_prtdokdoku__logdqok'
 , 'prj__pl_prtdokdoku__logdquelle'
 , 'prj__pl_prtdokdoku__logentfernt'
 , 'prj__pl_prtdokdoku__logname'
 , 'prj__pl_dokausgabe__id'
 , 'prj__pl_dokausgabe__prj_projekte_id'
 , 'prj__pl_dokausgabe__stand'
 , 'prj__pl_dokausgabe__datum'
 , 'prj__pl_dokausgabe__istfrei'
 , 'prj__pl_dokausgabe__notizen'
 , 'prj__pl_dokausgabe__nr'
 , 'prj__pl_dokausgabe__logdatuhrz'
 , 'prj__pl_dokausgabe__logdqok'
 , 'prj__pl_dokausgabe__logdquelle'
 , 'prj__pl_dokausgabe__logentfernt'
 , 'prj__pl_dokausgabe__logname'
 , 'prj__pl_dokausgabe__spr_uebvar_id'
 , 'prj__ppl_dokdoku__id'
 , 'prj__ppl_dokdoku__prj_personen_id'
 , 'prj__ppl_dokdoku__prj_projekte_id'
 , 'prj__ppl_dokdoku__notizen'
 , 'prj__ppl_dokdoku__logdatuhrz'
 , 'prj__ppl_dokdoku__logdqok'
 , 'prj__ppl_dokdoku__logdquelle'
 , 'prj__ppl_dokdoku__logentfernt'
 , 'prj__ppl_dokdoku__logname'
 , 'prj__p_dokstrkt__id'
 , 'prj__p_dokstrkt__notizen'
 , 'prj__p_dokstrkt__prj_projekte_id'
 , 'prj__p_dokstrkt__str_strkt_id'
] 
, ARRAY[
   E'siehe \\texttt{dok.doku.id}'
 , E'siehe \\texttt{dok.doku.aspekt}'
 , E'siehe \\texttt{dok.doku.notizen}'
 , E'siehe \\texttt{dok.doku.dok_typ_id}'
 , E'siehe \\texttt{dok.doku.spr_uebvar_id_kb}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.id}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.prj_projekte_id}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.prt_protokoll_id}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.notizen}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.logdatuhrz}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.logdqok}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.logdquelle}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.logentfernt}'
 , E'siehe \\texttt{prj.pl_prtdokdoku.logname}'
 , E'siehe \\texttt{prj.pl_dokausgabe.id}'
 , E'siehe \\texttt{prj.pl_dokausgabe.prj_projekte_id}'
 , E'siehe \\texttt{prj.pl_dokausgabe.stand}'
 , E'siehe \\texttt{prj.pl_dokausgabe.datum}'
 , E'siehe \\texttt{prj.pl_dokausgabe.istfrei}'
 , E'siehe \\texttt{prj.pl_dokausgabe.notizen}'
 , E'siehe \\texttt{prj.pl_dokausgabe.nr}'
 , E'siehe \\texttt{prj.pl_dokausgabe.logdatuhrz}'
 , E'siehe \\texttt{prj.pl_dokausgabe.logdqok}'
 , E'siehe \\texttt{prj.pl_dokausgabe.logdquelle}'
 , E'siehe \\texttt{prj.pl_dokausgabe.logentfernt}'
 , E'siehe \\texttt{prj.pl_dokausgabe.logname}'
 , E'siehe \\texttt{prj.pl_dokausgabe.spr_uebvar_id}'
 , E'siehe \\texttt{prj.ppl_dokdoku.id}'
 , E'siehe \\texttt{prj.ppl_dokdoku.prj_personen_id}'
 , E'siehe \\texttt{prj.ppl_dokdoku.prj_projekte_id}'
 , E'siehe \\texttt{prj.ppl_dokdoku.notizen}'
 , E'siehe \\texttt{prj.ppl_dokdoku.logdatuhrz}'
 , E'siehe \\texttt{prj.ppl_dokdoku.logdqok}'
 , E'siehe \\texttt{prj.ppl_dokdoku.logdquelle}'
 , E'siehe \\texttt{prj.ppl_dokdoku.logentfernt}'
 , E'siehe \\texttt{prj.ppl_dokdoku.logname}'
 , E'siehe \\texttt{prj.p_dokstrkt.id}'
 , E'siehe \\texttt{prj.p_dokstrkt.notizen}'
 , E'siehe \\texttt{prj_projekte_id}'
 , E'siehe \\texttt{prj.p_dokstrkt.str_strkt_id}'
], 
E'Es werden die Dokumente (siehe \\texttt{dok.doku}, \\texttt{prj.pl_prtdokdoku}, \\texttt{prj.pl_dokausgabe}, \\texttt{prj.ppl_dokdoku}) angezeigt.' );
--
-- Standardverhalten:
-- ..................
--
--SELECT * FROM prj.zeige__dokdoku;
--






--
-- --	>prj.nimm__tabwerte< korrigieren	------------------------------------------
--

CREATE OR REPLACE FUNCTION prj.nimm__tabwerte( IN tabname varchar, IN tabwerte varchar[], OUT tabid varchar ) AS
$$
DECLARE
--------------------------------------------------------------------------------
-- Konstanten
--------------------------------------------------------------------------------


--------------------------------------------------------------------------------
-- lokale Variablen
--------------------------------------------------------------------------------
--
-- temporäre Ganzzahlvariable(n)
--
tmpInteger integer;
--
-- Grenzen
--
uGoG integer[];
--
-- Liste der Spaltennamen
--
spNamen varchar[];
--
-- Tabellenwerte müssen veränderbar sein
--
tabwerteIntern varchar[];


BEGIN

--
-- 0. Tabellenwerte übernehmen
--
tabwerteIntern := tabwerte;


--
-- 1.)	Tabname einlesen / prüfen
--
tmpInteger := array_upper( tabwerte, 1 );
IF(
	tabname='p_dokstrkt'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '4' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'dok_doku_id'
			, 'dok_strkt_id'
			, 'notizen'
			];




ELSIF(
	tabname='p_prtstrstrkt'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '4' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'prt_protokoll_id'
			, 'str_strkt_id'
			, 'notizen'
			];


ELSIF(
	tabname='p_prtverbindung'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '4' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'prt_protokoll_id_nachf'
			, 'prt_protokoll_id_vorg'
			, 'notizen'
			];


ELSIF(
	tabname='personen'
  )
THEN

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '4' ];
	spNamen := ARRAY[
			'intern_firma_id'
			, 'name_n'
			, 'name_v'
			, 'notizen'
			];


ELSIF(
	tabname='pl_dokausgabe'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'bw', tabwerte[3], NULL, NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Plausibilitätsprüfung ab tabwerte[5]
	--
	IF(
		NOT( tmpInteger < 5 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[5], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[5]' );
	END IF;

	--
	-- Plausibilitätsprüfung ab tabwerte[7]
	--
	IF(
		NOT( tmpInteger < 7 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'du', tabwerte[7], NULL, NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[7]' );
	END IF;

	--
	-- Plausibilitätsprüfung ab tabwerte[8]
	--
	IF(
		NOT( tmpInteger < 8 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'bw', tabwerte[8], NULL, NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[8]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '2', '13' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'dok_doku_id'
			, 'logentfernt'
			, 'nr'
			, 'spr_uebvar_id'
			, 'stand'
			, 'datum'
			, 'istfrei'
			, 'notizen'
			, 'logdatuhrz'
			, 'logdquelle'
			, 'logname'
			, 'logdqok'
			];


ELSIF(
	tabname='pl_prtpsgefszenario'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '9' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'ps_gefszenario_id'
			, 'prt_protokoll_id'
			, 'notizen'
			, 'logentfernt'
			, 'logdatuhrz'
			, 'logdquelle'
			, 'logname'
			, 'logdqok'
			];


ELSIF(
	tabname='pl_psgefstrkt'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '9' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'ps_gefszenario_id'
			, 'str_strkt_id'
			, 'notizen'
			, 'logentfernt'
			, 'logdatuhrz'
			, 'logdquelle'
			, 'logname'
			, 'logdqok'
			];


ELSIF(
	tabname='pl_psgefabk'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'bw', tabwerte[3], NULL, NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Plausibilitätsprüfung tabwerte[4]
	--
	IF(
		NOT( tmpInteger < 4 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[4], '0', NULL
						, 'prj.nimm__tabwerte(...)'
						, tabname || '.tabwerte[4]' );
	END IF;
	--
	-- Plausibilitätsprüfung tabwerte[5]
	--
	IF(
		NOT( tmpInteger < 5 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[5], '0', NULL
						, 'prj.nimm__tabwerte(...)'
						, tabname || '.tabwerte[5]' );
	END IF;


	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '4', '10' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'ps_gefszenario_id'
			, 'logentfernt'
			, 'ps_abk_id'
			, 'spr_uebvar_id_zus'
			, 'notizen'
			, 'logdatuhrz'
			, 'logdquelle'
			, 'logname'
			, 'logdqok'
			];


ELSIF(
	tabname='pl_psgefanm'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'bw', tabwerte[3], NULL, NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Plausibilitätsprüfung ab tabwerte[4]
	--
	IF(
		NOT( tmpInteger < 4 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[4], '0', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[4]' );
	END IF;

	--
	-- Plausibilitätsprüfung ab tabwerte[5]
	--
	IF(
		NOT( tmpInteger < 5 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[5], '0', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[5]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '5', '10' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'ps_gefszenario_id'
			, 'logentfernt'
			, 'ps_anmerkung_id'
			, 'spr_uebvar_id'
			, 'notizen'
			, 'logdatuhrz'
			, 'logdquelle'
			, 'logname'
			, 'logdqok'
			];


ELSIF(
	tabname='ppl_dokdoku'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Plausibilitätsprüfung ab tabwerte[4]
	--
	IF(
		NOT( tmpInteger < 4 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'bw', tabwerte[4], NULL, NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[4]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '9' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'dok_doku_id'
			, 'prj_personen_id'
			, 'logentfernt'
			, 'notizen'
			, 'logdatuhrz'
			, 'logdquelle'
			, 'logname'
			, 'logdqok'
			];


--
-- 1.1.) Protokolleintrag einem Projekt zuordnen bzw. projektspezifisch modifizieren
--
--	vorübergehend deaktiviert !
--
--ELSIF(
--	tabname='pp_prtprotokoll'
--  )
--THEN
--
--	--
--	-- Plausibilitätsprüfung ab tabwerte[3]
--	--
--	IF(
--		NOT( tmpInteger < 3 )
--	  ) 
--	THEN
--		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '0', NULL
--					, 'prj.nimm__tabwerte(...)'
--					, tabname || '.tabwerte[3]' );
--	END IF;
--
--	IF(
--		NOT( tmpInteger < 4 )
--	  ) 
--	THEN
--		EXECUTE intern.pruefe__dt( 'du', tabwerte[4], NULL, NULL
--					, 'prj.nimm__tabwerte(...)'
--					, tabname || '.tabwerte[4]' );
--	END IF;
--
--	IF(
--		NOT( tmpInteger < 5 )
--	  ) 
--	THEN
--		EXECUTE intern.pruefe__dt( 'bw', tabwerte[5], NULL, NULL
--					, 'prj.nimm__tabwerte(...)'
--					, tabname || '.tabwerte[5]' );
--	END IF;
--
--	IF(
--		NOT( tmpInteger < 6 )
--	  ) 
--	THEN
--		EXECUTE intern.pruefe__dt( 'bw', tabwerte[6], NULL, NULL
--					, 'prj.nimm__tabwerte(...)'
--					, tabname || '.tabwerte[6]' );
--	END IF;
--
--	--
--	-- Werte zuweisen
--	--
--	uGoG := ARRAY[ '3', '7' ];
--	spNamen := ARRAY[
--			'prj_projekte_id'
--			, 'prt_protokoll_id'
-- 			, 'spr_uebvar_id'
--			, 'datuhrz'
--			, 'intern'
--			, 'erledigt'
--			, 'notizen'
--			];
--
--
---- 1.2.) dem Protokolleintrag die beteiligten Personen zuordnen
---- 1.3.) der Protokolleintrag ist eine Frage / Aufgabe
--ELSIF(
--	tabname='pp_prtprotokoll_pers'
--  )
--THEN
--
--	--
--	-- Plausibilitätsprüfung ab tabwerte[3]
--	--
--	IF(
--		NOT( tmpInteger < 3 )
--	  ) 
--	THEN
--		EXECUTE intern.pruefe__dt( 'bw', tabwerte[3], NULL, NULL
--					, 'prj.nimm__tabwerte(...)'
--					, tabname || '.tabwerte[3]' );
--	END IF;
--
--	IF(
--		NOT( tmpInteger < 4 )
--	  ) 
--	THEN
--		EXECUTE intern.pruefe__dt( 'gz', tabwerte[4], '1', NULL
--					, 'prj.nimm__tabwerte(...)'
--					, tabname || '.tabwerte[4]' );
--	END IF;
--
--	IF(
--		NOT( tmpInteger < 5 )
--	  ) 
--	THEN
--		EXECUTE intern.pruefe__dt( 'du', tabwerte[5], NULL, NULL
--					, 'prj.nimm__tabwerte(...)'
--					, tabname || '.tabwerte[5]' );
--	END IF;
--
--	IF(
--		NOT( tmpInteger < 6 )
--	  ) 
--	THEN
--		EXECUTE intern.pruefe__dt( 'du', tabwerte[6], NULL, NULL
--					, 'prj.nimm__tabwerte(...)'
--					, tabname || '.tabwerte[6]' );
--	END IF;
--
--	--
--	-- Teilnehmer / Frage behandeln
--	--
--	IF(
--		( tmpInteger > 4 )
--		AND ( CAST( tabwerte[3] AS boolean ) = true )
--	  ) 
--	THEN
--		RAISE EXCEPTION 'prj.nimm__tabwerte(...)	Wenn >tabwerte[3] = true< ist, darf >tabwerte[5]< und >tabwerte[6]< nicht angegeben werden. Das Einlesen wird abgebrochen !';
--	END IF;
--
--	IF(
--		( tmpInteger > 3 )
--		AND ( tmpInteger < 5 )
--		AND ( CAST( tabwerte[3] AS boolean ) = false )
--	  ) 
--	THEN
--		RAISE EXCEPTION 'prj.nimm__tabwerte(...)	Wenn >tabwerte[3] = false< ist, muß >tabwerte[5]< angegeben werden. Das Einlesen wird abgebrochen !';
--	END IF;
--
--
--	--
--	-- Werte zuweisen
--	--
--	uGoG := ARRAY[ '4', '7' ];
--	spNamen := ARRAY[
--			'prj_projekte_id'
--			, 'prt_protokoll_id'
--			, 'teilnehmer'
--			, 'prj_personen_id'
--			, 'termin'
--			, 'duanfrage'
--			, 'notizen'
--			];
--
--
ELSIF(
	tabname='pp_psgefszenario'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '0', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );

	IF(
		NOT( tmpInteger < 4 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[4], '0', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[4]' );
	END IF;

	IF(
		NOT( tmpInteger < 5 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[5], '0', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[5]' );
	END IF;

	IF(
		NOT( tmpInteger < 6 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[6], '0', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[6]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '7' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'ps_gefszenario_id'
			, 'prj_personen_id'
			, 'spr_uebvar_id'
			, 'spr_uebvar_id_reprgefszen'
			, 'spr_uebvar_id_ursp'
			, 'notizen'
			];


ELSIF(
	tabname='pp_strstrkt'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );

	IF(
		NOT( tmpInteger < 4 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[4], '0', NULL
						, 'prj.nimm__tabwerte(...)'
						, tabname || '.tabwerte[4]' );
	END IF;

	IF(
		NOT( tmpInteger < 5 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[5], '0', NULL
						, 'prj.nimm__tabwerte(...)'
						, tabname || '.tabwerte[5]' );
	END IF;

	IF(
		NOT( tmpInteger < 6 )
	  ) 
	THEN
		EXECUTE str.pruefe__fbwerte( 'FB-Ereignis', tabwerte[6]
						, 'prj.nimm__tabwerte(...)'
						, 'tabwerte[6]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '7' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'str_strkt_id'
			, 'prj_personen_id'
			, 'spr_uebvar_id'
			, 'spr_uebvar_id_zus'
			, 'fbereignis'
			, 'notizen'
			];


ELSIF(
	tabname='pl_prtdokdoku'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	--
	-- Plausibilitätsprüfung ab tabwerte[4]
	--
	IF(
		NOT( tmpInteger < 4 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'bw', tabwerte[6], NULL, NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[6]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '9' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'dok_doku_id'
			, 'prt_protokoll_id'
			, 'logentfernt'
			, 'notizen'
			, 'logdatuhrz'
			, 'logdquelle'
			, 'logname'
			, 'logdqok'
			];


ELSIF(
	tabname='projekte'
  )
THEN
	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '2', '4' ];
	spNamen := ARRAY[
			'prjname'
			, 'prjbeschr'
			, 'makefile'
			, 'notizen'
			];


ELSIF(
	tabname='p_psabk'
  )
THEN

	--
	-- Plausibilitätsprüfung ab tabwerte[3]
	--
	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;


	IF(
		NOT( tmpInteger < 4 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[4], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[4]' );
	END IF;


	IF(
		NOT( tmpInteger < 5 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[5], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[5]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '2', '6' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'ps_abk_id'
			, 'spr_uebvar_id'
			, 'spr_uebvar_id_l'
			, 'spr_uebvar_id_zus'
			, 'notizen'
			];


ELSIF(
	tabname='p_strverbindung'
  )
THEN

	IF(
		NOT( tmpInteger < 3 )
	  ) 
	THEN
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[3], '1', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[3]' );
	END IF;

	IF(
		NOT( tmpInteger < 4 )
	  ) 
	THEN
		EXECUTE str.pruefe__fbwerte( 'FB-Tor', tabwerte[4]
						, 'prj.nimm__tabwerte(...)'
						, 'tabwerte[4]' );
	END IF;

	--
	-- Werte zuweisen
	--
	uGoG := ARRAY[ '3', '5' ];
	spNamen := ARRAY[
			'prj_projekte_id'
			, 'str_strkt_id_vorg'
			, 'str_strkt_id_nachf'
			, 'fbtor'
			, 'notizen'
			];


ELSE

	--
	-- Fehlermeldung. Es dürfen nur die im Schema >prj< verfügbaren Tabellennamen verwendet 
	-- werden
	--
	RAISE EXCEPTION 'prj.nimm__tabwerte(...)	Der übergebene Tabellenname  >tabname = %', 
		CASE WHEN( tabname IS NULL ) THEN 'NULL' ELSE tabname END
		 || '< ist nicht zulässig. Es dürfen nur die im Schema >prj< enthaltenen Tabellennamen verwendet werden. Das Einlesen wird abgebrochen !';

END IF;



--
-- 2.1)	Plausibilitätsprüfungen für alle Tabellen
--	- Listengröße
--
EXECUTE intern.pruefe__array( tabwerte, uGoG[1], uGoG[2]
				, 'prj.nimm__tabwerte(...)'
				, tabname || '.tabwerte' );

--
-- 2.2)	Plausibilitätsprüfungen für alle Tabellen außer >prj.projekte<
--	- tabwerte[1]
--	- tabwerte[2] (außer >prj.personen<)
--
IF(
	tabname != 'projekte'
  )
THEN

	--
	-- >tabwerte[1]< muß mindestens  >0< sein.
	--
	EXECUTE intern.pruefe__dt( 'gz', tabwerte[1], '0', NULL
					, 'prj.nimm__tabwerte(...)'
					, tabname || '.tabwerte[1]' );

	IF(
		tabname != 'personen'
	  )
	THEN

		--
		-- >tabwerte[2]< muß mindestens  >1< sein.
		--
		EXECUTE intern.pruefe__dt( 'gz', tabwerte[2], '1', NULL
						, 'prj.nimm__tabwerte(...)'
						, tabname || '.tabwerte[2]' );

	END IF;

END IF;


--
-- 2.3)	Bei allen Tabellen mit Logbuchfunktion, das Wiederverwenden von Zeilen mittels
--	expliziten Setzen von >logdatuhrz< deaktivieren
--
--	Bei der Übergabe von Werten, die unterhalb >logdatuhrz< liegen, wird >logdatuhrz<
--	automatisch ergänzt
--
--	ACHTUNG ! hier wird das veränderbare Array >tabwerteIntern< gesetzt
--

-- pl_prtdokdoku < 6
-- pl_prtpsgefszenario < 6
-- pl_psgefstrkt < 6
-- ppl_dokdoku < 6

-- pl_psgefabk < 7
-- pl_psgefanm < 7

-- pl_dokausgabe < 10


IF(
	( ( tabname= 'pl_prtpsgefszenario' OR tabname='pl_psgefstrkt' OR tabname='ppl_dokdoku' OR tabname='pl_prtdokdoku' ) AND ( tmpInteger < 6 ) )
	OR ( ( tabname='pl_psgefabk' OR tabname='pl_psgefanm' ) AND ( tmpInteger < 7 ) )
	OR ( ( tabname='pl_dokausgabe' ) AND ( tmpInteger < 10) )
  ) 
THEN
	--
	-- Spaltennamen und Wert ergänzen / >tmpInteger< hochzählen
	--
	tmpInteger := tmpInteger + 1;
	spNamen[tmpInteger] := 'logdatuhrz';
	tabwerteIntern := tabwerteIntern || CAST( timeofday() AS varchar );
END IF;


--
-- 3.)	Tabname einlesen
--		- >spNamen[1]< immer vorhanden
--		- >spNamen[2]< immer vorhanden
--		- >spNamen[3 ... 11]< ggf. vorhanden
--
--		- ab hier statt >tabwerte< das veränderbare Array >tabwerteIntern< verwenden
--
EXECUTE
	'SELECT intern.nimm__zeile( ''prj.' 
				|| CASE WHEN( tabname = 'pp_prtprotokoll_pers' ) 
					THEN 'pp_prtprotokoll' ELSE tabname END
				|| ''', ARRAY[ ''' || spNamen[1] || '''
				, ''' || spNamen[2] || ''''
				|| CASE WHEN( NOT( tmpInteger < 3 ) )
					THEN ', ''' || spNamen[3] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 4 ) )
					THEN ', ''' || spNamen[4] ||  '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 5 ) )
					THEN ', ''' || spNamen[5] ||  '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 6 ) )
					THEN ', ''' || spNamen[6] ||  '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 7 ) )
					THEN ', ''' || spNamen[7] ||  '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 8 ) )
					THEN ', ''' || spNamen[8] ||  '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 9 ) )
					THEN ', ''' || spNamen[9] ||  '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 10 ) )
					THEN ', ''' || spNamen[10] ||  '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 11 ) )
					THEN ', ''' || spNamen[11] ||  '''' ELSE '' END
				|| ']
			, ARRAY[''' 	|| tabwerteIntern[1] || '''
				, '''	|| tabwerteIntern[2] || ''''
				|| CASE WHEN( NOT( tmpInteger < 3 ) )
					THEN ', ''' || tabwerteIntern[3] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 4 ) )
					THEN ', ''' || tabwerteIntern[4] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 5 ) )
					THEN ', ''' || tabwerteIntern[5] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 6 ) )
					THEN ', ''' || tabwerteIntern[6] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 7 ) )
					THEN ', ''' || tabwerteIntern[7] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 8 ) )
					THEN ', ''' || tabwerteIntern[8] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 9 ) )
					THEN ', ''' || tabwerteIntern[9] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 10 ) )
					THEN ', ''' || tabwerteIntern[10] || '''' ELSE '' END
				|| CASE WHEN( NOT( tmpInteger < 11 ) )
					THEN ', ''' || tabwerteIntern[11] || '''' ELSE '' END
				|| '])'
INTO tabid;


END
$$LANGUAGE 'plpgsql'  VOLATILE;
SELECT intern.nimm__TLKommentarFunktion( 'prj.nimm__tabwerte( IN tabname varchar, IN tabwerte varchar[], OUT tabid varchar )',
ARRAY[
E'Name der Tabelle (ohne Schemanamen) des Schemas \\texttt{prj}, welche die Werte übernehmen soll  (Details siehe Funktionsbeschreibung --- Werteliste einlesen).'
, E'Liste der Werte, welche in die aktuelle Tabelle eingelesen werden sollen (Details siehe Funktionsbeschreibung --- Werteliste einlesen).'
, E'Es wird die Identifikationsnummer des aktuell eingelesenen Wertes \\texttt{prj.*.id} zurückgegeben.'
],
E'Mittels dieser Funktion werden in die Tabellen des Schemas \\texttt{prj} die Werte eingelesen.
\\\\
\\\\
Werteliste einlesen:\\\\
Dem Funktionsparameter \\texttt{tabwerte} ist eine Werteliste (\\texttt{ARRAY}) zu übergeben (die maximale Anzahl und die Reihenfolge der Werte ist fest vorgegeben --- siehe oben). Soll nur eine Teilmenge der Werte übergeben werden, dann sind alle Werte von links nach rechts zu spezifizieren (nichtbenötigte Werte am Ende der Liste dürfen weggelassen werden).
\\\\
\\\\
\\noindent \\textbf{personen}

\\begin{enumerate}
  \\item \\texttt{intern_firma_id}
  \\item \\texttt{name_n}
  \\item \\texttt{name_v}
  \\item \\texttt{notizen}
\\end{enumerate}
Es müssen mindestens die ersten drei Werte übergeben werden. Der erste Wert muß größer \\texttt{0} sein.
\\\\
\\\\
\\noindent \\textbf{projekte}

\\begin{enumerate}
  \\item \\texttt{prjname}
  \\item \\texttt{prjbeschr}
  \\item \\texttt{makefile}
  \\item \\texttt{notizen}
\\end{enumerate}
Es müssen mindestens die ersten beiden Werte übergeben werden.
\\\\
\\\\
\\textbf{p_dokstrkt, p_prtstrstrkt, p_prtverbindung, \\\\p_psabk, p_strverbindung}

\\begin{enumerate}
  \\item \\texttt{prj_projekte_id}
  \\item \\texttt{dok_doku_id, prt_protokoll_id, prt_protokoll_id_nachf, \\\\ps_abk_id, str_strkt_id_vorg}
  \\item \\texttt{dok_strkt_id, str_strkt_id, prt_protokoll_id_vorg, \\\\spr_uebvar_id, str_strkt_id_nachf}
  \\item \\texttt{notizen, notizen, notizen, \\\\spr_uebvar_id_l, fbtor}
  \\item \\texttt{---, ---, ---, \\\\spr_uebvar_id_zus, notizen}
  \\item \\texttt{---, ---, ---, \\\\notizen, ---}
\\end{enumerate}
Es müssen mindestens die ersten drei Werte übergeben werden. \\texttt{prj_projekte_id} darf \\texttt{0} sein, die anderen beiden Werte müssen größer \\texttt{0} sein.
\\\\
\\\\
\\noindent \\textbf{pl_dokausgabe, pl_prtdokdoku, pl_prtpsgefszenario, \\\\pl_psgefabk, pl_psgefanm, pl_psgefstrkt}

\\begin{enumerate}
  \\item \\texttt{prj_projekte_id}
  \\item \\texttt{dok_doku_id, dok_doku_id, ps_gefszenario_id, \\\\ps_gefszenario_id, ps_gefszenario_id, ps_gefszenario_id}
  \\item \\texttt{logentfernt, prt_protokoll_id, prt_protokoll_id, \\\\logentfernt, logentfernt, str_strkt_id}
  \\item \\texttt{nr, logentfernt, notizen, \\\\ps_abk_id, ps_anmerkung_id, notizen}
  \\item \\texttt{spr_uebvar_id, notizen, logentfernt, \\\\spr_uebvar_id_zus, spr_uebvar_id, logentfernt}
  \\item \\texttt{stand, logdatuhrz, logdatuhrz, \\\\notizen, notizen, logdatuhrz}
  \\item \\texttt{datum, logdquelle, logdquelle, \\\\logdatuhrz, logdatuhrz, logdquelle}
  \\item \\texttt{istfrei, logname, logname, \\\\logdquelle, logdquelle, logname}
  \\item \\texttt{notizen, logdqok, logdqok, \\\\logname, logname, logdqok}
  \\item \\texttt{logdatuhrz, ---, ---, \\\\logdqok, logdqok, ---}
  \\item \\texttt{logdquelle, ---, ---, \\\\---, ---, ---}
  \\item \\texttt{logname, ---, ---, \\\\---, ---, ---}
  \\item \\texttt{logdqok, ---, ---, \\\\---, ---, ---}
\\end{enumerate}
Es müssen mindestens die ersten beiden Werte übergeben werden. \\texttt{prj_projekte_id} darf \\texttt{0} sein, der andere Wert muß größer \\texttt{0} sein.
Bei diesen Tabellen (Tabellen mit Logbuchfunktion) wird nicht nach bereits eingelesenen Einträgen gesucht. Somit ist es möglich mehrfach dieselben Einträge einzulesen. 
\\\\
\\\\
\\noindent \\textbf{pp_prtprotokoll, pp_prtprotokoll_pers (beide z.Zt. inaktiv), pp_psgefszenario, \\\\ pp_strstrkt, ppl_dokdoku}

\\begin{enumerate}
  \\item \\texttt{prj_projekte_id}
  \\item \\texttt{prt_protokoll_id, prt_protokoll_id, ps_gefszenario_id, \\\\ str_strkt_id, dok_doku_id}
  \\item \\texttt{spr_uebvar_id, teilnehmer, prj_personen_id, \\\\ prj_personen_id, prj_personen_id}
  \\item \\texttt{datuhrz, prj_personen_id, spr_uebvar_id, \\\\ spr_uebvar_id, logentfernt}
  \\item \\texttt{intern, termin, spr_uebvar_id_reprgefszen, \\\\ spr_uebvar_id_zus, notizen} Für die Spalten \\texttt{spr_uebvar_id_fzg} und \\texttt{spr_uebvar_id} muß der Wert größer  \\texttt{0} sein.
  \\item \\texttt{erledigt, duanfrage, spr_uebvar_id_ursp, \\\\ fbereignis, logdatuhrz}
  \\item \\texttt{notizen, notizen, notizen, \\\\ notizen, logdquelle}
  \\item \\texttt{---, ---, ---, \\\\ ---, logname }
  \\item \\texttt{---, ---, ---, \\\\ ---, logdqok }
\\end{enumerate}
Bei den Tabellen \\texttt{ppl_dokdoku} müssen die ersten drei und bei den Tabellen \\texttt{pp_psgefszenario, pp_strstrkt} die ersten zwei Werte übergeben werden. \\texttt{prj_projekte_id} darf \\texttt{0} sein, die anderen Drei bzw. Zwei Werte müssen größer \\texttt{0} sein.
\\\\
Bei der Tabelle \\texttt{pl_prtdokdoku} müssen die ersten drei Werte übergeben werden.
\\\\
\\\\
Die Tabelle \\texttt{pp_prtprotokoll} deckt drei Aspekte ab:
\\begin{enumerate}
  \\item Protokolleintrag einem Projekt zuordnen, projektspezifisch modifizieren und Randbedingungen setzen (\\texttt{pp_prtprotokoll} wählen);
  \\item dem Protokolleintrag die beteiligten Personen zuordnen (\\texttt{pp_prtprotokoll_pers} wählen);
  \\item dem Protokolleintrag der eine Frage / Aufgabe ist, die relevanten Informationen zuordnen (\\texttt{pp_prtprotokoll_pers} wählen);
\\end{enumerate}
wobei ein Protokolleintrag ein Gefahrenprotokolleintrag, eine Sicherheitsüberprüfung oder ein Terminplaneintrag (je nach Sinnfälligkeit) sein kann.
\\\\
Zur Unterscheidung der drei Aspekte werden die Spalten \\texttt{prj_personen_id} und \\texttt{teilnehmer} verwendet. Es gilt für
\\begin{enumerate}
  \\item \\texttt{prj_personen_id = 0} und \\texttt{teilnehmer = NULL}
  \\item \\texttt{prj_personen_id > 0} und \\texttt{teilnehmer = true}
  \\item \\texttt{prj_personen_id > 0} und \\texttt{teilnehmer = false}
\\end{enumerate}
Die Spalten der Tabelle \\texttt{pp_prtprotokoll} werden zur Abbildung der drei Aspekte wie folgt verwendet:  \\\\
 \\texttt{notizen ........... 1} \\\\
 \\texttt{datuhrz ........... 1} \\\\
 \\texttt{duanfrage ............. 3} \\\\
 \\texttt{erledigt .......... 1} \\\\
 \\texttt{intern ............ 1} \\\\
 \\texttt{prj_personen_id ..... 2 3} \\\\
 \\texttt{prj_projekte_id ... 1 2 3} \\\\
 \\texttt{prt_protokoll_id .. 1 2 3} \\\\
 \\texttt{spr_uebvar_id ..... 1} \\\\
 \\texttt{teilnehmer .......... 2 3} \\\\
 \\texttt{termin ................ 3}
'
, ARRAY[
E'ACTUNG ! Die Beispiele sind nicht aktualisiert --- muß später bereinit werden.'
, E'-- Fehlermeldung. Ungültige Tabelle !\\\\SELECT * FROM prj.nimm__tabwerte( NULL, NULL );'
, E'-- Fehlermeldung. Bei allen Tabellen müssen mindestens zwei Elemente übergeben werden\\\\SELECT * FROM prj.nimm__tabwerte( ''projekte'', ARRAY[''1''] );'
, E'-- Fehlermeldung. Die übergebenen Parameter müssen größer \\texttt{0} sein.\\\\SELECT * FROM prj.nimm__tabwerte( ''p_dokkomp'', ARRAY[''0'', ''1''] );\\\\SELECT * FROM prj.nimm__tabwerte( ''p_dokkomp'', ARRAY[''1'', ''0''] );\\\\SELECT * FROM prj.nimm__tabwerte( ''pl_psgefanm'', ARRAY[''1'', ''1'', ''0''] );\\\\SELECT * FROM prj.nimm__tabwerte( ''ppu_kmpkomp'', ARRAY[''1'', ''1'', ''1'', '''', ''0''] );\\\\SELECT * FROM prj.nimm__tabwerte( ''pp_prtprotokoll'', ARRAY[''1'', ''1'', ''1'', '''', '''', '''', '''', '''', '''', ''0''] );'
, E'-- Fehlermeldung. Es dürfen nur die zulässigen Begriffe verwendet werden\\\\SELECT * FROM prj.nimm__tabwerte( ''pp_strstrkt'', ARRAY[''1'', ''22'', ''1'', ''99'', ''ttt''] );\\\\SELECT * FROM prj.nimm__tabwerte( ''p_strverbindung'', ARRAY[''1'', ''1'', ''ttt''] );'

, E'-- \\texttt{prj.projekte} einlesen\\\\SELECT * FROM prj.projekte;\\\\SELECT * FROM prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt'', ''Inhalt des makefile'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.projekte;'
, E'-- \\texttt{dok.*} einlesen\\\\SELECT * FROM prj.pp_dokausgabe;\\\\SELECT * FROM prj.nimm__tabwerte( ''pp_dokausgabe'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), dok.nimm__tabwerte( ''ausgabe'', ARRAY[ dok.nimm__doku( ARRAY[''08-15'', ''1''] ), ''01''] ), prj.nimm__tabwerte( ''personen'', ARRAY[''1'', ''Bellair'', ''Michael''] ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pp_dokausgabe;\\\\SELECT * FROM prj.p_dokkomp;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_dokkomp'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), dok.nimm__tabwerte( ''komp'', ARRAY[dok.nimm__doku( ARRAY[''08-15'', ''1''] ), kmp.nimm__komp( ARRAY[''1'', ''47/11''] )] ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_dokkomp;\\\\SELECT * FROM prj.p_dokstrkt;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_dokstrkt'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), dok.nimm__tabwerte( ''strkt'', ARRAY[dok.nimm__doku( ARRAY[''08-15'', ''1''] ), str.nimm__strkt( ARRAY[''1'', ''-BAAA'', spr.nimm__wgruppe( ''Strukturpunkt'', ''1'', ''0'' )] )] ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_dokstrkt;'
, E'-- \\texttt{kmp.*} einlesen\\\\SELECT * FROM prj.ppu_kmpkomp;\\\\SELECT * FROM prj.nimm__tabwerte( ''ppu_kmpkomp'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), kmp.nimm__komp( ARRAY[''1'', ''08-15''] ), prj.nimm__tabwerte( ''personen'', ARRAY[''1'', ''Bellair'', ''Michael''] ), ''kmp-id-fzg'', spr.nimm__wgruppe( ''Komponentenbezeichnung-Fahrezeughersteller'', ''1'', ''0'' ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.ppu_kmpkomp;\\\\SELECT * FROM prj.p_kmpstrkt;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_kmpstrkt'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), kmp.nimm__strkt( ARRAY[kmp.nimm__komp( ARRAY[''1'', ''08-15''] ), str.nimm__strkt( ARRAY[''1'', ''-BAAA'', spr.nimm__wgruppe( ''Strukturpunkt'', ''1'', ''0'' )] ), ''Zusatzinformationen''] ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_kmpstrkt;'
, E'-- \\texttt{prt.*} einlesen\\\\SELECT * FROM prj.p_prtdokausgabe;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_prtdokausgabe'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), prt.nimm__tabwerte( ''dokausgabe'', ARRAY[prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( ''Aktueller Protokolleintrag.'', ''1'', ''0'' ), ''PE_OK''] ), dok.nimm__tabwerte( ''ausgabe'', ARRAY[ dok.nimm__doku( ARRAY[''08-15'', ''1''] ), ''01''] ), ''Zusatzinformationen''] ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_prtdokausgabe;\\\\SELECT * FROM prj.p_prtkomp;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_prtkomp'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), prt.nimm__tabwerte( ''komp'', ARRAY[prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( ''Aktueller Protokolleintrag.'', ''1'', ''0'' ), ''PE_OK''] ), kmp.nimm__komp( ARRAY[''1'', ''47/11''] )] ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_prtkomp;\\\\SELECT * FROM prj.pp_prtprotokoll;\\\\SELECT * FROM prj.nimm__tabwerte( ''pp_prtprotokoll'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( ''Aktueller Protokolleintrag.'', ''1'', ''0'' ), ''PE_OK''] ), prj.nimm__tabwerte( ''personen'', ARRAY[''1'', ''Bellair'', ''Michael''] ), ''true'', ''2007-06-08'', ''2007-06-20'', ''2007-07-07'', ''true'', ''true'', spr.nimm__wgruppe( ''Projektabhängiger, aktueller Protokolleintrag.'', ''1'', ''0'' ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pp_prtprotokoll;\\\\SELECT * FROM prj.p_prtstrstrkt;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_prtstrstrkt'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), prt.nimm__tabwerte( ''strkt'', ARRAY[prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( ''Aktueller Protokolleintrag.'', ''1'', ''0'' ), ''PE_OK''] ), str.nimm__strkt( ARRAY[''1'', ''-BAAA'', spr.nimm__wgruppe( ''Strukturpunkt'', ''1'', ''0'' )])]), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_prtstrstrkt;\\\\SELECT * FROM prj.p_prtverbindung;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_prtverbindung'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), prt.nimm__tabwerte( ''verbindung'', ARRAY[prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( ''Aktueller Protokolleintrag.'', ''1'', ''0'' ), ''PE_OK''] ), prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( ''Zugeordneter Aktueller Protokolleintrag.'', ''1'', ''0'' ), ''PE_OK''] )]), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_prtverbindung;'
, E'-- \\texttt{ps.*} einlesen\\\\SELECT * FROM prj.p_psabk;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_psabk'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), ps.nimm__abk( ARRAY[spr.nimm__wgruppe( ''abk'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Abkürzung'', ''1'', ''0'' ), ''BP''] ), spr.nimm__wgruppe( ''projabk'', ''1'', ''0'' ), spr.nimm__wgruppe( ''projektabhängige Abkürzung'', ''1'', ''0'' ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_psabk;\\\\SELECT * FROM prj.pl_psgefabk;\\\\SELECT * FROM prj.nimm__tabwerte( ''pl_psgefabk'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), ps.nimm__aspekte( ''gefabk'', ARRAY[ ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( ''Gefahrenszenario'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Ursprung des Gefahrenszenarios'', ''1'', ''0'' )] ), ps.nimm__abk( ARRAY[spr.nimm__wgruppe( ''abk'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Abkürzung'', ''1'', ''0'' ), ''BP''] )] ), ''2007-06-06'', ''datenquelle'', ''micha'', ''true'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pl_psgefabk;\\\\SELECT * FROM prj.pl_psgefanm;\\\\SELECT * FROM prj.nimm__tabwerte( ''pl_psgefanm'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ),  ps.nimm__aspekte( ''gefanm'', ARRAY[ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( ''Gefahrenszenario'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Ursprung des Gefahrenszenarios'', ''1'', ''0'' )] ), spr.nimm__wgruppe( ''Anmerkungen'', ''1'', ''0'' )] ), spr.nimm__wgruppe( ''projektspezifische Anmerkungen'', ''1'', ''0'' ), ''true'', ''2007-06-06'', ''datenquelle'', ''micha'', ''true'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pl_psgefanm;\\\\SELECT * FROM prj.pl_psgefkomp;\\\\SELECT * FROM prj.nimm__tabwerte( ''pl_psgefkomp'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), ps.nimm__aspekte( ''gefkomp'', ARRAY[ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( ''Gefahrenszenario'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Ursprung des Gefahrenszenarios'', ''1'', ''0'' )] ), kmp.nimm__komp( ARRAY[''1'',''08-15''] )] ), ''2007-06-06'', ''datenquelle'', ''micha'', ''true'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pl_psgefkomp;\\\\SELECT * FROM prj.pl_psgefnetz;\\\\SELECT * FROM prj.nimm__tabwerte( ''pl_psgefnetz'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ),  ps.nimm__aspekte( ''gefnetz'', ARRAY[ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( ''Gefahrenszenario'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Ursprung des Gefahrenszenarios'', ''1'', ''0'' )]), str.nimm__strkt( ARRAY[''1'', ''-BAAA'', spr.nimm__wgruppe( ''Strukturpunkt'', ''1'', ''0'' )])] ), ''2007-06-06'', ''datenquelle'', ''micha'', ''true'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pl_psgefnetz;\\\\SELECT * FROM prj.pl_prtpsgefszenario;\\\\SELECT * FROM prj.nimm__tabwerte( ''pl_prtpsgefszenario'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), ps.nimm__aspekte( ''gefprot'', ARRAY[ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( ''Gefahrenszenario'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Ursprung des Gefahrenszenarios'', ''1'', ''0'' )]), prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( ''Zugeordneter Aktueller Protokolleintrag.'', ''1'', ''0'' ), ''PE_OK''] )] ), ''true'', ''2007-06-06'', ''datenquelle'', ''micha'', ''true'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pl_prtpsgefszenario;\\\\SELECT * FROM prj.pl_psgefstrkt;\\\\SELECT * FROM prj.nimm__tabwerte( ''pl_psgefstrkt'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), ps.nimm__aspekte( ''gefstrkt'', ARRAY[ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( ''Gefahrenszenario'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Ursprung des Gefahrenszenarios'', ''1'', ''0'' )]), str.nimm__strkt( ARRAY[''1'', ''-BAAA'', spr.nimm__wgruppe( ''Strukturpunkt'', ''1'', ''0'' )])] ), ''true'', ''2007-06-06'', ''datenquelle'', ''micha'', ''true'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pl_psgefstrkt;\\\\SELECT * FROM prj.pp_psgefszenario;\\\\SELECT * FROM prj.nimm__tabwerte( ''pp_psgefszenario'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( ''Gefahrenszenario'', ''1'', ''0'' ), spr.nimm__wgruppe( ''Ursprung des Gefahrenszenarios'', ''1'', ''0'' )]), prj.nimm__tabwerte( ''personen'', ARRAY[''1'', ''Bellair'', ''Michael''] ), spr.nimm__wgruppe( ''projektspezifisch formuliertes Gefahrenszenario'', ''1'', ''0'' ), spr.nimm__wgruppe( ''projektspezifisch formulierter Ursprung des Gefahrenszenarios'', ''1'', ''0'' ), ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pp_psgefszenario;'
, E'-- \\texttt{str.*} einlesen\\\\SELECT * FROM prj.pp_strstrkt;\\\\SELECT * FROM prj.nimm__tabwerte( ''pp_strstrkt'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), str.nimm__strkt( ARRAY[''1'', ''-BAAA'', spr.nimm__wgruppe( ''Strukturpunkt'', ''1'', ''0'' )]), prj.nimm__tabwerte( ''personen'', ARRAY[''1'', ''Bellair'', ''Michael''] ), spr.nimm__wgruppe( ''Strukturpunkt übersetzt ?'', ''1'', ''0'' ), ''HAUS'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.pp_strstrkt;\\\\SELECT * FROM prj.p_strverbindung;\\\\SELECT * FROM prj.nimm__tabwerte( ''p_strverbindung'', ARRAY[prj.nimm__tabwerte( ''projekte'', ARRAY[''testProj'', ''Testprojekt''] ), str.nimm__verbindung( ARRAY[str.nimm__strkt( ARRAY[''1'', ''-BAAA1'', spr.nimm__wgruppe( ''Strukturpunkt-1'', ''1'', ''0'' )]), str.nimm__strkt( ARRAY[''1'', ''-BAAA2'', spr.nimm__wgruppe( ''Strukturpunkt-2'', ''1'', ''0'' )])] ), ''UND'', ''Zusatzinformationen''] );\\\\SELECT * FROM prj.p_strverbindung;'
]
);
--
-- Fehlermeldungen
-- ...............
--
--
--	-- Fehlermeldung. Ungültige Tabelle !
--SELECT * FROM prj.nimm__tabwerte( NULL, NULL );
--
--	-- Fehlermeldung. Bei allen Tabellen müssen mindestens zwei Elemente übergeben werden
--SELECT * FROM prj.nimm__tabwerte( 'projekte', ARRAY['1'] );
--
--	-- Fehlermeldung. Die übergebenen Parameter müssen größer \\texttt{0} sein.
--SELECT * FROM prj.nimm__tabwerte( 'p_dokkomp', ARRAY['0', '1'] );
--SELECT * FROM prj.nimm__tabwerte( 'p_dokkomp', ARRAY['1', '0'] );
--SELECT * FROM prj.nimm__tabwerte( 'pl_psgefanm', ARRAY['1', '1', '0'] );
--SELECT * FROM prj.nimm__tabwerte( 'pp_prtprotokoll', ARRAY['1', '1', '1', '', '', '', '', '', '', '0'] );
--
--	-- Fehlermeldung. Es dürfen nur die zulässigen Begriffe verwendet werden
--SELECT * FROM prj.nimm__tabwerte( 'pp_strstrkt', ARRAY['1', '22', '1', '99', 'ttt'] );
--SELECT * FROM prj.nimm__tabwerte( 'p_strverbindung', ARRAY['1', '1', 'ttt'] );
--
--
--
--
-- Standardverhalten:
-- ..................
--
--	-- \\texttt{prj.personen} einlesen
--SELECT * FROM prj.personen;
--SELECT * FROM prj.nimm__tabwerte( 'personen', ARRAY['1', 'Bellair', 'Auguste', 'Zusatzinformationen'] );
--SELECT * FROM prj.personen;
--
--
--	-- \\texttt{prj.projekte} einlesen
--SELECT * FROM prj.projekte;
--SELECT * FROM prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt', 'Inhalt des makefile', 'Zusatzinformationen'] );
--SELECT * FROM prj.projekte;
--
--
--
--	-- \\texttt{dok.*} einlesen
--SELECT * FROM prj.pp_dokausgabe;
--SELECT * FROM prj.nimm__tabwerte( 'pp_dokausgabe', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, dok.nimm__tabwerte( 'ausgabe', ARRAY[ dok.nimm__doku( ARRAY['08-15', '1'] ), '01'] )
--	, prj.nimm__tabwerte( 'personen', ARRAY['1', 'Bellair', 'Michael'] )
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.pp_dokausgabe;
--
--SELECT * FROM prj.p_dokkomp;
--SELECT * FROM prj.nimm__tabwerte( 'p_dokkomp', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, dok.nimm__tabwerte( 'komp', ARRAY[dok.nimm__doku( ARRAY['08-15', '1'] )
--					, kmp.nimm__komp( ARRAY['1', '47/11'] )] )
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.p_dokkomp;
--
--SELECT * FROM prj.p_dokstrkt;
--SELECT * FROM prj.nimm__tabwerte( 'p_dokstrkt', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, dok.nimm__tabwerte( 'strkt', ARRAY[dok.nimm__doku( ARRAY['08-15', '1'] )
--					, str.nimm__strkt( ARRAY['1', '-BAAA', spr.nimm__wgruppe( 'Strukturpunkt', '1', '0' )] )] )
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.p_dokstrkt;
--
--
--	-- \\texttt{prt.*} einlesen
--SELECT * FROM prj.p_prtdokausgabe;
--SELECT * FROM prj.nimm__tabwerte( 'p_prtdokausgabe', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, prt.nimm__tabwerte( 'dokausgabe', ARRAY[prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( 'Aktueller Protokolleintrag.', '1', '0' ), 'PE_OK'] ), dok.nimm__tabwerte( 'ausgabe', ARRAY[ dok.nimm__doku( ARRAY['08-15', '1'] ), '01'] ), 'Zusatzinformationen'] )
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.p_prtdokausgabe;
--
--SELECT * FROM prj.p_prtkomp;
--SELECT * FROM prj.nimm__tabwerte( 'p_prtkomp', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, prt.nimm__tabwerte( 'komp', ARRAY[prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( 'Aktueller Protokolleintrag.', '1', '0' ), 'PE_OK'] ), kmp.nimm__komp( ARRAY['1', '47/11'] )] )
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.p_prtkomp;
--
--SELECT * FROM prj.pp_prtprotokoll;
--SELECT * FROM prj.nimm__tabwerte( 'pp_prtprotokoll', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( 'Aktueller Protokolleintrag.', '1', '0' ), 'PE_OK'] )
--	, prj.nimm__tabwerte( 'personen', ARRAY['1', 'Bellair', 'Michael'] )
--	, 'true'
--	, '2007-06-08'
--	, '2007-06-20'
--	, '2007-07-07'
--	, 'true'
--	, 'true'
--	, spr.nimm__wgruppe( 'Projektabhängiger, aktueller Protokolleintrag.', '1', '0' )
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.pp_prtprotokoll;
--
--SELECT * FROM prj.nimm__tabwerte( 'pp_prtprotokoll', ARRAY['2', '1'] );
--SELECT * FROM prj.nimm__tabwerte( 'pp_prtprotokoll', ARRAY['1', '1', '0', '2008-12-18', 'false', 'true', 'Interne Notizen'] );
--SELECT * FROM prj.nimm__tabwerte( 'pp_prtprotokoll_pers', ARRAY['1', '1', 'false', '1', '2008-12-18', '2008-12-18', 'Interne Notizen'] );
--
--SELECT * FROM prj.p_prtstrstrkt;
--SELECT * FROM prj.nimm__tabwerte( 'p_prtstrstrkt', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, prt.nimm__tabwerte( 'strkt', ARRAY[prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( 'Aktueller Protokolleintrag.', '1', '0' ), 'PE_OK'] ), str.nimm__strkt( ARRAY['1', '-BAAA', spr.nimm__wgruppe( 'Strukturpunkt', '1', '0' )])])
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.p_prtstrstrkt;
--
--SELECT * FROM prj.p_prtverbindung;
--SELECT * FROM prj.nimm__tabwerte( 'p_prtverbindung', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, prt.nimm__tabwerte( 'verbindung', ARRAY[prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( 'Aktueller Protokolleintrag.', '1', '0' ), 'PE_OK'] ), prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( 'Zugeordneter Aktueller Protokolleintrag.', '1', '0' ), 'PE_OK'] )])
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.p_prtverbindung;
--
--
--	-- \\texttt{ps.*} einlesen
--SELECT * FROM prj.p_psabk;
--SELECT * FROM prj.nimm__tabwerte( 'p_psabk', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, ps.nimm__abk( ARRAY[spr.nimm__wgruppe( 'abk', '1', '0' ), spr.nimm__wgruppe( 'Abkürzung', '1', '0' ), 'BP'] )
--	, spr.nimm__wgruppe( 'projabk', '1', '0' )
--	, spr.nimm__wgruppe( 'projektabhängige Abkürzung', '1', '0' )
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.p_psabk;
--
--SELECT * FROM prj.pl_psgefabk;
--SELECT * FROM prj.nimm__tabwerte( 'pl_psgefabk', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, ps.nimm__aspekte( 'gefabk', ARRAY[ ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( 'Gefahrenszenario', '1', '0' ), spr.nimm__wgruppe( 'Ursprung des Gefahrenszenarios', '1', '0' )] ), ps.nimm__abk( ARRAY[spr.nimm__wgruppe( 'abk', '1', '0' ), spr.nimm__wgruppe( 'Abkürzung', '1', '0' ), 'BP'] )] )
--	, 'true'
--	, '2007-06-06'
--	, 'datenquelle'
--	, 'micha'
--	, 'true'
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.pl_psgefabk;
--
--SELECT * FROM prj.pl_psgefanm;
--SELECT * FROM prj.nimm__tabwerte( 'pl_psgefanm', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	,  ps.nimm__aspekte( 'gefanm', ARRAY[ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( 'Gefahrenszenario', '1', '0' ), spr.nimm__wgruppe( 'Ursprung des Gefahrenszenarios', '1', '0' )] ), spr.nimm__wgruppe( 'Anmerkungen', '1', '0' )] )
--	, spr.nimm__wgruppe( 'projektspezifische Anmerkungen', '1', '0' )
--	, 'true'
--	, '2007-06-06'
--	, 'datenquelle'
--	, 'micha'
--	, 'true'
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.pl_psgefanm;
--
--SELECT * FROM prj.pl_prtpsgefszenario;
--SELECT * FROM prj.nimm__tabwerte( 'pl_prtpsgefszenario', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, ps.nimm__aspekte( 'gefprot', ARRAY[ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( 'Gefahrenszenario', '1', '0' ), spr.nimm__wgruppe( 'Ursprung des Gefahrenszenarios', '1', '0' )]), prt.nimm__protokolleintrag( ARRAY[spr.nimm__wgruppe( 'Zugeordneter Aktueller Protokolleintrag.', '1', '0' ), 'PE_OK'] )] )
--	, 'true'
--	, '2007-06-06'
--	, 'datenquelle'
--	, 'micha'
--	, 'true'
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.pl_prtpsgefszenario;
--
--SELECT * FROM prj.pl_psgefstrkt;
--SELECT * FROM prj.nimm__tabwerte( 'pl_psgefstrkt', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, ps.nimm__aspekte( 'gefstrkt', ARRAY[ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( 'Gefahrenszenario', '1', '0' ), spr.nimm__wgruppe( 'Ursprung des Gefahrenszenarios', '1', '0' )]), str.nimm__strkt( ARRAY['1', '-BAAA', spr.nimm__wgruppe( 'Strukturpunkt', '1', '0' )])] )
--	, 'true'
--	, '2007-06-06'
--	, 'datenquelle'
--	, 'micha'
--	, 'true'
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.pl_psgefstrkt;
--
--SELECT * FROM prj.pp_psgefszenario;
--SELECT * FROM prj.nimm__tabwerte( 'pp_psgefszenario', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, ps.nimm__gefszenario( ARRAY[spr.nimm__wgruppe( 'Gefahrenszenario', '1', '0' ), spr.nimm__wgruppe( 'Ursprung des Gefahrenszenarios', '1', '0' )])
--	, prj.nimm__tabwerte( 'personen', ARRAY['1', 'Bellair', 'Michael'] )
--	, spr.nimm__wgruppe( 'projektspezifisch formuliertes Gefahrenszenario', '1', '0' )
--	, spr.nimm__wgruppe( 'projektspezifisch formulierter Ursprung des Gefahrenszenarios', '1', '0' )
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.pp_psgefszenario;
--
--
--	-- \\texttt{str.*} einlesen
--SELECT * FROM prj.pp_strstrkt;
--SELECT * FROM prj.nimm__tabwerte( 'pp_strstrkt', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, str.nimm__strkt( ARRAY['1', '-BAAA', spr.nimm__wgruppe( 'Strukturpunkt', '1', '0' )])
--	, prj.nimm__tabwerte( 'personen', ARRAY['1', 'Bellair', 'Michael'] )
--	, spr.nimm__wgruppe( 'Strukturpunkt übersetzt ?', '1', '0' )
--	, 'HAUS'
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.pp_strstrkt;
--
--SELECT * FROM prj.p_strverbindung;
--SELECT * FROM prj.nimm__tabwerte( 'p_strverbindung', ARRAY[
--	prj.nimm__tabwerte( 'projekte', ARRAY['testProj', 'Testprojekt'] )
--	, str.nimm__verbindung( ARRAY[str.nimm__strkt( ARRAY['1', '-BAAA1', spr.nimm__wgruppe( 'Strukturpunkt-1', '1', '0' )]), str.nimm__strkt( ARRAY['1', '-BAAA2', spr.nimm__wgruppe( 'Strukturpunkt-2', '1', '0' )])] )
--	, 'UND'
--	, 'Zusatzinformationen'] );
--SELECT * FROM prj.p_strverbindung;
--



--
-- --	>prj.zeige__pl_prtdokdoku_le< aktualisieren	----------------------------------
--
CREATE OR REPLACE VIEW prj.zeige__pl_prtdokdoku_le
AS
  SELECT
	dokdoku.id AS prj__pl_prtdokdoku__id
	--
	-- Kontrolle
	--
--	, dokdoku.dok_doku_id
--	, dokdoku.prj_projekte_id
--	, dokdoku.prt_protokoll_id
--	, dokdoku.logdatuhrz
--	, dokdoku.logentfernt
  FROM
	prj.pl_prtdokdoku
		LEFT OUTER JOIN prj.pl_prtdokdoku AS dokdoku
			ON (
				prj.pl_prtdokdoku.dok_doku_id = dokdoku.dok_doku_id
			   AND
				prj.pl_prtdokdoku.prj_projekte_id = dokdoku.prj_projekte_id
			   AND
				prj.pl_prtdokdoku.prt_protokoll_id = dokdoku.prt_protokoll_id
			   AND
				prj.pl_prtdokdoku.idfrei = 0
			   AND
				dokdoku.idfrei = 0
			)
  GROUP BY
	  dokdoku.id
	, dokdoku.logdatuhrz
	--
	-- Kontrolle
	--
--	, dokdoku.dok_doku_id
--	, dokdoku.prj_projekte_id
--	, dokdoku.prt_protokoll_id
--	, dokdoku.logentfernt
  HAVING
	--
	-- Abfrage auf letzte Änderung beschränken 
	--
	max( prj.pl_prtdokdoku.logdatuhrz ) = dokdoku.logdatuhrz
  ORDER BY
	dokdoku.id
	--
	-- Kontrolle
	--
--	, dokdoku.prt_protokoll_id
--	, dokdoku.prj_projekte_id
--	, dokdoku.dok_doku_id
;
SELECT intern.nimm__TLKommentarSicht( 'prj.zeige__pl_prtdokdoku_le'
, ARRAY[
   'prj__pl_prtdokdoku__id'
] 
, ARRAY[
   E'siehe \\texttt{prj.pl_prtdokdoku.id}'
], 
E'Zu jeder Sicherheitsanforderung, Protokolleintrag, Terminplaneintrag (siehe Tabelle \\texttt{prt.protokoll}) werden unter Berücksichtigung  des Projektes \\texttt{prj.pl_prtdokdoku.id} die zugeordneten Dokumente (siehe \\texttt{dok.doku})  angezeigt (Logbuchfunktion).' );
--
-- Standardverhalten:
-- ..................
--
--SELECT * FROM prj.zeige__pl_prtdokdoku_le;




--
-- --	>prj.pl_prtdokdoku< Spalten entfernen	------------------------------------------
--


ALTER TABLE prj.pl_prtdokdoku DROP COLUMN nr;
ALTER TABLE prj.pl_prtdokdoku DROP COLUMN spr_uebvar_id;
ALTER TABLE prj.pl_prtdokdoku DROP COLUMN spr_uebvar_id_zus;

ALTER TABLE prj.pl_prtdokdoku ADD CONSTRAINT uc__prj_pl_prtdokdoku UNIQUE(idfrei, logentfernt, logdatuhrz, dok_doku_id, prj_projekte_id, prt_protokoll_id );






--
-- --	Fehler beseitigen	----------------------------------------------------------
--
ALTER TABLE prj.pl_dokausgabe ADD CONSTRAINT fk__prj_pl_dokausgabe__dok_doku_id FOREIGN KEY ( dok_doku_id ) REFERENCES dok.doku ( id );
